/* Generated by wayland-scanner 1.23.0 */

#ifndef AURA_OUTPUT_MANAGEMENT_CLIENT_PROTOCOL_H
#define AURA_OUTPUT_MANAGEMENT_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_aura_output_management The aura_output_management protocol
 * @section page_ifaces_aura_output_management Interfaces
 * - @subpage page_iface_zaura_output_manager_v2 - aura output manager singleton
 * @section page_copyright_aura_output_management Copyright
 * <pre>
 *
 * Copyright 2024 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct zaura_output_manager_v2;

#ifndef ZAURA_OUTPUT_MANAGER_V2_INTERFACE
#define ZAURA_OUTPUT_MANAGER_V2_INTERFACE
/**
 * @page page_iface_zaura_output_manager_v2 zaura_output_manager_v2
 * @section page_iface_zaura_output_manager_v2_desc Description
 *
 * A global responsible for propagating atomic output configuration changes
 * to clients. An output configuration is a union of added / removed outputs
 * and updated output metrics.
 *
 * Added outputs arrive at the client as wl_registry.global events, removed
 * outputs as wl_registry.global_remove events and updated output metrics as
 * a sequence of events defined on the zaura_output_manager_v2 interface.
 * This is followed by the manager's done event which signals the end of the
 * transaction.
 *
 * The change should be processed by clients in a way that transitions from
 * one output configuration state to another without exposing the
 * intermediate output state to the rest of the application.
 *
 * Participating servers should emit the zaura_output_manager_v2 global
 * before any wl_output globals in the sequence of wl_registry.global events.
 *
 * Participating clients should bind the zaura_output_manager_v2 before any
 * wl_output globals. This ordering is required to ensure clients receive all
 * necessary output configuration information before receiving any further
 * server events that may reference bound wl_outputs.
 *
 * Clients can expect that all events comprising a configuration change are
 * sent synchronously, one after the other, before any other server events
 * that leverage the output as an event param.
 * @section page_iface_zaura_output_manager_v2_api API
 * See @ref iface_zaura_output_manager_v2.
 */
/**
 * @defgroup iface_zaura_output_manager_v2 The zaura_output_manager_v2 interface
 *
 * A global responsible for propagating atomic output configuration changes
 * to clients. An output configuration is a union of added / removed outputs
 * and updated output metrics.
 *
 * Added outputs arrive at the client as wl_registry.global events, removed
 * outputs as wl_registry.global_remove events and updated output metrics as
 * a sequence of events defined on the zaura_output_manager_v2 interface.
 * This is followed by the manager's done event which signals the end of the
 * transaction.
 *
 * The change should be processed by clients in a way that transitions from
 * one output configuration state to another without exposing the
 * intermediate output state to the rest of the application.
 *
 * Participating servers should emit the zaura_output_manager_v2 global
 * before any wl_output globals in the sequence of wl_registry.global events.
 *
 * Participating clients should bind the zaura_output_manager_v2 before any
 * wl_output globals. This ordering is required to ensure clients receive all
 * necessary output configuration information before receiving any further
 * server events that may reference bound wl_outputs.
 *
 * Clients can expect that all events comprising a configuration change are
 * sent synchronously, one after the other, before any other server events
 * that leverage the output as an event param.
 */
extern const struct wl_interface zaura_output_manager_v2_interface;
#endif

/**
 * @ingroup iface_zaura_output_manager_v2
 * @struct zaura_output_manager_v2_listener
 */
struct zaura_output_manager_v2_listener {
	/**
	 * sent all information about the output configuration change
	 *
	 * This event is sent after all added, changed and removed output
	 * events for a given wl_output have been dispatched to the client.
	 */
	void (*done)(void *data,
		     struct zaura_output_manager_v2 *zaura_output_manager_v2);
	/**
	 * advertise the output's display id
	 *
	 * This event describes the 64bit display id assigned to each
	 * display by ChromeOS. The value is opaque and should not be
	 * interpreted.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 */
	void (*display_id)(void *data,
			   struct zaura_output_manager_v2 *zaura_output_manager_v2,
			   uint32_t output_name,
			   uint32_t display_id_hi,
			   uint32_t display_id_lo);
	/**
	 * position of the output within the global compositor space
	 *
	 * The position event describes the location of the wl_output
	 * within the global compositor space.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param x x position within the global compositor space
	 * @param y y position within the global compositor space
	 */
	void (*logical_position)(void *data,
				 struct zaura_output_manager_v2 *zaura_output_manager_v2,
				 uint32_t output_name,
				 int32_t x,
				 int32_t y);
	/**
	 * size of the output in the global compositor space
	 *
	 * The logical_size event describes the logical size of the
	 * output in the global compositor space.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param width width in global compositor space
	 * @param height height in global compositor space
	 */
	void (*logical_size)(void *data,
			     struct zaura_output_manager_v2 *zaura_output_manager_v2,
			     uint32_t output_name,
			     int32_t width,
			     int32_t height);
	/**
	 * size of the output in pixels
	 *
	 * The physical resolution of the display in pixels. The value
	 * should not include any overscan insets or display rotation,
	 * except for any panel orientation adjustment.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param width width in global compositor space
	 * @param height height in global compositor space
	 */
	void (*physical_size)(void *data,
			      struct zaura_output_manager_v2 *zaura_output_manager_v2,
			      uint32_t output_name,
			      int32_t width,
			      int32_t height);
	/**
	 * advertise the work area insets for the output
	 *
	 * This event describes the work area insets for the output in
	 * logical screen coordinates, from which the work area can be
	 * calculated.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 */
	void (*work_area_insets)(void *data,
				 struct zaura_output_manager_v2 *zaura_output_manager_v2,
				 uint32_t output_name,
				 int32_t top,
				 int32_t left,
				 int32_t bottom,
				 int32_t right);
	/**
	 * advertise device scale factor for the output
	 *
	 * The scale factor of the output device. We reinterpret_cast the
	 * float scale factor into a 32-bit uint and later cast back into a
	 * float. This is because wayland does not support native transport
	 * of floats. As different CPU architectures may use different
	 * endian representations for IEEE 754 floats, this protocol
	 * implicitly assumes that the caller and receiver are the same
	 * machine.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param device_scale_factor display scale factor, in float format
	 */
	void (*device_scale_factor)(void *data,
				    struct zaura_output_manager_v2 *zaura_output_manager_v2,
				    uint32_t output_name,
				    uint32_t device_scale_factor);
	/**
	 * logical transform of the output
	 *
	 * This event describes the logical transform for the output.
	 * Whereas panel transform corresponds to the display's panel
	 * rotation, the logical transform corresponds to the display's
	 * logical rotation.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param transform transform that maps framebuffer to output
	 */
	void (*logical_transform)(void *data,
				  struct zaura_output_manager_v2 *zaura_output_manager_v2,
				  uint32_t output_name,
				  int32_t transform);
	/**
	 * panel transform of the output
	 *
	 * This event describes the panel transform for the output, which
	 * is the associated display's panel rotation.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param transform transform that maps framebuffer to output
	 */
	void (*panel_transform)(void *data,
				struct zaura_output_manager_v2 *zaura_output_manager_v2,
				uint32_t output_name,
				int32_t transform);
	/**
	 * human-readable name of this output
	 *
	 * The name is a UTF-8 string with no convention defined for its
	 * contents.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param name output name
	 */
	void (*name)(void *data,
		     struct zaura_output_manager_v2 *zaura_output_manager_v2,
		     uint32_t output_name,
		     const char *name);
	/**
	 * human-readable description of this output
	 *
	 * The description is a UTF-8 string with no convention defined
	 * for its contents.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 * @param description output description
	 */
	void (*description)(void *data,
			    struct zaura_output_manager_v2 *zaura_output_manager_v2,
			    uint32_t output_name,
			    const char *description);
	/**
	 * advertise the overscan insets for the output
	 *
	 * This event describes the overscan insets for the output in
	 * physical pixels.
	 *
	 * The event is sent immediately after the wl_registry.global event
	 * for the output and subsequently in latter display configuration
	 * changes.
	 */
	void (*overscan_insets)(void *data,
				struct zaura_output_manager_v2 *zaura_output_manager_v2,
				uint32_t output_name,
				int32_t top,
				int32_t left,
				int32_t bottom,
				int32_t right);
	/**
	 * target display for new windows
	 *
	 * Notifies that this output is now active output. It is
	 * typically used as a target when a new window is created without
	 * specific bounds.
	 */
	void (*activated)(void *data,
			  struct zaura_output_manager_v2 *zaura_output_manager_v2,
			  uint32_t output_name);
};

/**
 * @ingroup iface_zaura_output_manager_v2
 */
static inline int
zaura_output_manager_v2_add_listener(struct zaura_output_manager_v2 *zaura_output_manager_v2,
				     const struct zaura_output_manager_v2_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_output_manager_v2,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_DONE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_DISPLAY_ID_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_LOGICAL_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_LOGICAL_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_PHYSICAL_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_WORK_AREA_INSETS_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_DEVICE_SCALE_FACTOR_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_LOGICAL_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_PANEL_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_NAME_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_DESCRIPTION_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_OVERSCAN_INSETS_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager_v2
 */
#define ZAURA_OUTPUT_MANAGER_V2_ACTIVATED_SINCE_VERSION 1


/** @ingroup iface_zaura_output_manager_v2 */
static inline void
zaura_output_manager_v2_set_user_data(struct zaura_output_manager_v2 *zaura_output_manager_v2, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_output_manager_v2, user_data);
}

/** @ingroup iface_zaura_output_manager_v2 */
static inline void *
zaura_output_manager_v2_get_user_data(struct zaura_output_manager_v2 *zaura_output_manager_v2)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_output_manager_v2);
}

static inline uint32_t
zaura_output_manager_v2_get_version(struct zaura_output_manager_v2 *zaura_output_manager_v2)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_output_manager_v2);
}

/** @ingroup iface_zaura_output_manager_v2 */
static inline void
zaura_output_manager_v2_destroy(struct zaura_output_manager_v2 *zaura_output_manager_v2)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_output_manager_v2);
}

#ifdef  __cplusplus
}
#endif

#endif
