/* Generated by wayland-scanner 1.23.0 */

#ifndef OVERLAY_PRIORITIZER_CLIENT_PROTOCOL_H
#define OVERLAY_PRIORITIZER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_overlay_prioritizer The overlay_prioritizer protocol
 * @section page_ifaces_overlay_prioritizer Interfaces
 * - @subpage page_iface_overlay_prioritizer - overlay hint prioritization
 * - @subpage page_iface_overlay_prioritized_surface - delegate overlay prioritization hint of a wl_surface
 * @section page_copyright_overlay_prioritizer Copyright
 * <pre>
 *
 * Copyright 2021 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct overlay_prioritized_surface;
struct overlay_prioritizer;
struct wl_surface;

#ifndef OVERLAY_PRIORITIZER_INTERFACE
#define OVERLAY_PRIORITIZER_INTERFACE
/**
 * @page page_iface_overlay_prioritizer overlay_prioritizer
 * @section page_iface_overlay_prioritizer_desc Description
 *
 * The global interface exposing overlay delegated prioritization
 * hint capabilities is used to instantiate an interface extension for a
 * wl_surface object. This extended interface will then allow
 * delegated overlay prioritization of the surface.
 * @section page_iface_overlay_prioritizer_api API
 * See @ref iface_overlay_prioritizer.
 */
/**
 * @defgroup iface_overlay_prioritizer The overlay_prioritizer interface
 *
 * The global interface exposing overlay delegated prioritization
 * hint capabilities is used to instantiate an interface extension for a
 * wl_surface object. This extended interface will then allow
 * delegated overlay prioritization of the surface.
 */
extern const struct wl_interface overlay_prioritizer_interface;
#endif
#ifndef OVERLAY_PRIORITIZED_SURFACE_INTERFACE
#define OVERLAY_PRIORITIZED_SURFACE_INTERFACE
/**
 * @page page_iface_overlay_prioritized_surface overlay_prioritized_surface
 * @section page_iface_overlay_prioritized_surface_desc Description
 *
 * An additional interface to a wl_surface object, which allows the
 * client to specify hints for the overlay prioritization of the surface.
 * @section page_iface_overlay_prioritized_surface_api API
 * See @ref iface_overlay_prioritized_surface.
 */
/**
 * @defgroup iface_overlay_prioritized_surface The overlay_prioritized_surface interface
 *
 * An additional interface to a wl_surface object, which allows the
 * client to specify hints for the overlay prioritization of the surface.
 */
extern const struct wl_interface overlay_prioritized_surface_interface;
#endif

#ifndef OVERLAY_PRIORITIZER_ERROR_ENUM
#define OVERLAY_PRIORITIZER_ERROR_ENUM
enum overlay_prioritizer_error {
	/**
	 * the surface already has a prioritizer object              associated
	 */
	OVERLAY_PRIORITIZER_ERROR_OVERLAY_HINTED_SURFACE_EXISTS = 0,
};
#endif /* OVERLAY_PRIORITIZER_ERROR_ENUM */

#define OVERLAY_PRIORITIZER_DESTROY 0
#define OVERLAY_PRIORITIZER_GET_OVERLAY_PRIORITIZED_SURFACE 1


/**
 * @ingroup iface_overlay_prioritizer
 */
#define OVERLAY_PRIORITIZER_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_overlay_prioritizer
 */
#define OVERLAY_PRIORITIZER_GET_OVERLAY_PRIORITIZED_SURFACE_SINCE_VERSION 1

/** @ingroup iface_overlay_prioritizer */
static inline void
overlay_prioritizer_set_user_data(struct overlay_prioritizer *overlay_prioritizer, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) overlay_prioritizer, user_data);
}

/** @ingroup iface_overlay_prioritizer */
static inline void *
overlay_prioritizer_get_user_data(struct overlay_prioritizer *overlay_prioritizer)
{
	return wl_proxy_get_user_data((struct wl_proxy *) overlay_prioritizer);
}

static inline uint32_t
overlay_prioritizer_get_version(struct overlay_prioritizer *overlay_prioritizer)
{
	return wl_proxy_get_version((struct wl_proxy *) overlay_prioritizer);
}

/**
 * @ingroup iface_overlay_prioritizer
 *
 * Informs the server that the client will not be using this
 * protocol object anymore. This does not affect any other objects,
 * prioritizer objects included.
 */
static inline void
overlay_prioritizer_destroy(struct overlay_prioritizer *overlay_prioritizer)
{
	wl_proxy_marshal_flags((struct wl_proxy *) overlay_prioritizer,
			 OVERLAY_PRIORITIZER_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) overlay_prioritizer), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_overlay_prioritizer
 *
 * Instantiate an interface extension for the given wl_surface to
 * add support for overlay prioritization hinting. If the given wl_surface already has
 * a prioritization object associated, the delegate_exists protocol error is
 * raised.
 */
static inline struct overlay_prioritized_surface *
overlay_prioritizer_get_overlay_prioritized_surface(struct overlay_prioritizer *overlay_prioritizer, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) overlay_prioritizer,
			 OVERLAY_PRIORITIZER_GET_OVERLAY_PRIORITIZED_SURFACE, &overlay_prioritized_surface_interface, wl_proxy_get_version((struct wl_proxy *) overlay_prioritizer), 0, NULL, surface);

	return (struct overlay_prioritized_surface *) id;
}

#ifndef OVERLAY_PRIORITIZED_SURFACE_ERROR_ENUM
#define OVERLAY_PRIORITIZED_SURFACE_ERROR_ENUM
enum overlay_prioritized_surface_error {
	/**
	 * negative values in radius or size
	 */
	OVERLAY_PRIORITIZED_SURFACE_ERROR_BAD_VALUE = 0,
	/**
	 * the wl_surface was destroyed
	 */
	OVERLAY_PRIORITIZED_SURFACE_ERROR_NO_SURFACE = 1,
};
#endif /* OVERLAY_PRIORITIZED_SURFACE_ERROR_ENUM */

#ifndef OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_ENUM
#define OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_ENUM
/**
 * @ingroup iface_overlay_prioritized_surface
 * hints for overlay prioritization
 *
 */
enum overlay_prioritized_surface_overlay_priority {
	/**
	 * overlay promotion is not necessary for this surface
	 */
	OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_NONE = 0,
	/**
	 * surface could be considered as a candidate for promotion
	 */
	OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_REGULAR = 1,
	/**
	 * the surface is a low latency canvas that works better if promoted to overlay
	 */
	OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_PREFERRED_LOW_LATENCY_CANVAS = 2,
	/**
	 * the surface contains protected content and requires to be promoted to overlay
	 */
	OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_REQUIRED_HARDWARE_PROTECTION = 3,
};
#endif /* OVERLAY_PRIORITIZED_SURFACE_OVERLAY_PRIORITY_ENUM */

#define OVERLAY_PRIORITIZED_SURFACE_DESTROY 0
#define OVERLAY_PRIORITIZED_SURFACE_SET_OVERLAY_PRIORITY 1


/**
 * @ingroup iface_overlay_prioritized_surface
 */
#define OVERLAY_PRIORITIZED_SURFACE_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_overlay_prioritized_surface
 */
#define OVERLAY_PRIORITIZED_SURFACE_SET_OVERLAY_PRIORITY_SINCE_VERSION 1

/** @ingroup iface_overlay_prioritized_surface */
static inline void
overlay_prioritized_surface_set_user_data(struct overlay_prioritized_surface *overlay_prioritized_surface, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) overlay_prioritized_surface, user_data);
}

/** @ingroup iface_overlay_prioritized_surface */
static inline void *
overlay_prioritized_surface_get_user_data(struct overlay_prioritized_surface *overlay_prioritized_surface)
{
	return wl_proxy_get_user_data((struct wl_proxy *) overlay_prioritized_surface);
}

static inline uint32_t
overlay_prioritized_surface_get_version(struct overlay_prioritized_surface *overlay_prioritized_surface)
{
	return wl_proxy_get_version((struct wl_proxy *) overlay_prioritized_surface);
}

/**
 * @ingroup iface_overlay_prioritized_surface
 *
 * The associated wl_surface's overlay prioritization is removed.
 * The change is applied on the next wl_surface.commit.
 */
static inline void
overlay_prioritized_surface_destroy(struct overlay_prioritized_surface *overlay_prioritized_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) overlay_prioritized_surface,
			 OVERLAY_PRIORITIZED_SURFACE_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) overlay_prioritized_surface), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_overlay_prioritized_surface
 *
 */
static inline void
overlay_prioritized_surface_set_overlay_priority(struct overlay_prioritized_surface *overlay_prioritized_surface, uint32_t priority)
{
	wl_proxy_marshal_flags((struct wl_proxy *) overlay_prioritized_surface,
			 OVERLAY_PRIORITIZED_SURFACE_SET_OVERLAY_PRIORITY, NULL, wl_proxy_get_version((struct wl_proxy *) overlay_prioritized_surface), 0, priority);
}

#ifdef  __cplusplus
}
#endif

#endif
