// components/services/font/public/mojom/font_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_FONT_PUBLIC_MOJOM_FONT_SERVICE_MOJOM_H_
#define COMPONENTS_SERVICES_FONT_PUBLIC_MOJOM_FONT_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/services/font/public/mojom/font_service.mojom-features.h"  // IWYU pragma: export
#include "components/services/font/public/mojom/font_service.mojom-shared.h"  // IWYU pragma: export
#include "components/services/font/public/mojom/font_service.mojom-forward.h"  // IWYU pragma: export
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/read_only_file.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace font_service::mojom {

class FontServiceProxy;

template <typename ImplRefTraits>
class FontServiceStub;

class FontServiceRequestValidator;
class FontServiceResponseValidator;


class FontService
    : public FontServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FontServiceInterfaceBase;
  using Proxy_ = FontServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = FontServiceStub<ImplRefTraits>;

  using RequestValidator_ = FontServiceRequestValidator;
  using ResponseValidator_ = FontServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kMatchFamilyNameMinVersion = 0,
    kOpenStreamMinVersion = 0,
    kFallbackFontForCharacterMinVersion = 0,
    kFontRenderStyleForStrikeMinVersion = 0,
    kMatchFontByPostscriptNameOrFullFontNameMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct MatchFamilyName_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OpenStream_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct FallbackFontForCharacter_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct FontRenderStyleForStrike_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct MatchFontByPostscriptNameOrFullFontName_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FontService() = default;


  using MatchFamilyNameCallback = base::OnceCallback<void(FontIdentityPtr, const std::string&, TypefaceStylePtr)>;
  
  virtual void MatchFamilyName(const std::string& family_name, TypefaceStylePtr style, MatchFamilyNameCallback callback) = 0;


  using OpenStreamCallback = base::OnceCallback<void(::base::File)>;
  
  virtual void OpenStream(uint32_t id_number, OpenStreamCallback callback) = 0;


  using FallbackFontForCharacterCallback = base::OnceCallback<void(FontIdentityPtr, const std::string&, bool, bool)>;
  
  virtual void FallbackFontForCharacter(uint32_t character, const std::string& locale, FallbackFontForCharacterCallback callback) = 0;


  using FontRenderStyleForStrikeCallback = base::OnceCallback<void(FontRenderStylePtr)>;
  
  virtual void FontRenderStyleForStrike(const std::string& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStyleForStrikeCallback callback) = 0;


  using MatchFontByPostscriptNameOrFullFontNameCallback = base::OnceCallback<void(FontIdentityPtr)>;
  
  virtual void MatchFontByPostscriptNameOrFullFontName(const std::string& postscript_name_or_full_font_name, MatchFontByPostscriptNameOrFullFontNameCallback callback) = 0;
};



class  FontServiceProxy
    : public FontService {
 public:
  using InterfaceType = FontService;

  explicit FontServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void MatchFamilyName(const std::string& family_name, TypefaceStylePtr style, MatchFamilyNameCallback callback) final;
  
  void OpenStream(uint32_t id_number, OpenStreamCallback callback) final;
  
  void FallbackFontForCharacter(uint32_t character, const std::string& locale, FallbackFontForCharacterCallback callback) final;
  
  void FontRenderStyleForStrike(const std::string& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStyleForStrikeCallback callback) final;
  
  void MatchFontByPostscriptNameOrFullFontName(const std::string& postscript_name_or_full_font_name, MatchFontByPostscriptNameOrFullFontNameCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  FontServiceStubDispatch {
 public:
  static bool Accept(FontService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FontService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FontService>>
class FontServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FontServiceStub() = default;
  ~FontServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  FontServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  FontServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  TypefaceStyle {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TypefaceStyle, T>::value>;
  using DataView = TypefaceStyleDataView;
  using Data_ = internal::TypefaceStyle_Data;

  template <typename... Args>
  static TypefaceStylePtr New(Args&&... args) {
    return TypefaceStylePtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TypefaceStylePtr From(const U& u) {
    return mojo::TypeConverter<TypefaceStylePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TypefaceStyle>::Convert(*this);
  }


  TypefaceStyle();

  TypefaceStyle(
      uint16_t weight,
      uint8_t width,
      TypefaceSlant slant);


  ~TypefaceStyle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TypefaceStylePtr>
  TypefaceStylePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TypefaceStyle::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TypefaceStyle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TypefaceStyle_UnserializedMessageContext<
            UserType, TypefaceStyle::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TypefaceStyle::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return TypefaceStyle::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TypefaceStyle_UnserializedMessageContext<
            UserType, TypefaceStyle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TypefaceStyle::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint16_t weight;
  
  uint8_t width;
  
  TypefaceSlant slant;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TypefaceStyle::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}










class  FontIdentity {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FontIdentity, T>::value>;
  using DataView = FontIdentityDataView;
  using Data_ = internal::FontIdentity_Data;

  template <typename... Args>
  static FontIdentityPtr New(Args&&... args) {
    return FontIdentityPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FontIdentityPtr From(const U& u) {
    return mojo::TypeConverter<FontIdentityPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FontIdentity>::Convert(*this);
  }


  FontIdentity();

  FontIdentity(
      uint32_t id,
      int32_t ttc_index,
      const ::base::FilePath& filepath);


  ~FontIdentity();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FontIdentityPtr>
  FontIdentityPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FontIdentity::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FontIdentity::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FontIdentity_UnserializedMessageContext<
            UserType, FontIdentity::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FontIdentity::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return FontIdentity::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FontIdentity_UnserializedMessageContext<
            UserType, FontIdentity::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FontIdentity::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t id;
  
  int32_t ttc_index;
  
  ::base::FilePath filepath;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FontIdentity::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FontRenderStyle {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FontRenderStyle, T>::value>;
  using DataView = FontRenderStyleDataView;
  using Data_ = internal::FontRenderStyle_Data;

  template <typename... Args>
  static FontRenderStylePtr New(Args&&... args) {
    return FontRenderStylePtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FontRenderStylePtr From(const U& u) {
    return mojo::TypeConverter<FontRenderStylePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FontRenderStyle>::Convert(*this);
  }


  FontRenderStyle();

  FontRenderStyle(
      RenderStyleSwitch use_bitmaps,
      RenderStyleSwitch use_autohint,
      RenderStyleSwitch use_hinting,
      uint8_t hint_style,
      RenderStyleSwitch use_antialias,
      RenderStyleSwitch use_subpixel_rendering,
      RenderStyleSwitch use_subpixel_positioning);


  ~FontRenderStyle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FontRenderStylePtr>
  FontRenderStylePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FontRenderStyle::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FontRenderStyle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FontRenderStyle_UnserializedMessageContext<
            UserType, FontRenderStyle::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FontRenderStyle::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return FontRenderStyle::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FontRenderStyle_UnserializedMessageContext<
            UserType, FontRenderStyle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FontRenderStyle::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  RenderStyleSwitch use_bitmaps;
  
  RenderStyleSwitch use_autohint;
  
  RenderStyleSwitch use_hinting;
  
  uint8_t hint_style;
  
  RenderStyleSwitch use_antialias;
  
  RenderStyleSwitch use_subpixel_rendering;
  
  RenderStyleSwitch use_subpixel_positioning;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FontRenderStyle::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
TypefaceStylePtr TypefaceStyle::Clone() const {
  return New(
      mojo::Clone(weight),
      mojo::Clone(width),
      mojo::Clone(slant)
  );
}

template <typename T, TypefaceStyle::EnableIfSame<T>*>
bool TypefaceStyle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->weight, other_struct.weight))
    return false;
  if (!mojo::Equals(this->width, other_struct.width))
    return false;
  if (!mojo::Equals(this->slant, other_struct.slant))
    return false;
  return true;
}

template <typename T, TypefaceStyle::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.weight < rhs.weight)
    return true;
  if (rhs.weight < lhs.weight)
    return false;
  if (lhs.width < rhs.width)
    return true;
  if (rhs.width < lhs.width)
    return false;
  if (lhs.slant < rhs.slant)
    return true;
  if (rhs.slant < lhs.slant)
    return false;
  return false;
}
template <typename StructPtrType>
FontIdentityPtr FontIdentity::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(ttc_index),
      mojo::Clone(filepath)
  );
}

template <typename T, FontIdentity::EnableIfSame<T>*>
bool FontIdentity::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->ttc_index, other_struct.ttc_index))
    return false;
  if (!mojo::Equals(this->filepath, other_struct.filepath))
    return false;
  return true;
}

template <typename T, FontIdentity::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.ttc_index < rhs.ttc_index)
    return true;
  if (rhs.ttc_index < lhs.ttc_index)
    return false;
  if (lhs.filepath < rhs.filepath)
    return true;
  if (rhs.filepath < lhs.filepath)
    return false;
  return false;
}
template <typename StructPtrType>
FontRenderStylePtr FontRenderStyle::Clone() const {
  return New(
      mojo::Clone(use_bitmaps),
      mojo::Clone(use_autohint),
      mojo::Clone(use_hinting),
      mojo::Clone(hint_style),
      mojo::Clone(use_antialias),
      mojo::Clone(use_subpixel_rendering),
      mojo::Clone(use_subpixel_positioning)
  );
}

template <typename T, FontRenderStyle::EnableIfSame<T>*>
bool FontRenderStyle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->use_bitmaps, other_struct.use_bitmaps))
    return false;
  if (!mojo::Equals(this->use_autohint, other_struct.use_autohint))
    return false;
  if (!mojo::Equals(this->use_hinting, other_struct.use_hinting))
    return false;
  if (!mojo::Equals(this->hint_style, other_struct.hint_style))
    return false;
  if (!mojo::Equals(this->use_antialias, other_struct.use_antialias))
    return false;
  if (!mojo::Equals(this->use_subpixel_rendering, other_struct.use_subpixel_rendering))
    return false;
  if (!mojo::Equals(this->use_subpixel_positioning, other_struct.use_subpixel_positioning))
    return false;
  return true;
}

template <typename T, FontRenderStyle::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.use_bitmaps < rhs.use_bitmaps)
    return true;
  if (rhs.use_bitmaps < lhs.use_bitmaps)
    return false;
  if (lhs.use_autohint < rhs.use_autohint)
    return true;
  if (rhs.use_autohint < lhs.use_autohint)
    return false;
  if (lhs.use_hinting < rhs.use_hinting)
    return true;
  if (rhs.use_hinting < lhs.use_hinting)
    return false;
  if (lhs.hint_style < rhs.hint_style)
    return true;
  if (rhs.hint_style < lhs.hint_style)
    return false;
  if (lhs.use_antialias < rhs.use_antialias)
    return true;
  if (rhs.use_antialias < lhs.use_antialias)
    return false;
  if (lhs.use_subpixel_rendering < rhs.use_subpixel_rendering)
    return true;
  if (rhs.use_subpixel_rendering < lhs.use_subpixel_rendering)
    return false;
  if (lhs.use_subpixel_positioning < rhs.use_subpixel_positioning)
    return true;
  if (rhs.use_subpixel_positioning < lhs.use_subpixel_positioning)
    return false;
  return false;
}


}  // font_service::mojom

namespace mojo {


template <>
struct  StructTraits<::font_service::mojom::TypefaceStyle::DataView,
                                         ::font_service::mojom::TypefaceStylePtr> {
  static bool IsNull(const ::font_service::mojom::TypefaceStylePtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::TypefaceStylePtr* output) { output->reset(); }

  static decltype(::font_service::mojom::TypefaceStyle::weight) weight(
      const ::font_service::mojom::TypefaceStylePtr& input) {
    return input->weight;
  }

  static decltype(::font_service::mojom::TypefaceStyle::width) width(
      const ::font_service::mojom::TypefaceStylePtr& input) {
    return input->width;
  }

  static decltype(::font_service::mojom::TypefaceStyle::slant) slant(
      const ::font_service::mojom::TypefaceStylePtr& input) {
    return input->slant;
  }

  static bool Read(::font_service::mojom::TypefaceStyle::DataView input, ::font_service::mojom::TypefaceStylePtr* output);
};


template <>
struct  StructTraits<::font_service::mojom::FontIdentity::DataView,
                                         ::font_service::mojom::FontIdentityPtr> {
  static bool IsNull(const ::font_service::mojom::FontIdentityPtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::FontIdentityPtr* output) { output->reset(); }

  static decltype(::font_service::mojom::FontIdentity::id) id(
      const ::font_service::mojom::FontIdentityPtr& input) {
    return input->id;
  }

  static decltype(::font_service::mojom::FontIdentity::ttc_index) ttc_index(
      const ::font_service::mojom::FontIdentityPtr& input) {
    return input->ttc_index;
  }

  static const decltype(::font_service::mojom::FontIdentity::filepath)& filepath(
      const ::font_service::mojom::FontIdentityPtr& input) {
    return input->filepath;
  }

  static bool Read(::font_service::mojom::FontIdentity::DataView input, ::font_service::mojom::FontIdentityPtr* output);
};


template <>
struct  StructTraits<::font_service::mojom::FontRenderStyle::DataView,
                                         ::font_service::mojom::FontRenderStylePtr> {
  static bool IsNull(const ::font_service::mojom::FontRenderStylePtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::FontRenderStylePtr* output) { output->reset(); }

  static decltype(::font_service::mojom::FontRenderStyle::use_bitmaps) use_bitmaps(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_bitmaps;
  }

  static decltype(::font_service::mojom::FontRenderStyle::use_autohint) use_autohint(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_autohint;
  }

  static decltype(::font_service::mojom::FontRenderStyle::use_hinting) use_hinting(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_hinting;
  }

  static decltype(::font_service::mojom::FontRenderStyle::hint_style) hint_style(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->hint_style;
  }

  static decltype(::font_service::mojom::FontRenderStyle::use_antialias) use_antialias(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_antialias;
  }

  static decltype(::font_service::mojom::FontRenderStyle::use_subpixel_rendering) use_subpixel_rendering(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_subpixel_rendering;
  }

  static decltype(::font_service::mojom::FontRenderStyle::use_subpixel_positioning) use_subpixel_positioning(
      const ::font_service::mojom::FontRenderStylePtr& input) {
    return input->use_subpixel_positioning;
  }

  static bool Read(::font_service::mojom::FontRenderStyle::DataView input, ::font_service::mojom::FontRenderStylePtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_FONT_PUBLIC_MOJOM_FONT_SERVICE_MOJOM_H_