// electron/shell/common/web_contents_utility.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef ELECTRON_SHELL_COMMON_WEB_CONTENTS_UTILITY_MOJOM_H_
#define ELECTRON_SHELL_COMMON_WEB_CONTENTS_UTILITY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "electron/shell/common/web_contents_utility.mojom-features.h"  // IWYU pragma: export
#include "electron/shell/common/web_contents_utility.mojom-shared.h"  // IWYU pragma: export
#include "electron/shell/common/web_contents_utility.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/permissions/permission_status.mojom-forward.h"
#include "third_party/blink/public/mojom/tokens/tokens.mojom.h"
#include "url/mojom/origin.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace electron::mojom {

class ElectronWebContentsUtilityProxy;

template <typename ImplRefTraits>
class ElectronWebContentsUtilityStub;

class ElectronWebContentsUtilityRequestValidator;
class ElectronWebContentsUtilityResponseValidator;


class ElectronWebContentsUtility
    : public ElectronWebContentsUtilityInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    956898623, 
    982504138
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ElectronWebContentsUtilityInterfaceBase;
  using Proxy_ = ElectronWebContentsUtilityProxy;

  template <typename ImplRefTraits>
  using Stub_ = ElectronWebContentsUtilityStub<ImplRefTraits>;

  using RequestValidator_ = ElectronWebContentsUtilityRequestValidator;
  using ResponseValidator_ = ElectronWebContentsUtilityResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnFirstNonEmptyLayoutMinVersion = 0,
    kSetTemporaryZoomLevelMinVersion = 0,
    kDoGetZoomLevelMinVersion = 0,
    kCanAccessClipboardDeprecatedMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnFirstNonEmptyLayout_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetTemporaryZoomLevel_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DoGetZoomLevel_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CanAccessClipboardDeprecated_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ElectronWebContentsUtility() = default;

  
  virtual void OnFirstNonEmptyLayout() = 0;

  
  virtual void SetTemporaryZoomLevel(double zoom_level) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool DoGetZoomLevel(double* out_result);

  using DoGetZoomLevelCallback = base::OnceCallback<void(double)>;
  
  virtual void DoGetZoomLevel(DoGetZoomLevelCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool CanAccessClipboardDeprecated(PermissionName name, const ::blink::LocalFrameToken& frame_token, ::blink::mojom::PermissionStatus* out_status);

  using CanAccessClipboardDeprecatedCallback = base::OnceCallback<void(::blink::mojom::PermissionStatus)>;
  
  virtual void CanAccessClipboardDeprecated(PermissionName name, const ::blink::LocalFrameToken& frame_token, CanAccessClipboardDeprecatedCallback callback) = 0;
};



class  ElectronWebContentsUtilityProxy
    : public ElectronWebContentsUtility {
 public:
  using InterfaceType = ElectronWebContentsUtility;

  explicit ElectronWebContentsUtilityProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnFirstNonEmptyLayout() final;
  
  void SetTemporaryZoomLevel(double zoom_level) final;
  
  bool DoGetZoomLevel(double* out_result) final;
  
  void DoGetZoomLevel(DoGetZoomLevelCallback callback) final;
  
  bool CanAccessClipboardDeprecated(PermissionName name, const ::blink::LocalFrameToken& frame_token, ::blink::mojom::PermissionStatus* out_status) final;
  
  void CanAccessClipboardDeprecated(PermissionName name, const ::blink::LocalFrameToken& frame_token, CanAccessClipboardDeprecatedCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ElectronWebContentsUtilityStubDispatch {
 public:
  static bool Accept(ElectronWebContentsUtility* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ElectronWebContentsUtility* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ElectronWebContentsUtility>>
class ElectronWebContentsUtilityStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ElectronWebContentsUtilityStub() = default;
  ~ElectronWebContentsUtilityStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronWebContentsUtilityStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ElectronWebContentsUtilityStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ElectronWebContentsUtilityRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ElectronWebContentsUtilityResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // electron::mojom

namespace mojo {

}  // namespace mojo

#endif  // ELECTRON_SHELL_COMMON_WEB_CONTENTS_UTILITY_MOJOM_H_