// services/data_decoder/public/mojom/json_parser.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/data_decoder/public/mojom/json_parser.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/data_decoder/public/mojom/json_parser.mojom-params-data.h"
#include "services/data_decoder/public/mojom/json_parser.mojom-shared-message-ids.h"

#include "services/data_decoder/public/mojom/json_parser.mojom-import-headers.h"
#include "services/data_decoder/public/mojom/json_parser.mojom-test-utils.h"


namespace data_decoder::mojom {
const char JsonParser::Name_[] = "data_decoder.mojom.JsonParser";

JsonParser::IPCStableHashFunction JsonParser::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (static_cast<messages::JsonParser>(message.name())) {
    case messages::JsonParser::kParse: {
      return &JsonParser::Parse_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* JsonParser::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (static_cast<messages::JsonParser>(message.name())) {
      case messages::JsonParser::kParse:
            return "Receive data_decoder::mojom::JsonParser::Parse";
    }
  } else {
    switch (static_cast<messages::JsonParser>(message.name())) {
      case messages::JsonParser::kParse:
            return "Receive reply data_decoder::mojom::JsonParser::Parse";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t JsonParser::Parse_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)data_decoder::mojom::JsonParser::Parse");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class JsonParser_Parse_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  JsonParser_Parse_ForwardToCallback(
      JsonParser::ParseCallback callback
      ) : callback_(std::move(callback)) {
  }

  JsonParser_Parse_ForwardToCallback(const JsonParser_Parse_ForwardToCallback&) = delete;
  JsonParser_Parse_ForwardToCallback& operator=(const JsonParser_Parse_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  JsonParser::ParseCallback callback_;
};

JsonParserProxy::JsonParserProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void JsonParserProxy::Parse(
    const std::string& in_json, uint32_t in_options, ParseCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send data_decoder::mojom::JsonParser::Parse", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("json"), in_json,
                        "<value of type const std::string&>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("options"), in_options,
                        "<value of type uint32_t>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::JsonParser::kParse), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::data_decoder::mojom::internal::JsonParser_Parse_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->json)::BaseType> json_fragment(
          params.message());
  mojo::internal::Serialize<mojo::StringDataView>(
      in_json, json_fragment);
  params->json.Set(
      json_fragment.is_null() ? nullptr : json_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->json.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null json in JsonParser.Parse request");
  params->options = in_options;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(JsonParser::Name_);
  message.set_method_name("Parse");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new JsonParser_Parse_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class JsonParser_Parse_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static JsonParser::ParseCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<JsonParser_Parse_ProxyToResponder> proxy(
        new JsonParser_Parse_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&JsonParser_Parse_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~JsonParser_Parse_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  JsonParser_Parse_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "JsonParser::ParseCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::optional<::base::Value> in_result, const std::optional<std::string>& in_error);
};

bool JsonParser_Parse_ForwardToCallback::Accept(
    mojo::Message* message) {
  DCHECK(message->is_serialized());
  internal::JsonParser_Parse_ResponseParams_Data* params =
      reinterpret_cast<
          internal::JsonParser_Parse_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for JsonParser.0
  bool success = true;
  std::optional<::base::Value> p_result{};
  std::optional<std::string> p_error{};
  JsonParser_Parse_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (success && !input_data_view.ReadError(&p_error))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        JsonParser::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result), 
std::move(p_error));
  return true;
}

void JsonParser_Parse_ProxyToResponder::Run(
    std::optional<::base::Value> in_result, const std::optional<std::string>& in_error) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply data_decoder::mojom::JsonParser::Parse", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type std::optional<::base::Value>>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("error"), in_error,
                        "<value of type const std::optional<std::string>&>");
   });
#endif

  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::JsonParser::kParse), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::data_decoder::mojom::internal::JsonParser_Parse_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->result)>
      result_fragment(params.message());
  result_fragment.Claim(&params->result);
  mojo::internal::Serialize<::mojo_base::mojom::ValueDataView>(
      in_result, result_fragment, true);
  mojo::internal::MessageFragment<
      typename decltype(params->error)::BaseType> error_fragment(
          params.message());
  mojo::internal::Serialize<mojo::StringDataView>(
      in_error, error_fragment);
  params->error.Set(
      error_fragment.is_null() ? nullptr : error_fragment.data());

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(JsonParser::Name_);
  message.set_method_name("Parse");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool JsonParserStubDispatch::Accept(
    JsonParser* impl,
    mojo::Message* message) {
  switch (static_cast<messages::JsonParser>(message->header()->name)) {
    case messages::JsonParser::kParse: {
      break;
    }
  }
  return false;
}

// static
bool JsonParserStubDispatch::AcceptWithResponder(
    JsonParser* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (static_cast<messages::JsonParser>(message->header()->name)) {
    case messages::JsonParser::kParse: {
      internal::JsonParser_Parse_Params_Data* params =
          reinterpret_cast<
              internal::JsonParser_Parse_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for JsonParser.0
      bool success = true;
      std::string p_json{};
      uint32_t p_options{};
      JsonParser_Parse_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadJson(&p_json))
        success = false;
      if (success)
        p_options = input_data_view.options();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            JsonParser::Name_, 0, false);
        return false;
      }
      JsonParser::ParseCallback callback =
          JsonParser_Parse_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Parse(        
        std::move(p_json), 
        std::move(p_options), std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kJsonParserValidationInfo[] = {
    {base::to_underlying(messages::JsonParser::kParse),
     { &internal::JsonParser_Parse_Params_Data::Validate,
      &internal::JsonParser_Parse_ResponseParams_Data::Validate}},
};

bool JsonParserRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::data_decoder::mojom::JsonParser::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kJsonParserValidationInfo);
}

bool JsonParserResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::data_decoder::mojom::JsonParser::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kJsonParserValidationInfo);

}


}  // data_decoder::mojom


namespace mojo {

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace data_decoder::mojom {


void JsonParserInterceptorForTesting::Parse(const std::string& json, uint32_t options, ParseCallback callback) {
  GetForwardingInterface()->Parse(
    std::move(json)
    , 
    std::move(options)
    , std::move(callback));
}
JsonParserAsyncWaiter::JsonParserAsyncWaiter(
    JsonParser* proxy) : proxy_(proxy) {}

JsonParserAsyncWaiter::~JsonParserAsyncWaiter() = default;

void JsonParserAsyncWaiter::Parse(
    const std::string& json, uint32_t options, std::optional<::base::Value>* out_result, std::optional<std::string>* out_error) {
  base::RunLoop loop;
  proxy_->Parse(
      std::move(json),
      std::move(options),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::optional<::base::Value>* out_result
,
             std::optional<std::string>* out_error
,
             std::optional<::base::Value> result,
             const std::optional<std::string>& error) {*out_result = std::move(result);*out_error = std::move(error);
            loop->Quit();
          },
          &loop,
          out_result,
          out_error));
  loop.Run();
}








}  // data_decoder::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif