// services/webnn/public/mojom/webnn_graph_builder.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_BLINK_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_graph_builder.mojom-features.h"  // IWYU pragma: export
#include "services/webnn/public/mojom/webnn_graph_builder.mojom-shared.h"  // IWYU pragma: export
#include "services/webnn/public/mojom/webnn_graph_builder.mojom-blink-forward.h"  // IWYU pragma: export
#include "services/webnn/public/mojom/webnn_error.mojom-blink.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "base/component_export.h"




namespace webnn::mojom::blink {

class WebNNGraphBuilderProxy;

template <typename ImplRefTraits>
class WebNNGraphBuilderStub;

class WebNNGraphBuilderRequestValidator;
class WebNNGraphBuilderResponseValidator;


class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) WebNNGraphBuilder
    : public WebNNGraphBuilderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNGraphBuilderInterfaceBase;
  using Proxy_ = WebNNGraphBuilderProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNGraphBuilderStub<ImplRefTraits>;

  using RequestValidator_ = WebNNGraphBuilderRequestValidator;
  using ResponseValidator_ = WebNNGraphBuilderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateGraphMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateGraph_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNGraphBuilder() = default;


  using CreateGraphCallback = base::OnceCallback<void(CreateGraphResultPtr)>;
  
  virtual void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) = 0;
};



class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) WebNNGraphBuilderProxy
    : public WebNNGraphBuilder {
 public:
  using InterfaceType = WebNNGraphBuilder;

  explicit WebNNGraphBuilderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) WebNNGraphBuilderStubDispatch {
 public:
  static bool Accept(WebNNGraphBuilder* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNGraphBuilder* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNGraphBuilder>>
class WebNNGraphBuilderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNGraphBuilderStub() = default;
  ~WebNNGraphBuilderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNGraphBuilderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNGraphBuilderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) WebNNGraphBuilderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) WebNNGraphBuilderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) CreateGraphResult {
 public:
  using DataView = CreateGraphResultDataView;
  using Data_ = internal::CreateGraphResult_Data;
  using Tag = Data_::CreateGraphResult_Tag;

  template <typename... Args>
  static CreateGraphResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |graph_remote|.
  static CreateGraphResultPtr
  NewGraphRemote(
      ::mojo::PendingAssociatedRemote<::webnn::mojom::blink::WebNNGraph> value) {
    auto result = CreateGraphResultPtr(std::in_place);
    result->set_graph_remote(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static CreateGraphResultPtr
  NewError(
      ::webnn::mojom::blink::ErrorPtr value) {
    auto result = CreateGraphResultPtr(std::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static CreateGraphResultPtr From(const U& u) {
    return mojo::TypeConverter<CreateGraphResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateGraphResult>::Convert(*this);
  }

  CreateGraphResult();
  ~CreateGraphResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  CreateGraphResult(const CreateGraphResult& other) = delete;
  CreateGraphResult& operator=(const CreateGraphResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = CreateGraphResultPtr>
  CreateGraphResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateGraphResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateGraphResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_graph_remote() const { return tag_ == Tag::kGraphRemote; }

  
  ::mojo::PendingAssociatedRemote<::webnn::mojom::blink::WebNNGraph>& get_graph_remote() const {
    CHECK(tag_ == Tag::kGraphRemote);
    return *(data_.graph_remote);
  }

  
  void set_graph_remote(
      ::mojo::PendingAssociatedRemote<::webnn::mojom::blink::WebNNGraph> graph_remote);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  ::webnn::mojom::blink::ErrorPtr& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      ::webnn::mojom::blink::ErrorPtr error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateGraphResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<CreateGraphResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::mojo::PendingAssociatedRemote<::webnn::mojom::blink::WebNNGraph>* graph_remote;
    ::webnn::mojom::blink::ErrorPtr* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};

template <typename UnionPtrType>
CreateGraphResultPtr CreateGraphResult::Clone() const {
  switch (tag_) {
    case Tag::kGraphRemote:
      return NewGraphRemote(
          mojo::Clone(*data_.graph_remote));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, CreateGraphResult>::value>::type*>
bool CreateGraphResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kGraphRemote:
      return mojo::Equals(*(data_.graph_remote), *(other.data_.graph_remote));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}


}  // webnn::mojom::blink

namespace mojo {


template <>
struct COMPONENT_EXPORT(WEBNN_MOJOM_BLINK) UnionTraits<::webnn::mojom::blink::CreateGraphResult::DataView,
                                        ::webnn::mojom::blink::CreateGraphResultPtr> {
  static bool IsNull(const ::webnn::mojom::blink::CreateGraphResultPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::CreateGraphResultPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::CreateGraphResult::Tag GetTag(const ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->which();
  }

  static  ::mojo::PendingAssociatedRemote<::webnn::mojom::blink::WebNNGraph>& graph_remote( ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->get_graph_remote();
  }

  static const ::webnn::mojom::blink::ErrorPtr& error(const ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::webnn::mojom::blink::CreateGraphResult::DataView input, ::webnn::mojom::blink::CreateGraphResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_BUILDER_MOJOM_BLINK_H_