// third_party/blink/public/mojom/ai/ai_text_session_info.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_TEXT_SESSION_INFO_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_TEXT_SESSION_INFO_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/ai/ai_text_session_info.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink::mojom {
class AITextSessionSamplingParamsDataView;

class AITextModelInfoDataView;

class AITextSessionInfoDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::AITextSessionSamplingParamsDataView> {
  using Data = ::blink::mojom::internal::AITextSessionSamplingParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::AITextModelInfoDataView> {
  using Data = ::blink::mojom::internal::AITextModelInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::AITextSessionInfoDataView> {
  using Data = ::blink::mojom::internal::AITextSessionInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


class AITextSessionSamplingParamsDataView {
 public:
  AITextSessionSamplingParamsDataView() = default;

  AITextSessionSamplingParamsDataView(
      internal::AITextSessionSamplingParams_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t top_k() const {
    return data_->top_k;
  }
  float temperature() const {
    return data_->temperature;
  }
 private:
  internal::AITextSessionSamplingParams_Data* data_ = nullptr;
};


class AITextModelInfoDataView {
 public:
  AITextModelInfoDataView() = default;

  AITextModelInfoDataView(
      internal::AITextModelInfo_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t default_top_k() const {
    return data_->default_top_k;
  }
  uint32_t max_top_k() const {
    return data_->max_top_k;
  }
  float default_temperature() const {
    return data_->default_temperature;
  }
 private:
  internal::AITextModelInfo_Data* data_ = nullptr;
};


class AITextSessionInfoDataView {
 public:
  AITextSessionInfoDataView() = default;

  AITextSessionInfoDataView(
      internal::AITextSessionInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  uint64_t max_tokens() const {
    return data_->max_tokens;
  }
  inline void GetSamplingParamsDataView(
      AITextSessionSamplingParamsDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSamplingParams(UserType* output) {
    
    auto* pointer = data_->sampling_params.Get();
    return mojo::internal::Deserialize<::blink::mojom::AITextSessionSamplingParamsDataView>(
        pointer, output, message_);
  }
 private:
  internal::AITextSessionInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AITextSessionSamplingParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AITextSessionSamplingParamsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AITextSessionSamplingParams_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->top_k = Traits::top_k(input);
    fragment->temperature = Traits::temperature(input);
  }

  static bool Deserialize(::blink::mojom::internal::AITextSessionSamplingParams_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AITextSessionSamplingParamsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AITextModelInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AITextModelInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AITextModelInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->default_top_k = Traits::default_top_k(input);
    fragment->max_top_k = Traits::max_top_k(input);
    fragment->default_temperature = Traits::default_temperature(input);
  }

  static bool Deserialize(::blink::mojom::internal::AITextModelInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AITextModelInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AITextSessionInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AITextSessionInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AITextSessionInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->max_tokens = Traits::max_tokens(input);
    decltype(Traits::sampling_params(input)) in_sampling_params = Traits::sampling_params(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->sampling_params)::BaseType> sampling_params_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::AITextSessionSamplingParamsDataView>(
        in_sampling_params, sampling_params_fragment);
    fragment->sampling_params.Set(
        sampling_params_fragment.is_null() ? nullptr : sampling_params_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->sampling_params.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null sampling_params in AITextSessionInfo struct");
  }

  static bool Deserialize(::blink::mojom::internal::AITextSessionInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AITextSessionInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {





inline void AITextSessionInfoDataView::GetSamplingParamsDataView(
    AITextSessionSamplingParamsDataView* output) {
  auto pointer = data_->sampling_params.Get();
  *output = AITextSessionSamplingParamsDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_TEXT_SESSION_INFO_MOJOM_SHARED_H_