// third_party/blink/public/mojom/annotation/annotation.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_ANNOTATION_ANNOTATION_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_ANNOTATION_ANNOTATION_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/annotation/annotation.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "third_party/blink/public/mojom/link_to_text/link_to_text.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class SelectorCreationResultDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::SelectorCreationResultDataView> {
  using Data = ::blink::mojom::internal::SelectorCreationResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class AnnotationType : int32_t {
  
  kSharedHighlight = 0,
  
  kUserNote = 1,
  
  kTextFinder = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, AnnotationType value);
inline bool IsKnownEnumValue(AnnotationType value) {
  return internal::AnnotationType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class AnnotationAgentInterfaceBase {};

using AnnotationAgentPtrDataView =
    mojo::InterfacePtrDataView<AnnotationAgentInterfaceBase>;
using AnnotationAgentRequestDataView =
    mojo::InterfaceRequestDataView<AnnotationAgentInterfaceBase>;
using AnnotationAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AnnotationAgentInterfaceBase>;
using AnnotationAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AnnotationAgentInterfaceBase>;
class AnnotationAgentHostInterfaceBase {};

using AnnotationAgentHostPtrDataView =
    mojo::InterfacePtrDataView<AnnotationAgentHostInterfaceBase>;
using AnnotationAgentHostRequestDataView =
    mojo::InterfaceRequestDataView<AnnotationAgentHostInterfaceBase>;
using AnnotationAgentHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AnnotationAgentHostInterfaceBase>;
using AnnotationAgentHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AnnotationAgentHostInterfaceBase>;
class AnnotationAgentContainerInterfaceBase {};

using AnnotationAgentContainerPtrDataView =
    mojo::InterfacePtrDataView<AnnotationAgentContainerInterfaceBase>;
using AnnotationAgentContainerRequestDataView =
    mojo::InterfaceRequestDataView<AnnotationAgentContainerInterfaceBase>;
using AnnotationAgentContainerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AnnotationAgentContainerInterfaceBase>;
using AnnotationAgentContainerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AnnotationAgentContainerInterfaceBase>;


class SelectorCreationResultDataView {
 public:
  SelectorCreationResultDataView() = default;

  SelectorCreationResultDataView(
      internal::SelectorCreationResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeHostReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfaceRequestDataView<::blink::mojom::AnnotationAgentHostInterfaceBase>>(
            &data_->host_receiver, &result, message_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeAgentRemote() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::blink::mojom::AnnotationAgentInterfaceBase>>(
            &data_->agent_remote, &result, message_);
    DCHECK(ret);
    return result;
  }
  inline void GetSerializedSelectorDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSerializedSelector(UserType* output) {
    
    auto* pointer = data_->serialized_selector.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetSelectedTextDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSelectedText(UserType* output) {
    
    auto* pointer = data_->selected_text.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, message_);
  }
 private:
  internal::SelectorCreationResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::AnnotationType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::AnnotationType> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AnnotationType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::AnnotationType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::AnnotationType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SelectorCreationResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::SelectorCreationResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::SelectorCreationResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::host_receiver(input)) in_host_receiver = Traits::host_receiver(input);
    mojo::internal::Serialize<mojo::InterfaceRequestDataView<::blink::mojom::AnnotationAgentHostInterfaceBase>>(
        in_host_receiver, &fragment->host_receiver, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->host_receiver),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid host_receiver in SelectorCreationResult struct");
    decltype(Traits::agent_remote(input)) in_agent_remote = Traits::agent_remote(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::AnnotationAgentInterfaceBase>>(
        in_agent_remote, &fragment->agent_remote, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->agent_remote),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid agent_remote in SelectorCreationResult struct");
    decltype(Traits::serialized_selector(input)) in_serialized_selector = Traits::serialized_selector(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->serialized_selector)::BaseType> serialized_selector_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_serialized_selector, serialized_selector_fragment);
    fragment->serialized_selector.Set(
        serialized_selector_fragment.is_null() ? nullptr : serialized_selector_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->serialized_selector.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null serialized_selector in SelectorCreationResult struct");
    decltype(Traits::selected_text(input)) in_selected_text = Traits::selected_text(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->selected_text)::BaseType> selected_text_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_selected_text, selected_text_fragment);
    fragment->selected_text.Set(
        selected_text_fragment.is_null() ? nullptr : selected_text_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->selected_text.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null selected_text in SelectorCreationResult struct");
  }

  static bool Deserialize(::blink::mojom::internal::SelectorCreationResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::SelectorCreationResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void SelectorCreationResultDataView::GetSerializedSelectorDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->serialized_selector.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void SelectorCreationResultDataView::GetSelectedTextDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->selected_text.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::AnnotationType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::AnnotationType value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_ANNOTATION_ANNOTATION_MOJOM_SHARED_H_