// third_party/blink/public/mojom/choosers/date_time_chooser.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_DATE_TIME_CHOOSER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_DATE_TIME_CHOOSER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/choosers/date_time_chooser.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "ui/base/ime/mojom/ime_types.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class DateTimeSuggestionDataView;

class DateTimeDialogValueDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::DateTimeSuggestionDataView> {
  using Data = ::blink::mojom::internal::DateTimeSuggestion_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::DateTimeDialogValueDataView> {
  using Data = ::blink::mojom::internal::DateTimeDialogValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {
// Interface base classes. They are used for type safety check.
class DateTimeChooserInterfaceBase {};

using DateTimeChooserPtrDataView =
    mojo::InterfacePtrDataView<DateTimeChooserInterfaceBase>;
using DateTimeChooserRequestDataView =
    mojo::InterfaceRequestDataView<DateTimeChooserInterfaceBase>;
using DateTimeChooserAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DateTimeChooserInterfaceBase>;
using DateTimeChooserAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DateTimeChooserInterfaceBase>;


class DateTimeSuggestionDataView {
 public:
  DateTimeSuggestionDataView() = default;

  DateTimeSuggestionDataView(
      internal::DateTimeSuggestion_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  double value() const {
    return data_->value;
  }
  inline void GetLocalizedValueDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLocalizedValue(UserType* output) {
    
    auto* pointer = data_->localized_value.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, message_);
  }
  inline void GetLabelDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLabel(UserType* output) {
    
    auto* pointer = data_->label.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, message_);
  }
 private:
  internal::DateTimeSuggestion_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class DateTimeDialogValueDataView {
 public:
  DateTimeDialogValueDataView() = default;

  DateTimeDialogValueDataView(
      internal::DateTimeDialogValue_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadDialogType(UserType* output) const {
    auto data_value = data_->dialog_type;
    return mojo::internal::Deserialize<::ui::mojom::TextInputType>(
        data_value, output);
  }
  ::ui::mojom::TextInputType dialog_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::ui::mojom::TextInputType>(data_->dialog_type));
  }
  double dialog_value() const {
    return data_->dialog_value;
  }
  double minimum() const {
    return data_->minimum;
  }
  double maximum() const {
    return data_->maximum;
  }
  double step() const {
    return data_->step;
  }
  inline void GetSuggestionsDataView(
      mojo::ArrayDataView<DateTimeSuggestionDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSuggestions(UserType* output) {
    
    auto* pointer = data_->suggestions.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::blink::mojom::DateTimeSuggestionDataView>>(
        pointer, output, message_);
  }
 private:
  internal::DateTimeDialogValue_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DateTimeSuggestionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::DateTimeSuggestionDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::DateTimeSuggestion_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->value = Traits::value(input);
    decltype(Traits::localized_value(input)) in_localized_value = Traits::localized_value(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->localized_value)::BaseType> localized_value_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_localized_value, localized_value_fragment);
    fragment->localized_value.Set(
        localized_value_fragment.is_null() ? nullptr : localized_value_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->localized_value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null localized_value in DateTimeSuggestion struct");
    decltype(Traits::label(input)) in_label = Traits::label(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->label)::BaseType> label_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::String16DataView>(
        in_label, label_fragment);
    fragment->label.Set(
        label_fragment.is_null() ? nullptr : label_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->label.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null label in DateTimeSuggestion struct");
  }

  static bool Deserialize(::blink::mojom::internal::DateTimeSuggestion_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::DateTimeSuggestionDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DateTimeDialogValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::DateTimeDialogValueDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::DateTimeDialogValue_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::ui::mojom::TextInputType>(
        Traits::dialog_type(input), &fragment->dialog_type);
    fragment->dialog_value = Traits::dialog_value(input);
    fragment->minimum = Traits::minimum(input);
    fragment->maximum = Traits::maximum(input);
    fragment->step = Traits::step(input);
    decltype(Traits::suggestions(input)) in_suggestions = Traits::suggestions(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->suggestions)::BaseType>
        suggestions_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& suggestions_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::blink::mojom::DateTimeSuggestionDataView>>(
        in_suggestions, suggestions_fragment, &suggestions_validate_params);
    fragment->suggestions.Set(
        suggestions_fragment.is_null() ? nullptr : suggestions_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->suggestions.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null suggestions in DateTimeDialogValue struct");
  }

  static bool Deserialize(::blink::mojom::internal::DateTimeDialogValue_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::DateTimeDialogValueDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void DateTimeSuggestionDataView::GetLocalizedValueDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->localized_value.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, message_);
}
inline void DateTimeSuggestionDataView::GetLabelDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->label.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, message_);
}


inline void DateTimeDialogValueDataView::GetSuggestionsDataView(
    mojo::ArrayDataView<DateTimeSuggestionDataView>* output) {
  auto pointer = data_->suggestions.Get();
  *output = mojo::ArrayDataView<DateTimeSuggestionDataView>(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_CHOOSERS_DATE_TIME_CHOOSER_MOJOM_SHARED_H_