// third_party/blink/public/mojom/file_system_access/file_system_access_observer_host.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_OBSERVER_HOST_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_OBSERVER_HOST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/file_system_access/file_system_access_observer_host.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/file_system_access/file_system_access_observer_host.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/file_system_access/file_system_access_observer_host.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/file_system_access/file_system_access_error.mojom-forward.h"
#include "third_party/blink/public/mojom/file_system_access/file_system_access_observer.mojom-forward.h"
#include "third_party/blink/public/mojom/file_system_access/file_system_access_transfer_token.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class FileSystemAccessObserverHostProxy;

template <typename ImplRefTraits>
class FileSystemAccessObserverHostStub;

class FileSystemAccessObserverHostRequestValidator;
class FileSystemAccessObserverHostResponseValidator;


class BLINK_COMMON_EXPORT FileSystemAccessObserverHost
    : public FileSystemAccessObserverHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FileSystemAccessObserverHostInterfaceBase;
  using Proxy_ = FileSystemAccessObserverHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = FileSystemAccessObserverHostStub<ImplRefTraits>;

  using RequestValidator_ = FileSystemAccessObserverHostRequestValidator;
  using ResponseValidator_ = FileSystemAccessObserverHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kObserveMinVersion = 0,
    kUnobserveMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Observe_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Unobserve_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FileSystemAccessObserverHost() = default;


  using ObserveCallback = base::OnceCallback<void(::blink::mojom::FileSystemAccessErrorPtr, ::mojo::PendingReceiver<::blink::mojom::FileSystemAccessObserver>)>;
  
  virtual void Observe(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token, bool is_recursive, ObserveCallback callback) = 0;

  
  virtual void Unobserve(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token) = 0;
};



class BLINK_COMMON_EXPORT FileSystemAccessObserverHostProxy
    : public FileSystemAccessObserverHost {
 public:
  using InterfaceType = FileSystemAccessObserverHost;

  explicit FileSystemAccessObserverHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Observe(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token, bool is_recursive, ObserveCallback callback) final;
  
  void Unobserve(::mojo::PendingRemote<::blink::mojom::FileSystemAccessTransferToken> token) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FileSystemAccessObserverHostStubDispatch {
 public:
  static bool Accept(FileSystemAccessObserverHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FileSystemAccessObserverHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FileSystemAccessObserverHost>>
class FileSystemAccessObserverHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FileSystemAccessObserverHostStub() = default;
  ~FileSystemAccessObserverHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessObserverHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessObserverHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FileSystemAccessObserverHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FileSystemAccessObserverHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_OBSERVER_HOST_MOJOM_H_