// third_party/blink/public/mojom/web_install/web_install.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/web_install/web_install.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/web_install/web_install.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/web_install/web_install.mojom-blink-forward.h"  // IWYU pragma: export
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class WebInstallServiceProxy;

template <typename ImplRefTraits>
class WebInstallServiceStub;

class WebInstallServiceRequestValidator;
class WebInstallServiceResponseValidator;


class PLATFORM_EXPORT WebInstallService
    : public WebInstallServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebInstallServiceInterfaceBase;
  using Proxy_ = WebInstallServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebInstallServiceStub<ImplRefTraits>;

  using RequestValidator_ = WebInstallServiceRequestValidator;
  using ResponseValidator_ = WebInstallServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kInstallCurrentDocumentMinVersion = 0,
    kInstallBackgroundDocumentMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct InstallCurrentDocument_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct InstallBackgroundDocument_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebInstallService() = default;


  using InstallCurrentDocumentCallback = base::OnceCallback<void(WebInstallServiceResult, const ::blink::KURL&)>;
  
  virtual void InstallCurrentDocument(const ::blink::KURL& manifest_id, InstallCurrentDocumentCallback callback) = 0;


  using InstallBackgroundDocumentCallback = base::OnceCallback<void(WebInstallServiceResult, const ::blink::KURL&)>;
  
  virtual void InstallBackgroundDocument(const ::blink::KURL& manifest_id, const ::blink::KURL& install_url, InstallBackgroundDocumentCallback callback) = 0;
};



class PLATFORM_EXPORT WebInstallServiceProxy
    : public WebInstallService {
 public:
  using InterfaceType = WebInstallService;

  explicit WebInstallServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void InstallCurrentDocument(const ::blink::KURL& manifest_id, InstallCurrentDocumentCallback callback) final;
  
  void InstallBackgroundDocument(const ::blink::KURL& manifest_id, const ::blink::KURL& install_url, InstallBackgroundDocumentCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT WebInstallServiceStubDispatch {
 public:
  static bool Accept(WebInstallService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebInstallService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebInstallService>>
class WebInstallServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebInstallServiceStub() = default;
  ~WebInstallServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebInstallServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebInstallServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT WebInstallServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT WebInstallServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEB_INSTALL_WEB_INSTALL_MOJOM_BLINK_H_