// third_party/blink/public/mojom/webid/digital_identity_request.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/webid/digital_identity_request.mojom-blink-forward.h"  // IWYU pragma: export

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class DigitalIdentityRequestProxy;

template <typename ImplRefTraits>
class DigitalIdentityRequestStub;

class DigitalIdentityRequestRequestValidator;
class DigitalIdentityRequestResponseValidator;


class PLATFORM_EXPORT DigitalIdentityRequest
    : public DigitalIdentityRequestInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DigitalIdentityRequestInterfaceBase;
  using Proxy_ = DigitalIdentityRequestProxy;

  template <typename ImplRefTraits>
  using Stub_ = DigitalIdentityRequestStub<ImplRefTraits>;

  using RequestValidator_ = DigitalIdentityRequestRequestValidator;
  using ResponseValidator_ = DigitalIdentityRequestResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestMinVersion = 0,
    kAbortMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Request_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Abort_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DigitalIdentityRequest() = default;


  using RequestCallback = base::OnceCallback<void(RequestDigitalIdentityStatus, const WTF::String&)>;
  
  virtual void Request(DigitalCredentialProviderPtr digital_credential_provider, RequestCallback callback) = 0;

  
  virtual void Abort() = 0;
};



class PLATFORM_EXPORT DigitalIdentityRequestProxy
    : public DigitalIdentityRequest {
 public:
  using InterfaceType = DigitalIdentityRequest;

  explicit DigitalIdentityRequestProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Request(DigitalCredentialProviderPtr digital_credential_provider, RequestCallback callback) final;
  
  void Abort() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT DigitalIdentityRequestStubDispatch {
 public:
  static bool Accept(DigitalIdentityRequest* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DigitalIdentityRequest* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DigitalIdentityRequest>>
class DigitalIdentityRequestStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DigitalIdentityRequestStub() = default;
  ~DigitalIdentityRequestStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalIdentityRequestStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalIdentityRequestStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT DigitalIdentityRequestRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT DigitalIdentityRequestResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class PLATFORM_EXPORT DigitalCredentialProvider {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialProvider, T>::value>;
  using DataView = DigitalCredentialProviderDataView;
  using Data_ = internal::DigitalCredentialProvider_Data;

  template <typename... Args>
  static DigitalCredentialProviderPtr New(Args&&... args) {
    return DigitalCredentialProviderPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialProviderPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialProvider>::Convert(*this);
  }


  DigitalCredentialProvider();

  DigitalCredentialProvider(
      const WTF::String& protocol,
      const WTF::String& request);


  ~DigitalCredentialProvider();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialProviderPtr>
  DigitalCredentialProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialProvider::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialProvider::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return DigitalCredentialProvider::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String protocol;
  
  WTF::String request;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
DigitalCredentialProviderPtr DigitalCredentialProvider::Clone() const {
  return New(
      mojo::Clone(protocol),
      mojo::Clone(request)
  );
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool DigitalCredentialProvider::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->protocol, other_struct.protocol))
    return false;
  if (!mojo::Equals(this->request, other_struct.request))
    return false;
  return true;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.protocol < rhs.protocol)
    return true;
  if (rhs.protocol < lhs.protocol)
    return false;
  if (lhs.request < rhs.request)
    return true;
  if (rhs.request < lhs.request)
    return false;
  return false;
}


}  // blink::mojom::blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::DigitalCredentialProvider::DataView,
                                         ::blink::mojom::blink::DigitalCredentialProviderPtr> {
  static bool IsNull(const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::DigitalCredentialProviderPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::protocol)& protocol(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->protocol;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::request)& request(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->request;
  }

  static bool Read(::blink::mojom::blink::DigitalCredentialProvider::DataView input, ::blink::mojom::blink::DigitalCredentialProviderPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_DIGITAL_IDENTITY_REQUEST_MOJOM_BLINK_H_