// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_base_keyframe.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_timeline_range_offset.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_double_string_timelinerangeoffset.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"composite",
"easing",
"offset",
};


}  // namespace 

BaseKeyframe* BaseKeyframe::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  BaseKeyframe* dictionary = MakeGarbageCollected<BaseKeyframe>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "BaseKeyframe";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 BaseKeyframe::BaseKeyframe() : member_offset_(nullptr) {
  
}

 BaseKeyframe::BaseKeyframe(v8::Isolate* isolate) : member_offset_(nullptr) {
  
}








void BaseKeyframe::setEasing(const String& value) {
  member_easing_ = value;
}

void BaseKeyframe::setEasing(String&& value) {
  member_easing_ = std::move(value);
}









void BaseKeyframe::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8CompositeOperationOrAuto>::Trace(visitor, member_composite_);
TraceIfNeeded<String>::Trace(visitor, member_easing_);
TraceIfNeeded<Member<V8UnionDoubleOrStringOrTimelineRangeOffset>>::Trace(visitor, member_offset_);
bindings::DictionaryBase::Trace(visitor);
}

void BaseKeyframe::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void BaseKeyframe::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasComposite()) {
  values[0] = ToV8Traits<V8CompositeOperationOrAuto>::ToV8(script_state, member_composite_);
DCHECK(!values[0].IsEmpty());
}
if (hasEasing()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_easing_);
DCHECK(!values[1].IsEmpty());
}
if (hasOffset()) {
  values[2] = ToV8Traits<IDLNullable<V8UnionDoubleOrStringOrTimelineRangeOffset>>::ToV8(script_state, member_offset_.Get());
DCHECK(!values[2].IsEmpty());
}
}

const void* BaseKeyframe::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> BaseKeyframe::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void BaseKeyframe::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "BaseKeyframe";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("composite");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8CompositeOperationOrAuto, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_composite_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("easing");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_easing_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("offset");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8UnionDoubleOrStringOrTimelineRangeOffset>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_offset_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> BaseKeyframe::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
