// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_dom_matrix_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"is2D",
"m13",
"m14",
"m23",
"m24",
"m31",
"m32",
"m33",
"m34",
"m43",
"m44",
};


}  // namespace 

DOMMatrixInit* DOMMatrixInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DOMMatrixInit* dictionary = MakeGarbageCollected<DOMMatrixInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DOMMatrixInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 DOMMatrixInit::DOMMatrixInit() {
  
}

 DOMMatrixInit::DOMMatrixInit(v8::Isolate* isolate) : DOMMatrix2DInit(isolate) {
  
}




























































void DOMMatrixInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_is_2d_);
TraceIfNeeded<double>::Trace(visitor, member_m_13_);
TraceIfNeeded<double>::Trace(visitor, member_m_14_);
TraceIfNeeded<double>::Trace(visitor, member_m_23_);
TraceIfNeeded<double>::Trace(visitor, member_m_24_);
TraceIfNeeded<double>::Trace(visitor, member_m_31_);
TraceIfNeeded<double>::Trace(visitor, member_m_32_);
TraceIfNeeded<double>::Trace(visitor, member_m_33_);
TraceIfNeeded<double>::Trace(visitor, member_m_34_);
TraceIfNeeded<double>::Trace(visitor, member_m_43_);
TraceIfNeeded<double>::Trace(visitor, member_m_44_);
DOMMatrix2DInit::Trace(visitor);
}

void DOMMatrixInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
DOMMatrix2DInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "DOMMatrixInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("is2D");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_is_2d_, member_is_2d_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m13");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_m_13_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m14");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_m_14_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m23");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_m_23_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m24");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_m_24_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m31");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_m_31_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m32");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_m_32_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m33");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_m_33_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m34");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_m_34_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m43");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_m_43_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("m44");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnrestrictedDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_m_44_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DOMMatrixInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
