// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_IMAGE_ENCODE_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_IMAGE_ENCODE_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_image_color_space.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_image_pixel_format.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT ImageEncodeOptions : public bindings::InputDictionaryBase {
  
  public:
static ImageEncodeOptions* Create() {
  return MakeGarbageCollected<ImageEncodeOptions>();
}
static ImageEncodeOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<ImageEncodeOptions>(isolate);
}
static ImageEncodeOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  ImageEncodeOptions();
explicit  ImageEncodeOptions(v8::Isolate* isolate);

bool hasColorSpace() const {
  return true;
}
V8ImageColorSpace colorSpace() const {
  return member_color_space_;
}
void setColorSpace(V8ImageColorSpace value) {
  member_color_space_ = value;
}
void setColorSpace(V8ImageColorSpace::Enum value) {
  member_color_space_ = V8ImageColorSpace(value);
}

bool hasPixelFormat() const {
  return true;
}
V8ImagePixelFormat pixelFormat() const {
  return member_pixel_format_;
}
void setPixelFormat(V8ImagePixelFormat value) {
  member_pixel_format_ = value;
}
void setPixelFormat(V8ImagePixelFormat::Enum value) {
  member_pixel_format_ = V8ImagePixelFormat(value);
}

bool hasQuality() const {
  return true;
}
double quality() const {
  return member_quality_;
}
void setQuality(double value) {
  member_quality_ = value;
}

bool hasType() const {
  return true;
}
const String& type() const {
  return member_type_;
}
void setType(const String& value);
void setType(String&& value);


// Obsolete accessor functions
void setColorSpace(const String& value) {
  member_color_space_ = V8ImageColorSpace::Create(value).value();
}
void setPixelFormat(const String& value) {
  member_pixel_format_ = V8ImagePixelFormat::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 4;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



V8ImageColorSpace member_color_space_{V8ImageColorSpace::Enum::kSRGB};
V8ImagePixelFormat member_pixel_format_{V8ImagePixelFormat::Enum::kUint8};
double member_quality_{1.0};
String member_type_{"image/png"};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_IMAGE_ENCODE_OPTIONS_H_
