// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_memory_attribution.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_memory_attribution_container.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"container",
"scope",
"url",
};


}  // namespace 

MemoryAttribution* MemoryAttribution::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MemoryAttribution* dictionary = MakeGarbageCollected<MemoryAttribution>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MemoryAttribution";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MemoryAttribution::MemoryAttribution() {
  
}

 MemoryAttribution::MemoryAttribution(v8::Isolate* isolate) {
  
}










void MemoryAttribution::setScope(const String& value) {
  member_scope_ = value;
}

void MemoryAttribution::setScope(String&& value) {
  member_scope_ = std::move(value);
}




void MemoryAttribution::setUrl(const String& value) {
  member_url_ = value;
}

void MemoryAttribution::setUrl(String&& value) {
  member_url_ = std::move(value);
}




void MemoryAttribution::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MemoryAttributionContainer>>::Trace(visitor, member_container_);
TraceIfNeeded<String>::Trace(visitor, member_scope_);
TraceIfNeeded<String>::Trace(visitor, member_url_);
bindings::DictionaryBase::Trace(visitor);
}

void MemoryAttribution::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MemoryAttribution::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasContainer()) {
  values[0] = ToV8Traits<MemoryAttributionContainer>::ToV8(script_state, member_container_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasScope()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_scope_);
DCHECK(!values[1].IsEmpty());
}
if (hasUrl()) {
  values[2] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_url_);
DCHECK(!values[2].IsEmpty());
}
}

const void* MemoryAttribution::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MemoryAttribution::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MemoryAttribution::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "MemoryAttribution";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("container");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MemoryAttributionContainer, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_container_, member_container_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scope");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_scope_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("url");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_url_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MemoryAttribution::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
