// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_mojo_create_shared_buffer_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/mojo/mojo_handle.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"handle",
"result",
};


}  // namespace 

MojoCreateSharedBufferResult* MojoCreateSharedBufferResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MojoCreateSharedBufferResult* dictionary = MakeGarbageCollected<MojoCreateSharedBufferResult>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MojoCreateSharedBufferResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MojoCreateSharedBufferResult::MojoCreateSharedBufferResult() {
  
}

 MojoCreateSharedBufferResult::MojoCreateSharedBufferResult(v8::Isolate* isolate) {
  
}















void MojoCreateSharedBufferResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MojoHandle>>::Trace(visitor, member_handle_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_result_);
bindings::DictionaryBase::Trace(visitor);
}

void MojoCreateSharedBufferResult::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MojoCreateSharedBufferResult::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasHandle()) {
  values[0] = ToV8Traits<MojoHandle>::ToV8(script_state, member_handle_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasResult()) {
  values[1] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_result_);
DCHECK(!values[1].IsEmpty());
}
}

const void* MojoCreateSharedBufferResult::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MojoCreateSharedBufferResult::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MojoCreateSharedBufferResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "MojoCreateSharedBufferResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("handle");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MojoHandle, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_handle_, member_handle_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("result");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_result_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MojoCreateSharedBufferResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
