// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_mutation_observer_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"attributeFilter",
"attributeOldValue",
"attributes",
"characterData",
"characterDataOldValue",
"childList",
"subtree",
};


}  // namespace 

MutationObserverInit* MutationObserverInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MutationObserverInit* dictionary = MakeGarbageCollected<MutationObserverInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MutationObserverInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MutationObserverInit::MutationObserverInit() {
  
}

 MutationObserverInit::MutationObserverInit(v8::Isolate* isolate) {
  
}



Vector<String> MutationObserverInit::getAttributeFilterOr(const Vector<String>& fallback_value) const {
  if (!hasAttributeFilter()) {
  return fallback_value;
}
return member_attribute_filter_;
}

Vector<String> MutationObserverInit::getAttributeFilterOr(Vector<String>&& fallback_value) const {
  if (!hasAttributeFilter()) {
  return std::move(fallback_value);
}
return member_attribute_filter_;
}

void MutationObserverInit::setAttributeFilter(const Vector<String>& value) {
  member_attribute_filter_ = value;
has_attribute_filter_ = true;
}

void MutationObserverInit::setAttributeFilter(Vector<String>&& value) {
  member_attribute_filter_ = std::move(value);
has_attribute_filter_ = true;
}










































void MutationObserverInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<String>>::Trace(visitor, member_attribute_filter_);
TraceIfNeeded<bool>::Trace(visitor, member_attribute_old_value_);
TraceIfNeeded<bool>::Trace(visitor, member_attributes_);
TraceIfNeeded<bool>::Trace(visitor, member_character_data_);
TraceIfNeeded<bool>::Trace(visitor, member_character_data_old_value_);
TraceIfNeeded<bool>::Trace(visitor, member_child_list_);
TraceIfNeeded<bool>::Trace(visitor, member_subtree_);
bindings::InputDictionaryBase::Trace(visitor);
}

void MutationObserverInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "MutationObserverInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("attributeFilter");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_attribute_filter_, member_attribute_filter_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("attributeOldValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_attribute_old_value_, member_attribute_old_value_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("attributes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_attributes_, member_attributes_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("characterData");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_character_data_, member_character_data_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("characterDataOldValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_character_data_old_value_, member_character_data_old_value_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("childList");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_child_list_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("subtree");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_subtree_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MutationObserverInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
