// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_performance_entry_filter_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"entryType",
"includeChildFrames",
"name",
};


}  // namespace 

PerformanceEntryFilterOptions* PerformanceEntryFilterOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PerformanceEntryFilterOptions* dictionary = MakeGarbageCollected<PerformanceEntryFilterOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PerformanceEntryFilterOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PerformanceEntryFilterOptions::PerformanceEntryFilterOptions() {
  
}

 PerformanceEntryFilterOptions::PerformanceEntryFilterOptions(v8::Isolate* isolate) {
  
}



String PerformanceEntryFilterOptions::getEntryTypeOr(const String& fallback_value) const {
  if (!hasEntryType()) {
  return fallback_value;
}
return member_entry_type_;
}

String PerformanceEntryFilterOptions::getEntryTypeOr(String&& fallback_value) const {
  if (!hasEntryType()) {
  return std::move(fallback_value);
}
return member_entry_type_;
}

void PerformanceEntryFilterOptions::setEntryType(const String& value) {
  member_entry_type_ = value;
has_entry_type_ = true;
}

void PerformanceEntryFilterOptions::setEntryType(String&& value) {
  member_entry_type_ = std::move(value);
has_entry_type_ = true;
}











String PerformanceEntryFilterOptions::getNameOr(const String& fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_;
}

String PerformanceEntryFilterOptions::getNameOr(String&& fallback_value) const {
  if (!hasName()) {
  return std::move(fallback_value);
}
return member_name_;
}

void PerformanceEntryFilterOptions::setName(const String& value) {
  member_name_ = value;
has_name_ = true;
}

void PerformanceEntryFilterOptions::setName(String&& value) {
  member_name_ = std::move(value);
has_name_ = true;
}




void PerformanceEntryFilterOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_entry_type_);
TraceIfNeeded<bool>::Trace(visitor, member_include_child_frames_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
bindings::InputDictionaryBase::Trace(visitor);
}

void PerformanceEntryFilterOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PerformanceEntryFilterOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("entryType");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_entry_type_, member_entry_type_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("includeChildFrames");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_include_child_frames_, member_include_child_frames_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_name_, member_name_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PerformanceEntryFilterOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
