// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PERFORMANCE_ENTRY_FILTER_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PERFORMANCE_ENTRY_FILTER_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT PerformanceEntryFilterOptions : public bindings::InputDictionaryBase {
  
  public:
static PerformanceEntryFilterOptions* Create() {
  return MakeGarbageCollected<PerformanceEntryFilterOptions>();
}
static PerformanceEntryFilterOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PerformanceEntryFilterOptions>(isolate);
}
static PerformanceEntryFilterOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PerformanceEntryFilterOptions();
explicit  PerformanceEntryFilterOptions(v8::Isolate* isolate);

bool hasEntryType() const {
  return has_entry_type_;
}
const String& entryType() const {
  DCHECK(hasEntryType());
return member_entry_type_;
}
String getEntryTypeOr(const String& fallback_value) const;
String getEntryTypeOr(String&& fallback_value) const;
void setEntryType(const String& value);
void setEntryType(String&& value);

bool hasIncludeChildFrames() const {
  return has_include_child_frames_;
}
bool includeChildFrames() const {
  DCHECK(hasIncludeChildFrames());
return member_include_child_frames_;
}
bool getIncludeChildFramesOr(bool fallback_value) const {
  if (!hasIncludeChildFrames()) {
  return fallback_value;
}
return member_include_child_frames_;
}
void setIncludeChildFrames(bool value) {
  member_include_child_frames_ = value;
has_include_child_frames_ = true;
}

bool hasName() const {
  return has_name_;
}
const String& name() const {
  DCHECK(hasName());
return member_name_;
}
String getNameOr(const String& fallback_value) const;
String getNameOr(String&& fallback_value) const;
void setName(const String& value);
void setName(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 3;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_entry_type_ = false;
bool has_include_child_frames_ = false;
bool has_name_ = false;

String member_entry_type_;
bool member_include_child_frames_;
String member_name_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PERFORMANCE_ENTRY_FILTER_OPTIONS_H_
