// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_profiler_frame.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"column",
"line",
"name",
"resourceId",
};


}  // namespace 

ProfilerFrame* ProfilerFrame::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ProfilerFrame* dictionary = MakeGarbageCollected<ProfilerFrame>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ProfilerFrame";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 ProfilerFrame::ProfilerFrame() {
  
}

 ProfilerFrame::ProfilerFrame(v8::Isolate* isolate) {
  
}

















void ProfilerFrame::setName(const String& value) {
  member_name_ = value;
}

void ProfilerFrame::setName(String&& value) {
  member_name_ = std::move(value);
}











void ProfilerFrame::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint64_t>::Trace(visitor, member_column_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_line_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_resource_id_);
bindings::DictionaryBase::Trace(visitor);
}

void ProfilerFrame::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void ProfilerFrame::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasColumn()) {
  values[0] = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_column_);
DCHECK(!values[0].IsEmpty());
}
if (hasLine()) {
  values[1] = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_line_);
DCHECK(!values[1].IsEmpty());
}
if (hasName()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_name_);
DCHECK(!values[2].IsEmpty());
}
if (hasResourceId()) {
  values[3] = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_resource_id_);
DCHECK(!values[3].IsEmpty());
}
}

const void* ProfilerFrame::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> ProfilerFrame::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void ProfilerFrame::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "ProfilerFrame";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("column");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_column_, member_column_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("line");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_line_, member_line_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_name_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("resourceId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_resource_id_, member_resource_id_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ProfilerFrame::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
