// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_shadow_root_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/html/custom/custom_element_registry.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clonable",
"delegatesFocus",
"mode",
"referenceTarget",
"registry",
"serializable",
"slotAssignment",
};


}  // namespace 

ShadowRootInit* ShadowRootInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ShadowRootInit* dictionary = MakeGarbageCollected<ShadowRootInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ShadowRootInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 ShadowRootInit::ShadowRootInit() {
  
}

 ShadowRootInit::ShadowRootInit(v8::Isolate* isolate) {
  
}






















String ShadowRootInit::getReferenceTargetOr(const String& fallback_value) const {
  if (!hasReferenceTarget()) {
  return fallback_value;
}
return member_reference_target_;
}

String ShadowRootInit::getReferenceTargetOr(String&& fallback_value) const {
  if (!hasReferenceTarget()) {
  return std::move(fallback_value);
}
return member_reference_target_;
}

void ShadowRootInit::setReferenceTarget(const String& value) {
  member_reference_target_ = value;
has_reference_target_ = true;
}

void ShadowRootInit::setReferenceTarget(String&& value) {
  member_reference_target_ = std::move(value);
has_reference_target_ = true;
}

























void ShadowRootInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_clonable_);
TraceIfNeeded<bool>::Trace(visitor, member_delegates_focus_);
TraceIfNeeded<V8ShadowRootMode>::Trace(visitor, member_mode_);
TraceIfNeeded<String>::Trace(visitor, member_reference_target_);
TraceIfNeeded<Member<CustomElementRegistry>>::Trace(visitor, member_registry_);
TraceIfNeeded<bool>::Trace(visitor, member_serializable_);
TraceIfNeeded<V8SlotAssignmentMode>::Trace(visitor, member_slot_assignment_);
bindings::InputDictionaryBase::Trace(visitor);
}

void ShadowRootInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "ShadowRootInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clonable");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_clonable_, member_clonable_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("delegatesFocus");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_delegates_focus_, member_delegates_focus_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8ShadowRootMode, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mode_, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::ShadowRootReferenceTargetEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("referenceTarget");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_reference_target_, member_reference_target_, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::ScopedCustomElementRegistryEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("registry");
if (!bindings::GetDictionaryMemberFromV8Object<CustomElementRegistry, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_registry_, member_registry_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("serializable");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_serializable_, member_serializable_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("slotAssignment");
if (!bindings::GetDictionaryMemberFromV8Object<V8SlotAssignmentMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_slot_assignment_, member_slot_assignment_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ShadowRootInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
