// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SYNC_ITERATOR_STYLE_PROPERTY_MAP_READ_ONLY_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SYNC_ITERATOR_STYLE_PROPERTY_MAP_READ_ONLY_H_

#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/sync_iterator_base.h"
#include "third_party/blink/renderer/platform/bindings/v8_interface_bridge.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class CSSStyleValue;
class ExecutionContext;
class StylePropertyMapReadOnly;
struct WrapperTypeInfo;

template <>
class CORE_EXPORT SyncIterator<StylePropertyMapReadOnly> final : public bindings::SyncIteratorBase {
  DEFINE_WRAPPERTYPEINFO();

  public:
using IDLKeyType = IDLString;
using IDLValueType = IDLSequence<CSSStyleValue>;
using KeyType = String;
using ValueType = HeapVector<Member<CSSStyleValue>>;

explicit  SyncIterator<StylePropertyMapReadOnly>(IterationSourceBase* source, Kind kind) : bindings::SyncIteratorBase(source, kind) {
  
}
 ~SyncIterator() override = default;


  
  
  
};

class CORE_EXPORT V8SyncIteratorStylePropertyMapReadOnly final : public bindings::V8InterfaceBridge<V8SyncIteratorStylePropertyMapReadOnly, SyncIterator<StylePropertyMapReadOnly>> {
  
  public:
static bool IsExposed(ExecutionContext* execution_context);

static constexpr const WrapperTypeInfo* GetWrapperTypeInfo() {
  return &wrapper_type_info_;
}
  static constexpr v8::CppHeapPointerTag kThisTag =
      static_cast<v8::CppHeapPointerTag>(1438);
  static constexpr v8::CppHeapPointerTag kMaxSubclassTag =
      static_cast<v8::CppHeapPointerTag>(1438);
  static constexpr v8::CppHeapPointerTagRange kTagRange =
      v8::CppHeapPointerTagRange(kThisTag, kMaxSubclassTag);


static void InstallInterfaceTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::Template> interface_template);
static void InstallUnconditionalProperties(v8::Isolate* isolate, const DOMWrapperWorld& world, v8::Local<v8::Template> instance_template, v8::Local<v8::Template> prototype_template, v8::Local<v8::Template> interface_template);
static void InstallContextDependentProperties(v8::Local<v8::Context> context, const DOMWrapperWorld& world, v8::Local<v8::Object> instance_object, v8::Local<v8::Object> prototype_object, v8::Local<v8::Object> interface_object, v8::Local<v8::Template> interface_template, FeatureSelector feature_selector);


  
  private:
static const WrapperTypeInfo wrapper_type_info_;


  friend class SyncIterator<StylePropertyMapReadOnly>;
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_SYNC_ITERATOR_STYLE_PROPERTY_MAP_READ_ONLY_H_
