// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_touch_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/dom/events/event_target.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clientX",
"clientY",
"force",
"identifier",
"pageX",
"pageY",
"radiusX",
"radiusY",
"region",
"rotationAngle",
"screenX",
"screenY",
"target",
};


}  // namespace 

TouchInit* TouchInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  TouchInit* dictionary = MakeGarbageCollected<TouchInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "TouchInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 TouchInit::TouchInit() {
  
}

 TouchInit::TouchInit(v8::Isolate* isolate) {
  
}











































void TouchInit::setRegion(const String& value) {
  member_region_ = value;
}

void TouchInit::setRegion(String&& value) {
  member_region_ = std::move(value);
}
























void TouchInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_client_x_);
TraceIfNeeded<double>::Trace(visitor, member_client_y_);
TraceIfNeeded<float>::Trace(visitor, member_force_);
TraceIfNeeded<int32_t>::Trace(visitor, member_identifier_);
TraceIfNeeded<double>::Trace(visitor, member_page_x_);
TraceIfNeeded<double>::Trace(visitor, member_page_y_);
TraceIfNeeded<float>::Trace(visitor, member_radius_x_);
TraceIfNeeded<float>::Trace(visitor, member_radius_y_);
TraceIfNeeded<String>::Trace(visitor, member_region_);
TraceIfNeeded<float>::Trace(visitor, member_rotation_angle_);
TraceIfNeeded<double>::Trace(visitor, member_screen_x_);
TraceIfNeeded<double>::Trace(visitor, member_screen_y_);
TraceIfNeeded<Member<EventTarget>>::Trace(visitor, member_target_);
bindings::InputDictionaryBase::Trace(visitor);
}

void TouchInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "TouchInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientX");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_client_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_client_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("force");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_force_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("identifier");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_identifier_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pageX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_page_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pageY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_page_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("radiusX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_radius_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("radiusY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_radius_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("region");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_region_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rotationAngle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_rotation_angle_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("screenX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_screen_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("screenY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_screen_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("target");
if (!bindings::GetDictionaryMemberFromV8Object<EventTarget, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_target_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> TouchInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
