// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_transition_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"elapsedTime",
"propertyName",
"pseudoElement",
};


}  // namespace 

TransitionEventInit* TransitionEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  TransitionEventInit* dictionary = MakeGarbageCollected<TransitionEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "TransitionEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 TransitionEventInit::TransitionEventInit() {
  
}

 TransitionEventInit::TransitionEventInit(v8::Isolate* isolate) : EventInit(isolate) {
  
}








void TransitionEventInit::setPropertyName(const String& value) {
  member_property_name_ = value;
}

void TransitionEventInit::setPropertyName(String&& value) {
  member_property_name_ = std::move(value);
}




void TransitionEventInit::setPseudoElement(const String& value) {
  member_pseudo_element_ = value;
}

void TransitionEventInit::setPseudoElement(String&& value) {
  member_pseudo_element_ = std::move(value);
}




void TransitionEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_elapsed_time_);
TraceIfNeeded<String>::Trace(visitor, member_property_name_);
TraceIfNeeded<String>::Trace(visitor, member_pseudo_element_);
EventInit::Trace(visitor);
}

void TransitionEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
EventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "TransitionEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("elapsedTime");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_elapsed_time_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("propertyName");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_property_name_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pseudoElement");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_pseudo_element_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> TransitionEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
