// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEEVENT_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEEVENT_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class FenceEvent;
class ScriptState;

class CORE_EXPORT V8UnionFenceEventOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kFenceEvent, kString
};

static V8UnionFenceEventOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionFenceEventOrString(FenceEvent* value) : content_type_(ContentType::kFenceEvent), member_fence_event_(value) {
  DCHECK(value);
}
explicit  V8UnionFenceEventOrString(const String& value);
explicit  V8UnionFenceEventOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsFenceEvent() const {
  return content_type_ == ContentType::kFenceEvent;
}
FenceEvent* GetAsFenceEvent() const {
  DCHECK_EQ(content_type_, ContentType::kFenceEvent);
return member_fence_event_.Get();
}
void Set(FenceEvent* value) {
  DCHECK(value);
Clear();
member_fence_event_ = value;
content_type_ = ContentType::kFenceEvent;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or FenceEvent)";
}

ContentType content_type_;

Member<FenceEvent> member_fence_event_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_FENCEEVENT_STRING_H_
