// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_timelinerangeoffset.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_timeline_range_offset.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionStringOrTimelineRangeOffset* V8UnionStringOrTimelineRangeOffset::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsNullOrUndefined()) {
  auto&& blink_value = TimelineRangeOffset::Create(isolate);
return MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>(blink_value);
}
if (v8_value->IsObject()) {
  auto&& blink_value = NativeValueTraits<TimelineRangeOffset>::NativeValue(isolate, v8_value, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLString>::NativeValue(isolate, v8_value, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return MakeGarbageCollected<V8UnionStringOrTimelineRangeOffset>(std::move(blink_value));
}
}

 V8UnionStringOrTimelineRangeOffset::V8UnionStringOrTimelineRangeOffset(const String& value) : content_type_(ContentType::kString), member_string_(value) {
  
}

 V8UnionStringOrTimelineRangeOffset::V8UnionStringOrTimelineRangeOffset(String&& value) : content_type_(ContentType::kString), member_string_(std::move(value)) {
  
}




void V8UnionStringOrTimelineRangeOffset::Set(const String& value) {
  Clear();
member_string_ = value;
content_type_ = ContentType::kString;
}

void V8UnionStringOrTimelineRangeOffset::Set(String&& value) {
  Clear();
member_string_ = std::move(value);
content_type_ = ContentType::kString;
}





v8::Local<v8::Value> V8UnionStringOrTimelineRangeOffset::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kString: {
    return ToV8Traits<IDLString>::ToV8(script_state, member_string_);
  }
  case ContentType::kTimelineRangeOffset: {
    return ToV8Traits<TimelineRangeOffset>::ToV8(script_state, member_timeline_range_offset_.Get());
  }
}

NOTREACHED_IN_MIGRATION();
return v8::Local<v8::Value>();
}

void V8UnionStringOrTimelineRangeOffset::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_string_);
TraceIfNeeded<Member<TimelineRangeOffset>>::Trace(visitor, member_timeline_range_offset_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionStringOrTimelineRangeOffset::Clear() {
  member_string_ = String();
member_timeline_range_offset_.Clear();
}



}  // namespace blink
