// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_ASSISTANT_CREATE_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_ASSISTANT_CREATE_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class AIAssistantInitialPrompt;
class ExceptionState;

class MODULES_EXPORT AIAssistantCreateOptions : public bindings::InputDictionaryBase {
  
  public:
static AIAssistantCreateOptions* Create() {
  return MakeGarbageCollected<AIAssistantCreateOptions>();
}
static AIAssistantCreateOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AIAssistantCreateOptions>(isolate);
}
static AIAssistantCreateOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AIAssistantCreateOptions();
explicit  AIAssistantCreateOptions(v8::Isolate* isolate);

bool hasInitialPrompts() const {
  return has_initial_prompts_;
}
const HeapVector<Member<AIAssistantInitialPrompt>>& initialPrompts() const {
  DCHECK(hasInitialPrompts());
return member_initial_prompts_;
}
HeapVector<Member<AIAssistantInitialPrompt>> getInitialPromptsOr(const HeapVector<Member<AIAssistantInitialPrompt>>& fallback_value) const;
HeapVector<Member<AIAssistantInitialPrompt>> getInitialPromptsOr(HeapVector<Member<AIAssistantInitialPrompt>>&& fallback_value) const;
void setInitialPrompts(const HeapVector<Member<AIAssistantInitialPrompt>>& value);
void setInitialPrompts(HeapVector<Member<AIAssistantInitialPrompt>>&& value);

bool hasSystemPrompt() const {
  return has_system_prompt_;
}
const String& systemPrompt() const {
  DCHECK(hasSystemPrompt());
return member_system_prompt_;
}
String getSystemPromptOr(const String& fallback_value) const;
String getSystemPromptOr(String&& fallback_value) const;
void setSystemPrompt(const String& value);
void setSystemPrompt(String&& value);

bool hasTemperature() const {
  return has_temperature_;
}
float temperature() const {
  DCHECK(hasTemperature());
return member_temperature_;
}
float getTemperatureOr(float fallback_value) const {
  if (!hasTemperature()) {
  return fallback_value;
}
return member_temperature_;
}
void setTemperature(float value) {
  member_temperature_ = value;
has_temperature_ = true;
}

bool hasTopK() const {
  return has_top_k_;
}
uint32_t topK() const {
  DCHECK(hasTopK());
return member_top_k_;
}
uint32_t getTopKOr(uint32_t fallback_value) const {
  if (!hasTopK()) {
  return fallback_value;
}
return member_top_k_;
}
void setTopK(uint32_t value) {
  member_top_k_ = value;
has_top_k_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 4;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_initial_prompts_ = false;
bool has_system_prompt_ = false;
bool has_temperature_ = false;
bool has_top_k_ = false;

HeapVector<Member<AIAssistantInitialPrompt>> member_initial_prompts_;
String member_system_prompt_;
float member_temperature_;
uint32_t member_top_k_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_ASSISTANT_CREATE_OPTIONS_H_
