// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_SUMMARIZER_CREATE_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_SUMMARIZER_CREATE_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_summarizer_format.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_summarizer_length.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ai_summarizer_type.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class AbortSignal;
class ExceptionState;

class MODULES_EXPORT AISummarizerCreateOptions : public bindings::InputDictionaryBase {
  
  public:
static AISummarizerCreateOptions* Create() {
  return MakeGarbageCollected<AISummarizerCreateOptions>();
}
static AISummarizerCreateOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AISummarizerCreateOptions>(isolate);
}
static AISummarizerCreateOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AISummarizerCreateOptions();
explicit  AISummarizerCreateOptions(v8::Isolate* isolate);

bool hasFormat() const {
  return true;
}
V8AISummarizerFormat format() const {
  return member_format_;
}
void setFormat(V8AISummarizerFormat value) {
  member_format_ = value;
}
void setFormat(V8AISummarizerFormat::Enum value) {
  member_format_ = V8AISummarizerFormat(value);
}

bool hasLength() const {
  return true;
}
V8AISummarizerLength length() const {
  return member_length_;
}
void setLength(V8AISummarizerLength value) {
  member_length_ = value;
}
void setLength(V8AISummarizerLength::Enum value) {
  member_length_ = V8AISummarizerLength(value);
}

bool hasSharedContext() const {
  return has_shared_context_;
}
const String& sharedContext() const {
  DCHECK(hasSharedContext());
return member_shared_context_;
}
String getSharedContextOr(const String& fallback_value) const;
String getSharedContextOr(String&& fallback_value) const;
void setSharedContext(const String& value);
void setSharedContext(String&& value);

bool hasSignal() const {
  return has_signal_;
}
AbortSignal* signal() const {
  DCHECK(hasSignal());
return member_signal_.Get();
}
AbortSignal* getSignalOr(AbortSignal* fallback_value) const {
  if (!hasSignal()) {
  return fallback_value;
}
return member_signal_.Get();
}
void setSignal(AbortSignal* value) {
  member_signal_ = value;
has_signal_ = true;
DCHECK(member_signal_);
}

bool hasType() const {
  return true;
}
V8AISummarizerType type() const {
  return member_type_;
}
void setType(V8AISummarizerType value) {
  member_type_ = value;
}
void setType(V8AISummarizerType::Enum value) {
  member_type_ = V8AISummarizerType(value);
}


// Obsolete accessor functions
void setFormat(const String& value) {
  member_format_ = V8AISummarizerFormat::Create(value).value();
}
void setLength(const String& value) {
  member_length_ = V8AISummarizerLength::Create(value).value();
}
void setType(const String& value) {
  member_type_ = V8AISummarizerType::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 5;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_shared_context_ = false;
bool has_signal_ = false;

V8AISummarizerFormat member_format_{V8AISummarizerFormat::Enum::kMarkdown};
V8AISummarizerLength member_length_{V8AISummarizerLength::Enum::kMedium};
String member_shared_context_;
Member<AbortSignal> member_signal_;
V8AISummarizerType member_type_{V8AISummarizerType::Enum::kKeyPoints};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AI_SUMMARIZER_CREATE_OPTIONS_H_
