// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_all_accepted_credentials_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"allAcceptedCredentialIds",
"rpId",
"userId",
};


}  // namespace 

AllAcceptedCredentialsOptions* AllAcceptedCredentialsOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AllAcceptedCredentialsOptions* dictionary = MakeGarbageCollected<AllAcceptedCredentialsOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AllAcceptedCredentialsOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AllAcceptedCredentialsOptions::AllAcceptedCredentialsOptions() {
  
}

 AllAcceptedCredentialsOptions::AllAcceptedCredentialsOptions(v8::Isolate* isolate) {
  
}



void AllAcceptedCredentialsOptions::setAllAcceptedCredentialIds(const Vector<String>& value) {
  member_all_accepted_credential_ids_ = value;
}

void AllAcceptedCredentialsOptions::setAllAcceptedCredentialIds(Vector<String>&& value) {
  member_all_accepted_credential_ids_ = std::move(value);
}




void AllAcceptedCredentialsOptions::setRpId(const String& value) {
  member_rp_id_ = value;
}

void AllAcceptedCredentialsOptions::setRpId(String&& value) {
  member_rp_id_ = std::move(value);
}




void AllAcceptedCredentialsOptions::setUserId(const String& value) {
  member_user_id_ = value;
}

void AllAcceptedCredentialsOptions::setUserId(String&& value) {
  member_user_id_ = std::move(value);
}




void AllAcceptedCredentialsOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<String>>::Trace(visitor, member_all_accepted_credential_ids_);
TraceIfNeeded<String>::Trace(visitor, member_rp_id_);
TraceIfNeeded<String>::Trace(visitor, member_user_id_);
bindings::InputDictionaryBase::Trace(visitor);
}

void AllAcceptedCredentialsOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AllAcceptedCredentialsOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("allAcceptedCredentialIds");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_all_accepted_credential_ids_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rpId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_rp_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_user_id_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AllAcceptedCredentialsOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
