// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_buffer_source_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/webaudio/audio_buffer.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"buffer",
"detune",
"loop",
"loopEnd",
"loopStart",
"playbackRate",
};


}  // namespace 

AudioBufferSourceOptions* AudioBufferSourceOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AudioBufferSourceOptions* dictionary = MakeGarbageCollected<AudioBufferSourceOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AudioBufferSourceOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AudioBufferSourceOptions::AudioBufferSourceOptions() {
  
}

 AudioBufferSourceOptions::AudioBufferSourceOptions(v8::Isolate* isolate) {
  
}



































void AudioBufferSourceOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<AudioBuffer>>::Trace(visitor, member_buffer_);
TraceIfNeeded<float>::Trace(visitor, member_detune_);
TraceIfNeeded<bool>::Trace(visitor, member_loop_);
TraceIfNeeded<double>::Trace(visitor, member_loop_end_);
TraceIfNeeded<double>::Trace(visitor, member_loop_start_);
TraceIfNeeded<float>::Trace(visitor, member_playback_rate_);
bindings::InputDictionaryBase::Trace(visitor);
}

void AudioBufferSourceOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AudioBufferSourceOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("buffer");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<AudioBuffer>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_buffer_, member_buffer_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("detune");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_detune_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("loop");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_loop_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("loopEnd");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_loop_end_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("loopStart");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_loop_start_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("playbackRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_playback_rate_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AudioBufferSourceOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
