// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_node_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"channelCount",
"channelCountMode",
"channelInterpretation",
};


}  // namespace 

AudioNodeOptions* AudioNodeOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AudioNodeOptions* dictionary = MakeGarbageCollected<AudioNodeOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AudioNodeOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AudioNodeOptions::AudioNodeOptions() {
  
}

 AudioNodeOptions::AudioNodeOptions(v8::Isolate* isolate) {
  
}
























void AudioNodeOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_channel_count_);
TraceIfNeeded<V8ChannelCountMode>::Trace(visitor, member_channel_count_mode_);
TraceIfNeeded<V8ChannelInterpretation>::Trace(visitor, member_channel_interpretation_);
bindings::DictionaryBase::Trace(visitor);
}

void AudioNodeOptions::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AudioNodeOptions::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasChannelCount()) {
  values[0] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_channel_count_);
DCHECK(!values[0].IsEmpty());
}
if (hasChannelCountMode()) {
  values[1] = ToV8Traits<V8ChannelCountMode>::ToV8(script_state, member_channel_count_mode_);
DCHECK(!values[1].IsEmpty());
}
if (hasChannelInterpretation()) {
  values[2] = ToV8Traits<V8ChannelInterpretation>::ToV8(script_state, member_channel_interpretation_);
DCHECK(!values[2].IsEmpty());
}
}

const void* AudioNodeOptions::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AudioNodeOptions::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AudioNodeOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AudioNodeOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("channelCount");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_channel_count_, member_channel_count_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("channelCountMode");
if (!bindings::GetDictionaryMemberFromV8Object<V8ChannelCountMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_channel_count_mode_, member_channel_count_mode_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("channelInterpretation");
if (!bindings::GetDictionaryMemberFromV8Object<V8ChannelInterpretation, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_channel_interpretation_, member_channel_interpretation_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AudioNodeOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
