// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_client_outputs.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_large_blob_outputs.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_prf_outputs.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_supplemental_pub_keys_outputs.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_credential_properties_output.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"appid",
"credBlob",
"credProps",
"getCredBlob",
"hmacCreateSecret",
"largeBlob",
"prf",
"supplementalPubKeys",
"uvm",
};


}  // namespace 

AuthenticationExtensionsClientOutputs* AuthenticationExtensionsClientOutputs::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationExtensionsClientOutputs* dictionary = MakeGarbageCollected<AuthenticationExtensionsClientOutputs>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationExtensionsClientOutputs";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AuthenticationExtensionsClientOutputs::AuthenticationExtensionsClientOutputs() {
  
}

 AuthenticationExtensionsClientOutputs::AuthenticationExtensionsClientOutputs(v8::Isolate* isolate) {
  
}



























































Vector<Vector<uint32_t>> AuthenticationExtensionsClientOutputs::getUvmOr(const Vector<Vector<uint32_t>>& fallback_value) const {
  if (!hasUvm()) {
  return fallback_value;
}
return member_uvm_;
}

Vector<Vector<uint32_t>> AuthenticationExtensionsClientOutputs::getUvmOr(Vector<Vector<uint32_t>>&& fallback_value) const {
  if (!hasUvm()) {
  return std::move(fallback_value);
}
return member_uvm_;
}

void AuthenticationExtensionsClientOutputs::setUvm(const Vector<Vector<uint32_t>>& value) {
  member_uvm_ = value;
has_uvm_ = true;
}

void AuthenticationExtensionsClientOutputs::setUvm(Vector<Vector<uint32_t>>&& value) {
  member_uvm_ = std::move(value);
has_uvm_ = true;
}




void AuthenticationExtensionsClientOutputs::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_appid_);
TraceIfNeeded<bool>::Trace(visitor, member_cred_blob_);
TraceIfNeeded<Member<CredentialPropertiesOutput>>::Trace(visitor, member_cred_props_);
TraceIfNeeded<Member<DOMArrayBuffer>>::Trace(visitor, member_get_cred_blob_);
TraceIfNeeded<bool>::Trace(visitor, member_hmac_create_secret_);
TraceIfNeeded<Member<AuthenticationExtensionsLargeBlobOutputs>>::Trace(visitor, member_large_blob_);
TraceIfNeeded<Member<AuthenticationExtensionsPRFOutputs>>::Trace(visitor, member_prf_);
TraceIfNeeded<Member<AuthenticationExtensionsSupplementalPubKeysOutputs>>::Trace(visitor, member_supplemental_pub_keys_);
TraceIfNeeded<Vector<Vector<uint32_t>>>::Trace(visitor, member_uvm_);
bindings::DictionaryBase::Trace(visitor);
}

void AuthenticationExtensionsClientOutputs::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuthenticationExtensionsClientOutputs::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAppid()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_appid_);
DCHECK(!values[0].IsEmpty());
}
if (hasCredBlob()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_cred_blob_);
DCHECK(!values[1].IsEmpty());
}
if (hasCredProps()) {
  values[2] = ToV8Traits<CredentialPropertiesOutput>::ToV8(script_state, member_cred_props_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasGetCredBlob()) {
  values[3] = ToV8Traits<DOMArrayBuffer>::ToV8(script_state, member_get_cred_blob_.Get());
DCHECK(!values[3].IsEmpty());
}
if (hasHmacCreateSecret()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_hmac_create_secret_);
DCHECK(!values[4].IsEmpty());
}
if (RuntimeEnabledFeatures::WebAuthenticationLargeBlobExtensionEnabled()) {
  if (hasLargeBlob()) {
  values[5] = ToV8Traits<AuthenticationExtensionsLargeBlobOutputs>::ToV8(script_state, member_large_blob_.Get());
DCHECK(!values[5].IsEmpty());
}
}
if (RuntimeEnabledFeatures::WebAuthenticationPRFEnabled()) {
  if (hasPrf()) {
  values[6] = ToV8Traits<AuthenticationExtensionsPRFOutputs>::ToV8(script_state, member_prf_.Get());
DCHECK(!values[6].IsEmpty());
}
}
if (RuntimeEnabledFeatures::WebAuthenticationSupplementalPubKeysEnabled()) {
  if (hasSupplementalPubKeys()) {
  values[7] = ToV8Traits<AuthenticationExtensionsSupplementalPubKeysOutputs>::ToV8(script_state, member_supplemental_pub_keys_.Get());
DCHECK(!values[7].IsEmpty());
}
}
if (hasUvm()) {
  values[8] = ToV8Traits<IDLSequence<IDLSequence<IDLUnsignedLong>>>::ToV8(script_state, member_uvm_);
DCHECK(!values[8].IsEmpty());
}
}

const void* AuthenticationExtensionsClientOutputs::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuthenticationExtensionsClientOutputs::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuthenticationExtensionsClientOutputs::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AuthenticationExtensionsClientOutputs";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("appid");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_appid_, member_appid_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("credBlob");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_cred_blob_, member_cred_blob_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("credProps");
if (!bindings::GetDictionaryMemberFromV8Object<CredentialPropertiesOutput, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_cred_props_, member_cred_props_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("getCredBlob");
if (!bindings::GetDictionaryMemberFromV8Object<DOMArrayBuffer, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_get_cred_blob_, member_get_cred_blob_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("hmacCreateSecret");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_hmac_create_secret_, member_hmac_create_secret_, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebAuthenticationLargeBlobExtensionEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("largeBlob");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsLargeBlobOutputs, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_large_blob_, member_large_blob_, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::WebAuthenticationPRFEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("prf");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsPRFOutputs, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_prf_, member_prf_, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::WebAuthenticationSupplementalPubKeysEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("supplementalPubKeys");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsSupplementalPubKeysOutputs, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_supplemental_pub_keys_, member_supplemental_pub_keys_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("uvm");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLSequence<IDLUnsignedLong>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_uvm_, member_uvm_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationExtensionsClientOutputs::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
