// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_prf_inputs.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_prf_values.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"eval",
"evalByCredential",
};


}  // namespace 

AuthenticationExtensionsPRFInputs* AuthenticationExtensionsPRFInputs::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationExtensionsPRFInputs* dictionary = MakeGarbageCollected<AuthenticationExtensionsPRFInputs>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationExtensionsPRFInputs";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AuthenticationExtensionsPRFInputs::AuthenticationExtensionsPRFInputs() {
  
}

 AuthenticationExtensionsPRFInputs::AuthenticationExtensionsPRFInputs(v8::Isolate* isolate) {
  
}










HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>> AuthenticationExtensionsPRFInputs::getEvalByCredentialOr(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>& fallback_value) const {
  if (!hasEvalByCredential()) {
  return fallback_value;
}
return member_eval_by_credential_;
}

HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>> AuthenticationExtensionsPRFInputs::getEvalByCredentialOr(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>&& fallback_value) const {
  if (!hasEvalByCredential()) {
  return std::move(fallback_value);
}
return member_eval_by_credential_;
}

void AuthenticationExtensionsPRFInputs::setEvalByCredential(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>& value) {
  member_eval_by_credential_ = value;
has_eval_by_credential_ = true;
}

void AuthenticationExtensionsPRFInputs::setEvalByCredential(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>&& value) {
  member_eval_by_credential_ = std::move(value);
has_eval_by_credential_ = true;
}




void AuthenticationExtensionsPRFInputs::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<AuthenticationExtensionsPRFValues>>::Trace(visitor, member_eval_);
TraceIfNeeded<HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>>::Trace(visitor, member_eval_by_credential_);
bindings::DictionaryBase::Trace(visitor);
}

void AuthenticationExtensionsPRFInputs::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuthenticationExtensionsPRFInputs::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasEval()) {
  values[0] = ToV8Traits<AuthenticationExtensionsPRFValues>::ToV8(script_state, member_eval_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasEvalByCredential()) {
  values[1] = ToV8Traits<IDLRecord<IDLUSVString, AuthenticationExtensionsPRFValues>>::ToV8(script_state, member_eval_by_credential_);
DCHECK(!values[1].IsEmpty());
}
}

const void* AuthenticationExtensionsPRFInputs::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuthenticationExtensionsPRFInputs::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuthenticationExtensionsPRFInputs::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AuthenticationExtensionsPRFInputs";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("eval");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsPRFValues, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_eval_, member_eval_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("evalByCredential");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, AuthenticationExtensionsPRFValues>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_eval_by_credential_, member_eval_by_credential_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationExtensionsPRFInputs::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
