// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_assertion_response_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"authenticatorData",
"clientDataJSON",
"signature",
"userHandle",
};


}  // namespace 

AuthenticatorAssertionResponseJSON* AuthenticatorAssertionResponseJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticatorAssertionResponseJSON* dictionary = MakeGarbageCollected<AuthenticatorAssertionResponseJSON>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticatorAssertionResponseJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AuthenticatorAssertionResponseJSON::AuthenticatorAssertionResponseJSON() {
  
}

 AuthenticatorAssertionResponseJSON::AuthenticatorAssertionResponseJSON(v8::Isolate* isolate) {
  
}



void AuthenticatorAssertionResponseJSON::setAuthenticatorData(const String& value) {
  member_authenticator_data_ = value;
}

void AuthenticatorAssertionResponseJSON::setAuthenticatorData(String&& value) {
  member_authenticator_data_ = std::move(value);
}




void AuthenticatorAssertionResponseJSON::setClientDataJSON(const String& value) {
  member_client_data_js_on_ = value;
}

void AuthenticatorAssertionResponseJSON::setClientDataJSON(String&& value) {
  member_client_data_js_on_ = std::move(value);
}




void AuthenticatorAssertionResponseJSON::setSignature(const String& value) {
  member_signature_ = value;
}

void AuthenticatorAssertionResponseJSON::setSignature(String&& value) {
  member_signature_ = std::move(value);
}




String AuthenticatorAssertionResponseJSON::getUserHandleOr(const String& fallback_value) const {
  if (!hasUserHandle()) {
  return fallback_value;
}
return member_user_handle_;
}

String AuthenticatorAssertionResponseJSON::getUserHandleOr(String&& fallback_value) const {
  if (!hasUserHandle()) {
  return std::move(fallback_value);
}
return member_user_handle_;
}

void AuthenticatorAssertionResponseJSON::setUserHandle(const String& value) {
  member_user_handle_ = value;
has_user_handle_ = true;
}

void AuthenticatorAssertionResponseJSON::setUserHandle(String&& value) {
  member_user_handle_ = std::move(value);
has_user_handle_ = true;
}




void AuthenticatorAssertionResponseJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_authenticator_data_);
TraceIfNeeded<String>::Trace(visitor, member_client_data_js_on_);
TraceIfNeeded<String>::Trace(visitor, member_signature_);
TraceIfNeeded<String>::Trace(visitor, member_user_handle_);
bindings::DictionaryBase::Trace(visitor);
}

void AuthenticatorAssertionResponseJSON::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuthenticatorAssertionResponseJSON::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAuthenticatorData()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_authenticator_data_);
DCHECK(!values[0].IsEmpty());
}
if (hasClientDataJSON()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_client_data_js_on_);
DCHECK(!values[1].IsEmpty());
}
if (hasSignature()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_signature_);
DCHECK(!values[2].IsEmpty());
}
if (hasUserHandle()) {
  values[3] = ToV8Traits<IDLString>::ToV8(script_state, member_user_handle_);
DCHECK(!values[3].IsEmpty());
}
}

const void* AuthenticatorAssertionResponseJSON::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuthenticatorAssertionResponseJSON::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuthenticatorAssertionResponseJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AuthenticatorAssertionResponseJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("authenticatorData");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_authenticator_data_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientDataJSON");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_client_data_js_on_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signature");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_signature_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userHandle");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_user_handle_, member_user_handle_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticatorAssertionResponseJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
