// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_detected_face.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_landmark.h"
#include "third_party/blink/renderer/core/geometry/dom_rect_read_only.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"boundingBox",
"landmarks",
};


}  // namespace 

DetectedFace* DetectedFace::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DetectedFace* dictionary = MakeGarbageCollected<DetectedFace>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DetectedFace";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 DetectedFace::DetectedFace() {
  
}

 DetectedFace::DetectedFace(v8::Isolate* isolate) {
  
}








void DetectedFace::setLandmarks(const HeapVector<Member<Landmark>>& value) {
  member_landmarks_ = value;
}

void DetectedFace::setLandmarks(HeapVector<Member<Landmark>>&& value) {
  member_landmarks_ = std::move(value);
}




void DetectedFace::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DOMRectReadOnly>>::Trace(visitor, member_bounding_box_);
TraceIfNeeded<HeapVector<Member<Landmark>>>::Trace(visitor, member_landmarks_);
bindings::DictionaryBase::Trace(visitor);
}

void DetectedFace::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void DetectedFace::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasBoundingBox()) {
  values[0] = ToV8Traits<DOMRectReadOnly>::ToV8(script_state, member_bounding_box_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasLandmarks()) {
  values[1] = ToV8Traits<IDLSequence<Landmark>>::ToV8(script_state, member_landmarks_);
DCHECK(!values[1].IsEmpty());
}
}

const void* DetectedFace::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> DetectedFace::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void DetectedFace::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "DetectedFace";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("boundingBox");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<DOMRectReadOnly, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_bounding_box_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("landmarks");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<Landmark>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_landmarks_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DetectedFace::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
