// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_TEXT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_TEXT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class DOMRectReadOnly;
class ExceptionState;
class Point2D;

class MODULES_EXPORT DetectedText : public bindings::DictionaryBase {
  
  public:
static DetectedText* Create() {
  return MakeGarbageCollected<DetectedText>();
}
static DetectedText* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DetectedText>(isolate);
}
static DetectedText* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DetectedText();
explicit  DetectedText(v8::Isolate* isolate);

bool hasBoundingBox() const {
  return true;
}
DOMRectReadOnly* boundingBox() const {
  return member_bounding_box_.Get();
}
void setBoundingBox(DOMRectReadOnly* value) {
  member_bounding_box_ = value;
DCHECK(member_bounding_box_);
}

bool hasCornerPoints() const {
  return true;
}
const HeapVector<Member<Point2D>>& cornerPoints() const {
  return member_corner_points_;
}
void setCornerPoints(const HeapVector<Member<Point2D>>& value);
void setCornerPoints(HeapVector<Member<Point2D>>&& value);

bool hasRawValue() const {
  return true;
}
const String& rawValue() const {
  return member_raw_value_;
}
void setRawValue(const String& value);
void setRawValue(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 3;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Member<DOMRectReadOnly> member_bounding_box_;
HeapVector<Member<Point2D>> member_corner_points_;
String member_raw_value_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DETECTED_TEXT_H_
