// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DISPLAY_MEDIA_STREAM_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DISPLAY_MEDIA_STREAM_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_display_media_include_or_exclude.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class CaptureController;
class ExceptionState;
class MediaTrackConstraints;
class V8UnionBooleanOrMediaTrackConstraints;

class MODULES_EXPORT DisplayMediaStreamOptions : public bindings::InputDictionaryBase {
  
  public:
static DisplayMediaStreamOptions* Create() {
  return MakeGarbageCollected<DisplayMediaStreamOptions>();
}
static DisplayMediaStreamOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DisplayMediaStreamOptions>(isolate);
}
static DisplayMediaStreamOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DisplayMediaStreamOptions();
explicit  DisplayMediaStreamOptions(v8::Isolate* isolate);

bool hasAudio() const {
  return true;
}
V8UnionBooleanOrMediaTrackConstraints* audio() const {
  return member_audio_.Get();
}
void setAudio(V8UnionBooleanOrMediaTrackConstraints* value) {
  member_audio_ = value;
DCHECK(member_audio_);
}

bool hasAutoSelectAllScreens() const {
  return true;
}
bool autoSelectAllScreens() const {
  return member_auto_select_all_screens_;
}
void setAutoSelectAllScreens(bool value) {
  member_auto_select_all_screens_ = value;
}

bool hasController() const {
  return has_controller_;
}
CaptureController* controller() const {
  DCHECK(hasController());
return member_controller_.Get();
}
CaptureController* getControllerOr(CaptureController* fallback_value) const {
  if (!hasController()) {
  return fallback_value;
}
return member_controller_.Get();
}
void setController(CaptureController* value) {
  member_controller_ = value;
has_controller_ = true;
DCHECK(member_controller_);
}

bool hasMonitorTypeSurfaces() const {
  return has_monitor_type_surfaces_;
}
V8DisplayMediaIncludeOrExclude monitorTypeSurfaces() const {
  DCHECK(hasMonitorTypeSurfaces());
return member_monitor_type_surfaces_;
}
V8DisplayMediaIncludeOrExclude getMonitorTypeSurfacesOr(V8DisplayMediaIncludeOrExclude fallback_value) const {
  if (!hasMonitorTypeSurfaces()) {
  return fallback_value;
}
return member_monitor_type_surfaces_;
}
void setMonitorTypeSurfaces(V8DisplayMediaIncludeOrExclude value) {
  member_monitor_type_surfaces_ = value;
has_monitor_type_surfaces_ = true;
}
void setMonitorTypeSurfaces(V8DisplayMediaIncludeOrExclude::Enum value) {
  member_monitor_type_surfaces_ = V8DisplayMediaIncludeOrExclude(value);
has_monitor_type_surfaces_ = true;
}

bool hasPreferCurrentTab() const {
  return true;
}
bool preferCurrentTab() const {
  return member_prefer_current_tab_;
}
void setPreferCurrentTab(bool value) {
  member_prefer_current_tab_ = value;
}

bool hasSelfBrowserSurface() const {
  return has_self_browser_surface_;
}
V8DisplayMediaIncludeOrExclude selfBrowserSurface() const {
  DCHECK(hasSelfBrowserSurface());
return member_self_browser_surface_;
}
V8DisplayMediaIncludeOrExclude getSelfBrowserSurfaceOr(V8DisplayMediaIncludeOrExclude fallback_value) const {
  if (!hasSelfBrowserSurface()) {
  return fallback_value;
}
return member_self_browser_surface_;
}
void setSelfBrowserSurface(V8DisplayMediaIncludeOrExclude value) {
  member_self_browser_surface_ = value;
has_self_browser_surface_ = true;
}
void setSelfBrowserSurface(V8DisplayMediaIncludeOrExclude::Enum value) {
  member_self_browser_surface_ = V8DisplayMediaIncludeOrExclude(value);
has_self_browser_surface_ = true;
}

bool hasSurfaceSwitching() const {
  return has_surface_switching_;
}
V8DisplayMediaIncludeOrExclude surfaceSwitching() const {
  DCHECK(hasSurfaceSwitching());
return member_surface_switching_;
}
V8DisplayMediaIncludeOrExclude getSurfaceSwitchingOr(V8DisplayMediaIncludeOrExclude fallback_value) const {
  if (!hasSurfaceSwitching()) {
  return fallback_value;
}
return member_surface_switching_;
}
void setSurfaceSwitching(V8DisplayMediaIncludeOrExclude value) {
  member_surface_switching_ = value;
has_surface_switching_ = true;
}
void setSurfaceSwitching(V8DisplayMediaIncludeOrExclude::Enum value) {
  member_surface_switching_ = V8DisplayMediaIncludeOrExclude(value);
has_surface_switching_ = true;
}

bool hasSystemAudio() const {
  return has_system_audio_;
}
V8DisplayMediaIncludeOrExclude systemAudio() const {
  DCHECK(hasSystemAudio());
return member_system_audio_;
}
V8DisplayMediaIncludeOrExclude getSystemAudioOr(V8DisplayMediaIncludeOrExclude fallback_value) const {
  if (!hasSystemAudio()) {
  return fallback_value;
}
return member_system_audio_;
}
void setSystemAudio(V8DisplayMediaIncludeOrExclude value) {
  member_system_audio_ = value;
has_system_audio_ = true;
}
void setSystemAudio(V8DisplayMediaIncludeOrExclude::Enum value) {
  member_system_audio_ = V8DisplayMediaIncludeOrExclude(value);
has_system_audio_ = true;
}

bool hasVideo() const {
  return true;
}
V8UnionBooleanOrMediaTrackConstraints* video() const {
  return member_video_.Get();
}
void setVideo(V8UnionBooleanOrMediaTrackConstraints* value) {
  member_video_ = value;
DCHECK(member_video_);
}


// Obsolete accessor functions
void setMonitorTypeSurfaces(const String& value) {
  member_monitor_type_surfaces_ = V8DisplayMediaIncludeOrExclude::Create(value).value();
has_monitor_type_surfaces_ = true;
}
void setSelfBrowserSurface(const String& value) {
  member_self_browser_surface_ = V8DisplayMediaIncludeOrExclude::Create(value).value();
has_self_browser_surface_ = true;
}
void setSurfaceSwitching(const String& value) {
  member_surface_switching_ = V8DisplayMediaIncludeOrExclude::Create(value).value();
has_surface_switching_ = true;
}
void setSystemAudio(const String& value) {
  member_system_audio_ = V8DisplayMediaIncludeOrExclude::Create(value).value();
has_system_audio_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 9;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_controller_ = false;
bool has_monitor_type_surfaces_ = false;
bool has_self_browser_surface_ = false;
bool has_surface_switching_ = false;
bool has_system_audio_ = false;

Member<V8UnionBooleanOrMediaTrackConstraints> member_audio_;
bool member_auto_select_all_screens_{false};
Member<CaptureController> member_controller_;
V8DisplayMediaIncludeOrExclude member_monitor_type_surfaces_{static_cast<V8DisplayMediaIncludeOrExclude::Enum>(0)};
bool member_prefer_current_tab_{false};
V8DisplayMediaIncludeOrExclude member_self_browser_surface_{static_cast<V8DisplayMediaIncludeOrExclude::Enum>(0)};
V8DisplayMediaIncludeOrExclude member_surface_switching_{static_cast<V8DisplayMediaIncludeOrExclude::Enum>(0)};
V8DisplayMediaIncludeOrExclude member_system_audio_{static_cast<V8DisplayMediaIncludeOrExclude::Enum>(0)};
Member<V8UnionBooleanOrMediaTrackConstraints> member_video_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DISPLAY_MEDIA_STREAM_OPTIONS_H_
