// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_canvas_configuration.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_canvas_high_dynamic_range_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_canvas_tone_mapping.h"
#include "third_party/blink/renderer/modules/webgpu/gpu_device.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"alphaMode",
"colorSpace",
"device",
"format",
"hdrOptions",
"toneMapping",
"usage",
"viewFormats",
};


}  // namespace 

GPUCanvasConfiguration* GPUCanvasConfiguration::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUCanvasConfiguration* dictionary = MakeGarbageCollected<GPUCanvasConfiguration>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUCanvasConfiguration";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUCanvasConfiguration::GPUCanvasConfiguration() : member_tone_mapping_(GPUCanvasToneMapping::Create()) {
  
}

 GPUCanvasConfiguration::GPUCanvasConfiguration(v8::Isolate* isolate) : member_tone_mapping_(GPUCanvasToneMapping::Create()) {
  
}








































void GPUCanvasConfiguration::setViewFormats(const Vector<V8GPUTextureFormat>& value) {
  member_view_formats_ = value;
}

void GPUCanvasConfiguration::setViewFormats(Vector<V8GPUTextureFormat>&& value) {
  member_view_formats_ = std::move(value);
}




void GPUCanvasConfiguration::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8GPUCanvasAlphaMode>::Trace(visitor, member_alpha_mode_);
TraceIfNeeded<V8PredefinedColorSpace>::Trace(visitor, member_color_space_);
TraceIfNeeded<Member<GPUDevice>>::Trace(visitor, member_device_);
TraceIfNeeded<V8GPUTextureFormat>::Trace(visitor, member_format_);
TraceIfNeeded<Member<CanvasHighDynamicRangeOptions>>::Trace(visitor, member_hdr_options_);
TraceIfNeeded<Member<GPUCanvasToneMapping>>::Trace(visitor, member_tone_mapping_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_usage_);
TraceIfNeeded<Vector<V8GPUTextureFormat>>::Trace(visitor, member_view_formats_);
bindings::InputDictionaryBase::Trace(visitor);
}

void GPUCanvasConfiguration::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPUCanvasConfiguration";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("alphaMode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUCanvasAlphaMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_alpha_mode_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("colorSpace");
if (!bindings::GetDictionaryMemberFromV8Object<V8PredefinedColorSpace, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_color_space_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("device");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<GPUDevice, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_device_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("format");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureFormat, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_format_, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::CanvasHDREnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("hdrOptions");
if (!bindings::GetDictionaryMemberFromV8Object<CanvasHighDynamicRangeOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_hdr_options_, member_hdr_options_, exception_state)) {
  return;
}
}
if (RuntimeEnabledFeatures::WebGPUHDREnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("toneMapping");
if (!bindings::GetDictionaryMemberFromV8Object<GPUCanvasToneMapping, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_tone_mapping_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("usage");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_usage_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("viewFormats");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8GPUTextureFormat>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_view_formats_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUCanvasConfiguration::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
