// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_image_copy_external_image.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_origin_2d_dict.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_gpuorigin2ddict_unsignedlongenforcerangesequence.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_htmlcanvaselement_htmlimageelement_htmlvideoelement_imagebitmap_imagedata_offscreencanvas_videoframe.h"
#include "third_party/blink/renderer/core/html/canvas/html_canvas_element.h"
#include "third_party/blink/renderer/core/html/canvas/image_data.h"
#include "third_party/blink/renderer/core/html/html_image_element.h"
#include "third_party/blink/renderer/core/html/media/html_video_element.h"
#include "third_party/blink/renderer/core/imagebitmap/image_bitmap.h"
#include "third_party/blink/renderer/core/offscreencanvas/offscreen_canvas.h"
#include "third_party/blink/renderer/modules/webcodecs/video_frame.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"flipY",
"origin",
"source",
};


}  // namespace 

GPUImageCopyExternalImage* GPUImageCopyExternalImage::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUImageCopyExternalImage* dictionary = MakeGarbageCollected<GPUImageCopyExternalImage>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUImageCopyExternalImage";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUImageCopyExternalImage::GPUImageCopyExternalImage() : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin2DDict::Create())) {
  
}

 GPUImageCopyExternalImage::GPUImageCopyExternalImage(v8::Isolate* isolate) : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin2DDict::Create())) {
  
}


















void GPUImageCopyExternalImage::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_flip_y_);
TraceIfNeeded<Member<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>>::Trace(visitor, member_origin_);
TraceIfNeeded<Member<V8UnionHTMLCanvasElementOrHTMLImageElementOrHTMLVideoElementOrImageBitmapOrImageDataOrOffscreenCanvasOrVideoFrame>>::Trace(visitor, member_source_);
bindings::InputDictionaryBase::Trace(visitor);
}

void GPUImageCopyExternalImage::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPUImageCopyExternalImage";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("flipY");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_flip_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("origin");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_origin_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("source");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionHTMLCanvasElementOrHTMLImageElementOrHTMLVideoElementOrImageBitmapOrImageDataOrOffscreenCanvasOrVideoFrame, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_source_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUImageCopyExternalImage::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
