// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_image_copy_texture.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_origin_3d_dict.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_gpuorigin3ddict_unsignedlongenforcerangesequence.h"
#include "third_party/blink/renderer/modules/webgpu/gpu_texture.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"aspect",
"mipLevel",
"origin",
"texture",
};


}  // namespace 

GPUImageCopyTexture* GPUImageCopyTexture::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUImageCopyTexture* dictionary = MakeGarbageCollected<GPUImageCopyTexture>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUImageCopyTexture";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUImageCopyTexture::GPUImageCopyTexture() : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin3DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin3DDict::Create())) {
  
}

 GPUImageCopyTexture::GPUImageCopyTexture(v8::Isolate* isolate) : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin3DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin3DDict::Create())) {
  
}























void GPUImageCopyTexture::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8GPUTextureAspect>::Trace(visitor, member_aspect_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_mip_level_);
TraceIfNeeded<Member<V8UnionGPUOrigin3DDictOrUnsignedLongEnforceRangeSequence>>::Trace(visitor, member_origin_);
TraceIfNeeded<Member<GPUTexture>>::Trace(visitor, member_texture_);
bindings::InputDictionaryBase::Trace(visitor);
}

void GPUImageCopyTexture::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPUImageCopyTexture";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("aspect");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUTextureAspect, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_aspect_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mipLevel");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_mip_level_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("origin");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionGPUOrigin3DDictOrUnsignedLongEnforceRangeSequence, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_origin_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("texture");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<GPUTexture, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_texture_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUImageCopyTexture::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
