// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_primitive_state.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"cullMode",
"frontFace",
"stripIndexFormat",
"topology",
"unclippedDepth",
};


}  // namespace 

GPUPrimitiveState* GPUPrimitiveState::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUPrimitiveState* dictionary = MakeGarbageCollected<GPUPrimitiveState>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUPrimitiveState";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUPrimitiveState::GPUPrimitiveState() {
  
}

 GPUPrimitiveState::GPUPrimitiveState(v8::Isolate* isolate) {
  
}






























void GPUPrimitiveState::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8GPUCullMode>::Trace(visitor, member_cull_mode_);
TraceIfNeeded<V8GPUFrontFace>::Trace(visitor, member_front_face_);
TraceIfNeeded<V8GPUIndexFormat>::Trace(visitor, member_strip_index_format_);
TraceIfNeeded<V8GPUPrimitiveTopology>::Trace(visitor, member_topology_);
TraceIfNeeded<bool>::Trace(visitor, member_unclipped_depth_);
bindings::InputDictionaryBase::Trace(visitor);
}

void GPUPrimitiveState::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPUPrimitiveState";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("cullMode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUCullMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_cull_mode_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frontFace");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUFrontFace, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_front_face_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stripIndexFormat");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUIndexFormat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_strip_index_format_, member_strip_index_format_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("topology");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUPrimitiveTopology, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_topology_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("unclippedDepth");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_unclipped_depth_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUPrimitiveState::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
