// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_shader_module_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_shader_module_compilation_hint.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"code",
"compilationHints",
};


}  // namespace 

GPUShaderModuleDescriptor* GPUShaderModuleDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUShaderModuleDescriptor* dictionary = MakeGarbageCollected<GPUShaderModuleDescriptor>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUShaderModuleDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUShaderModuleDescriptor::GPUShaderModuleDescriptor() {
  
}

 GPUShaderModuleDescriptor::GPUShaderModuleDescriptor(v8::Isolate* isolate) : GPUObjectDescriptorBase(isolate) {
  
}



void GPUShaderModuleDescriptor::setCode(const String& value) {
  member_code_ = value;
}

void GPUShaderModuleDescriptor::setCode(String&& value) {
  member_code_ = std::move(value);
}




void GPUShaderModuleDescriptor::setCompilationHints(const HeapVector<Member<GPUShaderModuleCompilationHint>>& value) {
  member_compilation_hints_ = value;
}

void GPUShaderModuleDescriptor::setCompilationHints(HeapVector<Member<GPUShaderModuleCompilationHint>>&& value) {
  member_compilation_hints_ = std::move(value);
}




void GPUShaderModuleDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_code_);
TraceIfNeeded<HeapVector<Member<GPUShaderModuleCompilationHint>>>::Trace(visitor, member_compilation_hints_);
GPUObjectDescriptorBase::Trace(visitor);
}

void GPUShaderModuleDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
GPUObjectDescriptorBase::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "GPUShaderModuleDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("code");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_code_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("compilationHints");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<GPUShaderModuleCompilationHint>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_compilation_hints_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUShaderModuleDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
