// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_provider_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_standard_claims.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"claims",
"context",
"mediation",
"mode",
"providers",
};


}  // namespace 

IdentityCredentialRequestOptions* IdentityCredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IdentityCredentialRequestOptions* dictionary = MakeGarbageCollected<IdentityCredentialRequestOptions>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IdentityCredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 IdentityCredentialRequestOptions::IdentityCredentialRequestOptions() {
  
}

 IdentityCredentialRequestOptions::IdentityCredentialRequestOptions(v8::Isolate* isolate) {
  
}















String IdentityCredentialRequestOptions::getMediationOr(const String& fallback_value) const {
  if (!hasMediation()) {
  return fallback_value;
}
return member_mediation_;
}

String IdentityCredentialRequestOptions::getMediationOr(String&& fallback_value) const {
  if (!hasMediation()) {
  return std::move(fallback_value);
}
return member_mediation_;
}

void IdentityCredentialRequestOptions::setMediation(const String& value) {
  member_mediation_ = value;
has_mediation_ = true;
}

void IdentityCredentialRequestOptions::setMediation(String&& value) {
  member_mediation_ = std::move(value);
has_mediation_ = true;
}









void IdentityCredentialRequestOptions::setProviders(const HeapVector<Member<IdentityProviderRequestOptions>>& value) {
  member_providers_ = value;
}

void IdentityCredentialRequestOptions::setProviders(HeapVector<Member<IdentityProviderRequestOptions>>&& value) {
  member_providers_ = std::move(value);
}




void IdentityCredentialRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<IdentityStandardClaims>>::Trace(visitor, member_claims_);
TraceIfNeeded<V8IdentityCredentialRequestOptionsContext>::Trace(visitor, member_context_);
TraceIfNeeded<String>::Trace(visitor, member_mediation_);
TraceIfNeeded<V8IdentityCredentialRequestOptionsMode>::Trace(visitor, member_mode_);
TraceIfNeeded<HeapVector<Member<IdentityProviderRequestOptions>>>::Trace(visitor, member_providers_);
bindings::InputDictionaryBase::Trace(visitor);
}

void IdentityCredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "IdentityCredentialRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (RuntimeEnabledFeatures::FedCmSelectiveDisclosureEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("claims");
if (!bindings::GetDictionaryMemberFromV8Object<IdentityStandardClaims, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_claims_, member_claims_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("context");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8IdentityCredentialRequestOptionsContext, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_context_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_mediation_, member_mediation_, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::FedCmButtonModeEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
if (!bindings::GetDictionaryMemberFromV8Object<V8IdentityCredentialRequestOptionsMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_mode_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("providers");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IdentityProviderRequestOptions>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_providers_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> IdentityCredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
