// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_lock_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clientId",
"mode",
"name",
};


}  // namespace 

LockInfo* LockInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  LockInfo* dictionary = MakeGarbageCollected<LockInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "LockInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 LockInfo::LockInfo() {
  
}

 LockInfo::LockInfo(v8::Isolate* isolate) {
  
}



String LockInfo::getClientIdOr(const String& fallback_value) const {
  if (!hasClientId()) {
  return fallback_value;
}
return member_client_id_;
}

String LockInfo::getClientIdOr(String&& fallback_value) const {
  if (!hasClientId()) {
  return std::move(fallback_value);
}
return member_client_id_;
}

void LockInfo::setClientId(const String& value) {
  member_client_id_ = value;
has_client_id_ = true;
}

void LockInfo::setClientId(String&& value) {
  member_client_id_ = std::move(value);
has_client_id_ = true;
}











String LockInfo::getNameOr(const String& fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_;
}

String LockInfo::getNameOr(String&& fallback_value) const {
  if (!hasName()) {
  return std::move(fallback_value);
}
return member_name_;
}

void LockInfo::setName(const String& value) {
  member_name_ = value;
has_name_ = true;
}

void LockInfo::setName(String&& value) {
  member_name_ = std::move(value);
has_name_ = true;
}




void LockInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_client_id_);
TraceIfNeeded<V8LockMode>::Trace(visitor, member_mode_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
bindings::DictionaryBase::Trace(visitor);
}

void LockInfo::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void LockInfo::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasClientId()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_client_id_);
DCHECK(!values[0].IsEmpty());
}
if (hasMode()) {
  values[1] = ToV8Traits<V8LockMode>::ToV8(script_state, member_mode_);
DCHECK(!values[1].IsEmpty());
}
if (hasName()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_name_);
DCHECK(!values[2].IsEmpty());
}
}

const void* LockInfo::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> LockInfo::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void LockInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "LockInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientId");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_client_id_, member_client_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
if (!bindings::GetDictionaryMemberFromV8Object<V8LockMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_mode_, member_mode_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_name_, member_name_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> LockInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
