// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_CAPABILITIES_DECODING_INFO_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_CAPABILITIES_DECODING_INFO_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_capabilities_info.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MediaKeySystemAccess;

class MODULES_EXPORT MediaCapabilitiesDecodingInfo : public MediaCapabilitiesInfo {
  
  public:
static MediaCapabilitiesDecodingInfo* Create() {
  return MakeGarbageCollected<MediaCapabilitiesDecodingInfo>();
}
static MediaCapabilitiesDecodingInfo* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MediaCapabilitiesDecodingInfo>(isolate);
}
static MediaCapabilitiesDecodingInfo* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MediaCapabilitiesDecodingInfo();
explicit  MediaCapabilitiesDecodingInfo(v8::Isolate* isolate);

bool hasKeySystemAccess() const {
  return true;
}
MediaKeySystemAccess* keySystemAccess() const {
  return member_key_system_access_.Get();
}
void setKeySystemAccess(MediaKeySystemAccess* value) {
  member_key_system_access_ = value;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = MediaCapabilitiesInfo::kTotalPropertyCount;
static constexpr size_t kOwnPropertyCount = 1;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Member<MediaKeySystemAccess> member_key_system_access_{nullptr};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_CAPABILITIES_DECODING_INFO_H_
