// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_BATCH_NORMALIZATION_SUPPORT_LIMITS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_BATCH_NORMALIZATION_SUPPORT_LIMITS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MLSupportLimits;

class MODULES_EXPORT MLBatchNormalizationSupportLimits : public bindings::DictionaryBase {
  
  public:
static MLBatchNormalizationSupportLimits* Create() {
  return MakeGarbageCollected<MLBatchNormalizationSupportLimits>();
}
static MLBatchNormalizationSupportLimits* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLBatchNormalizationSupportLimits>(isolate);
}
static MLBatchNormalizationSupportLimits* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLBatchNormalizationSupportLimits();
explicit  MLBatchNormalizationSupportLimits(v8::Isolate* isolate);

bool hasBias() const {
  return has_bias_;
}
MLSupportLimits* bias() const {
  DCHECK(hasBias());
return member_bias_.Get();
}
MLSupportLimits* getBiasOr(MLSupportLimits* fallback_value) const {
  if (!hasBias()) {
  return fallback_value;
}
return member_bias_.Get();
}
void setBias(MLSupportLimits* value) {
  member_bias_ = value;
has_bias_ = true;
DCHECK(member_bias_);
}

bool hasInput() const {
  return has_input_;
}
MLSupportLimits* input() const {
  DCHECK(hasInput());
return member_input_.Get();
}
MLSupportLimits* getInputOr(MLSupportLimits* fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_.Get();
}
void setInput(MLSupportLimits* value) {
  member_input_ = value;
has_input_ = true;
DCHECK(member_input_);
}

bool hasMean() const {
  return has_mean_;
}
MLSupportLimits* mean() const {
  DCHECK(hasMean());
return member_mean_.Get();
}
MLSupportLimits* getMeanOr(MLSupportLimits* fallback_value) const {
  if (!hasMean()) {
  return fallback_value;
}
return member_mean_.Get();
}
void setMean(MLSupportLimits* value) {
  member_mean_ = value;
has_mean_ = true;
DCHECK(member_mean_);
}

bool hasOutput() const {
  return has_output_;
}
MLSupportLimits* output() const {
  DCHECK(hasOutput());
return member_output_.Get();
}
MLSupportLimits* getOutputOr(MLSupportLimits* fallback_value) const {
  if (!hasOutput()) {
  return fallback_value;
}
return member_output_.Get();
}
void setOutput(MLSupportLimits* value) {
  member_output_ = value;
has_output_ = true;
DCHECK(member_output_);
}

bool hasScale() const {
  return has_scale_;
}
MLSupportLimits* scale() const {
  DCHECK(hasScale());
return member_scale_.Get();
}
MLSupportLimits* getScaleOr(MLSupportLimits* fallback_value) const {
  if (!hasScale()) {
  return fallback_value;
}
return member_scale_.Get();
}
void setScale(MLSupportLimits* value) {
  member_scale_ = value;
has_scale_ = true;
DCHECK(member_scale_);
}

bool hasVariance() const {
  return has_variance_;
}
MLSupportLimits* variance() const {
  DCHECK(hasVariance());
return member_variance_.Get();
}
MLSupportLimits* getVarianceOr(MLSupportLimits* fallback_value) const {
  if (!hasVariance()) {
  return fallback_value;
}
return member_variance_.Get();
}
void setVariance(MLSupportLimits* value) {
  member_variance_ = value;
has_variance_ = true;
DCHECK(member_variance_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 6;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_bias_ = false;
bool has_input_ = false;
bool has_mean_ = false;
bool has_output_ = false;
bool has_scale_ = false;
bool has_variance_ = false;

Member<MLSupportLimits> member_bias_;
Member<MLSupportLimits> member_input_;
Member<MLSupportLimits> member_mean_;
Member<MLSupportLimits> member_output_;
Member<MLSupportLimits> member_scale_;
Member<MLSupportLimits> member_variance_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_BATCH_NORMALIZATION_SUPPORT_LIMITS_H_
