// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_COMPUTE_RESULT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_COMPUTE_RESULT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MLComputeResult : public bindings::DictionaryBase {
  
  public:
static MLComputeResult* Create() {
  return MakeGarbageCollected<MLComputeResult>();
}
static MLComputeResult* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLComputeResult>(isolate);
}
static MLComputeResult* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLComputeResult();
explicit  MLComputeResult(v8::Isolate* isolate);

bool hasInputs() const {
  return has_inputs_;
}
const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& inputs() const {
  DCHECK(hasInputs());
return member_inputs_;
}
HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> getInputsOr(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& fallback_value) const;
HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> getInputsOr(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& fallback_value) const;
void setInputs(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& value);
void setInputs(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& value);

bool hasOutputs() const {
  return has_outputs_;
}
const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& outputs() const {
  DCHECK(hasOutputs());
return member_outputs_;
}
HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> getOutputsOr(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& fallback_value) const;
HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> getOutputsOr(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& fallback_value) const;
void setOutputs(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& value);
void setOutputs(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_inputs_ = false;
bool has_outputs_ = false;

HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> member_inputs_;
HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> member_outputs_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_COMPUTE_RESULT_H_
