// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_conv_2d_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/ml/webnn/ml_operand.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"bias",
"dilations",
"filterLayout",
"groups",
"inputLayout",
"padding",
"strides",
};


}  // namespace 

MLConv2dOptions* MLConv2dOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLConv2dOptions* dictionary = MakeGarbageCollected<MLConv2dOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLConv2dOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MLConv2dOptions::MLConv2dOptions() {
  
}

 MLConv2dOptions::MLConv2dOptions(v8::Isolate* isolate) : MLOperatorOptions(isolate) {
  
}










Vector<uint32_t> MLConv2dOptions::getDilationsOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasDilations()) {
  return fallback_value;
}
return member_dilations_;
}

Vector<uint32_t> MLConv2dOptions::getDilationsOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasDilations()) {
  return std::move(fallback_value);
}
return member_dilations_;
}

void MLConv2dOptions::setDilations(const Vector<uint32_t>& value) {
  member_dilations_ = value;
has_dilations_ = true;
}

void MLConv2dOptions::setDilations(Vector<uint32_t>&& value) {
  member_dilations_ = std::move(value);
has_dilations_ = true;
}



















Vector<uint32_t> MLConv2dOptions::getPaddingOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasPadding()) {
  return fallback_value;
}
return member_padding_;
}

Vector<uint32_t> MLConv2dOptions::getPaddingOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasPadding()) {
  return std::move(fallback_value);
}
return member_padding_;
}

void MLConv2dOptions::setPadding(const Vector<uint32_t>& value) {
  member_padding_ = value;
has_padding_ = true;
}

void MLConv2dOptions::setPadding(Vector<uint32_t>&& value) {
  member_padding_ = std::move(value);
has_padding_ = true;
}




Vector<uint32_t> MLConv2dOptions::getStridesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasStrides()) {
  return fallback_value;
}
return member_strides_;
}

Vector<uint32_t> MLConv2dOptions::getStridesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasStrides()) {
  return std::move(fallback_value);
}
return member_strides_;
}

void MLConv2dOptions::setStrides(const Vector<uint32_t>& value) {
  member_strides_ = value;
has_strides_ = true;
}

void MLConv2dOptions::setStrides(Vector<uint32_t>&& value) {
  member_strides_ = std::move(value);
has_strides_ = true;
}




void MLConv2dOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MLOperand>>::Trace(visitor, member_bias_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_dilations_);
TraceIfNeeded<V8MLConv2dFilterOperandLayout>::Trace(visitor, member_filter_layout_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_groups_);
TraceIfNeeded<V8MLInputOperandLayout>::Trace(visitor, member_input_layout_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_padding_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_strides_);
MLOperatorOptions::Trace(visitor);
}

void MLConv2dOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
MLOperatorOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "MLConv2dOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MLOperand, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_bias_, member_bias_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dilations");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_dilations_, member_dilations_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filterLayout");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8MLConv2dFilterOperandLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_filter_layout_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("groups");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_groups_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inputLayout");
if (!bindings::GetDictionaryMemberFromV8Object<V8MLInputOperandLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_input_layout_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("padding");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_padding_, member_padding_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("strides");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_strides_, member_strides_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLConv2dOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
