// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_CONV_2D_SUPPORT_LIMITS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_CONV_2D_SUPPORT_LIMITS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MLSupportLimits;

class MODULES_EXPORT MLConv2dSupportLimits : public bindings::DictionaryBase {
  
  public:
static MLConv2dSupportLimits* Create() {
  return MakeGarbageCollected<MLConv2dSupportLimits>();
}
static MLConv2dSupportLimits* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLConv2dSupportLimits>(isolate);
}
static MLConv2dSupportLimits* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLConv2dSupportLimits();
explicit  MLConv2dSupportLimits(v8::Isolate* isolate);

bool hasBias() const {
  return has_bias_;
}
MLSupportLimits* bias() const {
  DCHECK(hasBias());
return member_bias_.Get();
}
MLSupportLimits* getBiasOr(MLSupportLimits* fallback_value) const {
  if (!hasBias()) {
  return fallback_value;
}
return member_bias_.Get();
}
void setBias(MLSupportLimits* value) {
  member_bias_ = value;
has_bias_ = true;
DCHECK(member_bias_);
}

bool hasFilter() const {
  return has_filter_;
}
MLSupportLimits* filter() const {
  DCHECK(hasFilter());
return member_filter_.Get();
}
MLSupportLimits* getFilterOr(MLSupportLimits* fallback_value) const {
  if (!hasFilter()) {
  return fallback_value;
}
return member_filter_.Get();
}
void setFilter(MLSupportLimits* value) {
  member_filter_ = value;
has_filter_ = true;
DCHECK(member_filter_);
}

bool hasInput() const {
  return has_input_;
}
MLSupportLimits* input() const {
  DCHECK(hasInput());
return member_input_.Get();
}
MLSupportLimits* getInputOr(MLSupportLimits* fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_.Get();
}
void setInput(MLSupportLimits* value) {
  member_input_ = value;
has_input_ = true;
DCHECK(member_input_);
}

bool hasOutput() const {
  return has_output_;
}
MLSupportLimits* output() const {
  DCHECK(hasOutput());
return member_output_.Get();
}
MLSupportLimits* getOutputOr(MLSupportLimits* fallback_value) const {
  if (!hasOutput()) {
  return fallback_value;
}
return member_output_.Get();
}
void setOutput(MLSupportLimits* value) {
  member_output_ = value;
has_output_ = true;
DCHECK(member_output_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 4;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_bias_ = false;
bool has_filter_ = false;
bool has_input_ = false;
bool has_output_ = false;

Member<MLSupportLimits> member_bias_;
Member<MLSupportLimits> member_filter_;
Member<MLSupportLimits> member_input_;
Member<MLSupportLimits> member_output_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_CONV_2D_SUPPORT_LIMITS_H_
