// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_gemm_support_limits.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_support_limits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"a",
"b",
"c",
"output",
};


}  // namespace 

MLGemmSupportLimits* MLGemmSupportLimits::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLGemmSupportLimits* dictionary = MakeGarbageCollected<MLGemmSupportLimits>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLGemmSupportLimits";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MLGemmSupportLimits::MLGemmSupportLimits() {
  
}

 MLGemmSupportLimits::MLGemmSupportLimits(v8::Isolate* isolate) {
  
}































void MLGemmSupportLimits::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_a_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_b_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_c_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_output_);
bindings::DictionaryBase::Trace(visitor);
}

void MLGemmSupportLimits::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLGemmSupportLimits::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasA()) {
  values[0] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_a_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasB()) {
  values[1] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_b_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasC()) {
  values[2] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_c_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasOutput()) {
  values[3] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_output_.Get());
DCHECK(!values[3].IsEmpty());
}
}

const void* MLGemmSupportLimits::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLGemmSupportLimits::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLGemmSupportLimits::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "MLGemmSupportLimits";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("a");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_a_, member_a_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("b");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_b_, member_b_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("c");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_c_, member_c_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("output");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_output_, member_output_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLGemmSupportLimits::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
