// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_GRU_CELL_SUPPORT_LIMITS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_GRU_CELL_SUPPORT_LIMITS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MLSupportLimits;

class MODULES_EXPORT MLGruCellSupportLimits : public bindings::DictionaryBase {
  
  public:
static MLGruCellSupportLimits* Create() {
  return MakeGarbageCollected<MLGruCellSupportLimits>();
}
static MLGruCellSupportLimits* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLGruCellSupportLimits>(isolate);
}
static MLGruCellSupportLimits* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLGruCellSupportLimits();
explicit  MLGruCellSupportLimits(v8::Isolate* isolate);

bool hasBias() const {
  return has_bias_;
}
MLSupportLimits* bias() const {
  DCHECK(hasBias());
return member_bias_.Get();
}
MLSupportLimits* getBiasOr(MLSupportLimits* fallback_value) const {
  if (!hasBias()) {
  return fallback_value;
}
return member_bias_.Get();
}
void setBias(MLSupportLimits* value) {
  member_bias_ = value;
has_bias_ = true;
DCHECK(member_bias_);
}

bool hasHiddenState() const {
  return has_hidden_state_;
}
MLSupportLimits* hiddenState() const {
  DCHECK(hasHiddenState());
return member_hidden_state_.Get();
}
MLSupportLimits* getHiddenStateOr(MLSupportLimits* fallback_value) const {
  if (!hasHiddenState()) {
  return fallback_value;
}
return member_hidden_state_.Get();
}
void setHiddenState(MLSupportLimits* value) {
  member_hidden_state_ = value;
has_hidden_state_ = true;
DCHECK(member_hidden_state_);
}

bool hasInput() const {
  return has_input_;
}
MLSupportLimits* input() const {
  DCHECK(hasInput());
return member_input_.Get();
}
MLSupportLimits* getInputOr(MLSupportLimits* fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_.Get();
}
void setInput(MLSupportLimits* value) {
  member_input_ = value;
has_input_ = true;
DCHECK(member_input_);
}

bool hasOutput() const {
  return has_output_;
}
MLSupportLimits* output() const {
  DCHECK(hasOutput());
return member_output_.Get();
}
MLSupportLimits* getOutputOr(MLSupportLimits* fallback_value) const {
  if (!hasOutput()) {
  return fallback_value;
}
return member_output_.Get();
}
void setOutput(MLSupportLimits* value) {
  member_output_ = value;
has_output_ = true;
DCHECK(member_output_);
}

bool hasRecurrentBias() const {
  return has_recurrent_bias_;
}
MLSupportLimits* recurrentBias() const {
  DCHECK(hasRecurrentBias());
return member_recurrent_bias_.Get();
}
MLSupportLimits* getRecurrentBiasOr(MLSupportLimits* fallback_value) const {
  if (!hasRecurrentBias()) {
  return fallback_value;
}
return member_recurrent_bias_.Get();
}
void setRecurrentBias(MLSupportLimits* value) {
  member_recurrent_bias_ = value;
has_recurrent_bias_ = true;
DCHECK(member_recurrent_bias_);
}

bool hasRecurrentWeight() const {
  return has_recurrent_weight_;
}
MLSupportLimits* recurrentWeight() const {
  DCHECK(hasRecurrentWeight());
return member_recurrent_weight_.Get();
}
MLSupportLimits* getRecurrentWeightOr(MLSupportLimits* fallback_value) const {
  if (!hasRecurrentWeight()) {
  return fallback_value;
}
return member_recurrent_weight_.Get();
}
void setRecurrentWeight(MLSupportLimits* value) {
  member_recurrent_weight_ = value;
has_recurrent_weight_ = true;
DCHECK(member_recurrent_weight_);
}

bool hasWeight() const {
  return has_weight_;
}
MLSupportLimits* weight() const {
  DCHECK(hasWeight());
return member_weight_.Get();
}
MLSupportLimits* getWeightOr(MLSupportLimits* fallback_value) const {
  if (!hasWeight()) {
  return fallback_value;
}
return member_weight_.Get();
}
void setWeight(MLSupportLimits* value) {
  member_weight_ = value;
has_weight_ = true;
DCHECK(member_weight_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 7;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_bias_ = false;
bool has_hidden_state_ = false;
bool has_input_ = false;
bool has_output_ = false;
bool has_recurrent_bias_ = false;
bool has_recurrent_weight_ = false;
bool has_weight_ = false;

Member<MLSupportLimits> member_bias_;
Member<MLSupportLimits> member_hidden_state_;
Member<MLSupportLimits> member_input_;
Member<MLSupportLimits> member_output_;
Member<MLSupportLimits> member_recurrent_bias_;
Member<MLSupportLimits> member_recurrent_weight_;
Member<MLSupportLimits> member_weight_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_GRU_CELL_SUPPORT_LIMITS_H_
