// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_lstm_support_limits.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_support_limits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"bias",
"initialCellState",
"initialHiddenState",
"input",
"outputs",
"peepholeWeight",
"recurrentBias",
"recurrentWeight",
"weight",
};


}  // namespace 

MLLstmSupportLimits* MLLstmSupportLimits::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLLstmSupportLimits* dictionary = MakeGarbageCollected<MLLstmSupportLimits>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLLstmSupportLimits";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MLLstmSupportLimits::MLLstmSupportLimits() {
  
}

 MLLstmSupportLimits::MLLstmSupportLimits(v8::Isolate* isolate) {
  
}


































































void MLLstmSupportLimits::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_bias_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_initial_cell_state_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_initial_hidden_state_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_input_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_outputs_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_peephole_weight_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_recurrent_bias_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_recurrent_weight_);
TraceIfNeeded<Member<MLSupportLimits>>::Trace(visitor, member_weight_);
bindings::DictionaryBase::Trace(visitor);
}

void MLLstmSupportLimits::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void MLLstmSupportLimits::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasBias()) {
  values[0] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_bias_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasInitialCellState()) {
  values[1] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_initial_cell_state_.Get());
DCHECK(!values[1].IsEmpty());
}
if (hasInitialHiddenState()) {
  values[2] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_initial_hidden_state_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasInput()) {
  values[3] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_input_.Get());
DCHECK(!values[3].IsEmpty());
}
if (hasOutputs()) {
  values[4] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_outputs_.Get());
DCHECK(!values[4].IsEmpty());
}
if (hasPeepholeWeight()) {
  values[5] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_peephole_weight_.Get());
DCHECK(!values[5].IsEmpty());
}
if (hasRecurrentBias()) {
  values[6] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_recurrent_bias_.Get());
DCHECK(!values[6].IsEmpty());
}
if (hasRecurrentWeight()) {
  values[7] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_recurrent_weight_.Get());
DCHECK(!values[7].IsEmpty());
}
if (hasWeight()) {
  values[8] = ToV8Traits<MLSupportLimits>::ToV8(script_state, member_weight_.Get());
DCHECK(!values[8].IsEmpty());
}
}

const void* MLLstmSupportLimits::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> MLLstmSupportLimits::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void MLLstmSupportLimits::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "MLLstmSupportLimits";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("bias");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_bias_, member_bias_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("initialCellState");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_initial_cell_state_, member_initial_cell_state_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("initialHiddenState");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_initial_hidden_state_, member_initial_hidden_state_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("input");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_input_, member_input_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("outputs");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_outputs_, member_outputs_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("peepholeWeight");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_peephole_weight_, member_peephole_weight_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recurrentBias");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_recurrent_bias_, member_recurrent_bias_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recurrentWeight");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_recurrent_weight_, member_recurrent_weight_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("weight");
if (!bindings::GetDictionaryMemberFromV8Object<MLSupportLimits, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_weight_, member_weight_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLLstmSupportLimits::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
