// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_SCATTER_SUPPORT_LIMITS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_SCATTER_SUPPORT_LIMITS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MLSupportLimits;

class MODULES_EXPORT MLScatterSupportLimits : public bindings::DictionaryBase {
  
  public:
static MLScatterSupportLimits* Create() {
  return MakeGarbageCollected<MLScatterSupportLimits>();
}
static MLScatterSupportLimits* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLScatterSupportLimits>(isolate);
}
static MLScatterSupportLimits* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLScatterSupportLimits();
explicit  MLScatterSupportLimits(v8::Isolate* isolate);

bool hasIndices() const {
  return has_indices_;
}
MLSupportLimits* indices() const {
  DCHECK(hasIndices());
return member_indices_.Get();
}
MLSupportLimits* getIndicesOr(MLSupportLimits* fallback_value) const {
  if (!hasIndices()) {
  return fallback_value;
}
return member_indices_.Get();
}
void setIndices(MLSupportLimits* value) {
  member_indices_ = value;
has_indices_ = true;
DCHECK(member_indices_);
}

bool hasInput() const {
  return has_input_;
}
MLSupportLimits* input() const {
  DCHECK(hasInput());
return member_input_.Get();
}
MLSupportLimits* getInputOr(MLSupportLimits* fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_.Get();
}
void setInput(MLSupportLimits* value) {
  member_input_ = value;
has_input_ = true;
DCHECK(member_input_);
}

bool hasOutput() const {
  return has_output_;
}
MLSupportLimits* output() const {
  DCHECK(hasOutput());
return member_output_.Get();
}
MLSupportLimits* getOutputOr(MLSupportLimits* fallback_value) const {
  if (!hasOutput()) {
  return fallback_value;
}
return member_output_.Get();
}
void setOutput(MLSupportLimits* value) {
  member_output_ = value;
has_output_ = true;
DCHECK(member_output_);
}

bool hasUpdates() const {
  return has_updates_;
}
MLSupportLimits* updates() const {
  DCHECK(hasUpdates());
return member_updates_.Get();
}
MLSupportLimits* getUpdatesOr(MLSupportLimits* fallback_value) const {
  if (!hasUpdates()) {
  return fallback_value;
}
return member_updates_.Get();
}
void setUpdates(MLSupportLimits* value) {
  member_updates_ = value;
has_updates_ = true;
DCHECK(member_updates_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 4;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_indices_ = false;
bool has_input_ = false;
bool has_output_ = false;
bool has_updates_ = false;

Member<MLSupportLimits> member_indices_;
Member<MLSupportLimits> member_input_;
Member<MLSupportLimits> member_output_;
Member<MLSupportLimits> member_updates_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_SCATTER_SUPPORT_LIMITS_H_
