// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_transpose_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"permutation",
};


}  // namespace 

MLTransposeOptions* MLTransposeOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLTransposeOptions* dictionary = MakeGarbageCollected<MLTransposeOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLTransposeOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MLTransposeOptions::MLTransposeOptions() {
  
}

 MLTransposeOptions::MLTransposeOptions(v8::Isolate* isolate) : MLOperatorOptions(isolate) {
  
}



Vector<uint32_t> MLTransposeOptions::getPermutationOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasPermutation()) {
  return fallback_value;
}
return member_permutation_;
}

Vector<uint32_t> MLTransposeOptions::getPermutationOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasPermutation()) {
  return std::move(fallback_value);
}
return member_permutation_;
}

void MLTransposeOptions::setPermutation(const Vector<uint32_t>& value) {
  member_permutation_ = value;
has_permutation_ = true;
}

void MLTransposeOptions::setPermutation(Vector<uint32_t>&& value) {
  member_permutation_ = std::move(value);
has_permutation_ = true;
}




void MLTransposeOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_permutation_);
MLOperatorOptions::Trace(visitor);
}

void MLTransposeOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
MLOperatorOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "MLTransposeOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("permutation");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_permutation_, member_permutation_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLTransposeOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
