// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_multi_cache_query_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"cacheName",
};


}  // namespace 

MultiCacheQueryOptions* MultiCacheQueryOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MultiCacheQueryOptions* dictionary = MakeGarbageCollected<MultiCacheQueryOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MultiCacheQueryOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 MultiCacheQueryOptions::MultiCacheQueryOptions() {
  
}

 MultiCacheQueryOptions::MultiCacheQueryOptions(v8::Isolate* isolate) : CacheQueryOptions(isolate) {
  
}



String MultiCacheQueryOptions::getCacheNameOr(const String& fallback_value) const {
  if (!hasCacheName()) {
  return fallback_value;
}
return member_cache_name_;
}

String MultiCacheQueryOptions::getCacheNameOr(String&& fallback_value) const {
  if (!hasCacheName()) {
  return std::move(fallback_value);
}
return member_cache_name_;
}

void MultiCacheQueryOptions::setCacheName(const String& value) {
  member_cache_name_ = value;
has_cache_name_ = true;
}

void MultiCacheQueryOptions::setCacheName(String&& value) {
  member_cache_name_ = std::move(value);
has_cache_name_ = true;
}




void MultiCacheQueryOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_cache_name_);
CacheQueryOptions::Trace(visitor);
}

void MultiCacheQueryOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
CacheQueryOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "MultiCacheQueryOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("cacheName");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_cache_name_, member_cache_name_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MultiCacheQueryOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
