// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ndef_reading_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ndef_message_init.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"message",
"serialNumber",
};


}  // namespace 

NDEFReadingEventInit* NDEFReadingEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  NDEFReadingEventInit* dictionary = MakeGarbageCollected<NDEFReadingEventInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "NDEFReadingEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 NDEFReadingEventInit::NDEFReadingEventInit() {
  
}

 NDEFReadingEventInit::NDEFReadingEventInit(v8::Isolate* isolate) : EventInit(isolate) {
  
}








void NDEFReadingEventInit::setSerialNumber(const String& value) {
  member_serial_number_ = value;
}

void NDEFReadingEventInit::setSerialNumber(String&& value) {
  member_serial_number_ = std::move(value);
}




void NDEFReadingEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<NDEFMessageInit>>::Trace(visitor, member_message_);
TraceIfNeeded<String>::Trace(visitor, member_serial_number_);
EventInit::Trace(visitor);
}

void NDEFReadingEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
EventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "NDEFReadingEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("message");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<NDEFMessageInit, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_message_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("serialNumber");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_serial_number_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> NDEFReadingEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
