// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_panner_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"coneInnerAngle",
"coneOuterAngle",
"coneOuterGain",
"distanceModel",
"maxDistance",
"orientationX",
"orientationY",
"orientationZ",
"panningModel",
"positionX",
"positionY",
"positionZ",
"refDistance",
"rolloffFactor",
};


}  // namespace 

PannerOptions* PannerOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PannerOptions* dictionary = MakeGarbageCollected<PannerOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PannerOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PannerOptions::PannerOptions() {
  
}

 PannerOptions::PannerOptions(v8::Isolate* isolate) : AudioNodeOptions(isolate) {
  
}









































































void PannerOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_cone_inner_angle_);
TraceIfNeeded<double>::Trace(visitor, member_cone_outer_angle_);
TraceIfNeeded<double>::Trace(visitor, member_cone_outer_gain_);
TraceIfNeeded<V8DistanceModelType>::Trace(visitor, member_distance_model_);
TraceIfNeeded<double>::Trace(visitor, member_max_distance_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_x_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_y_);
TraceIfNeeded<float>::Trace(visitor, member_orientation_z_);
TraceIfNeeded<V8PanningModelType>::Trace(visitor, member_panning_model_);
TraceIfNeeded<float>::Trace(visitor, member_position_x_);
TraceIfNeeded<float>::Trace(visitor, member_position_y_);
TraceIfNeeded<float>::Trace(visitor, member_position_z_);
TraceIfNeeded<double>::Trace(visitor, member_ref_distance_);
TraceIfNeeded<double>::Trace(visitor, member_rolloff_factor_);
AudioNodeOptions::Trace(visitor);
}

void PannerOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
AudioNodeOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "PannerOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneInnerAngle");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_cone_inner_angle_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneOuterAngle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_cone_outer_angle_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("coneOuterGain");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_cone_outer_gain_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("distanceModel");
if (!bindings::GetDictionaryMemberFromV8Object<V8DistanceModelType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_distance_model_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxDistance");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_max_distance_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_orientation_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_orientation_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("orientationZ");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_orientation_z_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("panningModel");
if (!bindings::GetDictionaryMemberFromV8Object<V8PanningModelType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_panning_model_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionX");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_position_x_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionY");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), fallback_presence_var, member_position_y_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("positionZ");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), fallback_presence_var, member_position_z_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("refDistance");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), fallback_presence_var, member_ref_distance_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rolloffFactor");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), fallback_presence_var, member_rolloff_factor_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PannerOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
