// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_shipping_option.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_currency_amount.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"amount",
"id",
"label",
"selected",
};


}  // namespace 

PaymentShippingOption* PaymentShippingOption::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentShippingOption* dictionary = MakeGarbageCollected<PaymentShippingOption>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentShippingOption";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PaymentShippingOption::PaymentShippingOption() {
  
}

 PaymentShippingOption::PaymentShippingOption(v8::Isolate* isolate) {
  
}








void PaymentShippingOption::setId(const String& value) {
  member_id_ = value;
}

void PaymentShippingOption::setId(String&& value) {
  member_id_ = std::move(value);
}




void PaymentShippingOption::setLabel(const String& value) {
  member_label_ = value;
}

void PaymentShippingOption::setLabel(String&& value) {
  member_label_ = std::move(value);
}









void PaymentShippingOption::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<PaymentCurrencyAmount>>::Trace(visitor, member_amount_);
TraceIfNeeded<String>::Trace(visitor, member_id_);
TraceIfNeeded<String>::Trace(visitor, member_label_);
TraceIfNeeded<bool>::Trace(visitor, member_selected_);
bindings::DictionaryBase::Trace(visitor);
}

void PaymentShippingOption::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PaymentShippingOption::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAmount()) {
  values[0] = ToV8Traits<PaymentCurrencyAmount>::ToV8(script_state, member_amount_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasId()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_id_);
DCHECK(!values[1].IsEmpty());
}
if (hasLabel()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_label_);
DCHECK(!values[2].IsEmpty());
}
if (hasSelected()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_selected_);
DCHECK(!values[3].IsEmpty());
}
}

const void* PaymentShippingOption::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PaymentShippingOption::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PaymentShippingOption::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PaymentShippingOption";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("amount");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<PaymentCurrencyAmount, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_amount_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("label");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_label_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("selected");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_selected_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentShippingOption::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
