// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_validation_errors.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_address_errors.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_payer_errors.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"error",
"payer",
"shippingAddress",
};


}  // namespace 

PaymentValidationErrors* PaymentValidationErrors::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentValidationErrors* dictionary = MakeGarbageCollected<PaymentValidationErrors>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentValidationErrors";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PaymentValidationErrors::PaymentValidationErrors() {
  
}

 PaymentValidationErrors::PaymentValidationErrors(v8::Isolate* isolate) {
  
}



String PaymentValidationErrors::getErrorOr(const String& fallback_value) const {
  if (!hasError()) {
  return fallback_value;
}
return member_error_;
}

String PaymentValidationErrors::getErrorOr(String&& fallback_value) const {
  if (!hasError()) {
  return std::move(fallback_value);
}
return member_error_;
}

void PaymentValidationErrors::setError(const String& value) {
  member_error_ = value;
has_error_ = true;
}

void PaymentValidationErrors::setError(String&& value) {
  member_error_ = std::move(value);
has_error_ = true;
}


















void PaymentValidationErrors::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_error_);
TraceIfNeeded<Member<PayerErrors>>::Trace(visitor, member_payer_);
TraceIfNeeded<Member<AddressErrors>>::Trace(visitor, member_shipping_address_);
bindings::InputDictionaryBase::Trace(visitor);
}

void PaymentValidationErrors::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PaymentValidationErrors";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("error");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_error_, member_error_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("payer");
if (!bindings::GetDictionaryMemberFromV8Object<PayerErrors, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_payer_, member_payer_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("shippingAddress");
if (!bindings::GetDictionaryMemberFromV8Object<AddressErrors, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_shipping_address_, member_shipping_address_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentValidationErrors::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
