// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_presentation_source.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"audioPlayback",
"latencyHint",
"type",
"url",
};


}  // namespace 

PresentationSource* PresentationSource::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PresentationSource* dictionary = MakeGarbageCollected<PresentationSource>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PresentationSource";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PresentationSource::PresentationSource() {
  
}

 PresentationSource::PresentationSource(v8::Isolate* isolate) {
  
}






















String PresentationSource::getUrlOr(const String& fallback_value) const {
  if (!hasUrl()) {
  return fallback_value;
}
return member_url_;
}

String PresentationSource::getUrlOr(String&& fallback_value) const {
  if (!hasUrl()) {
  return std::move(fallback_value);
}
return member_url_;
}

void PresentationSource::setUrl(const String& value) {
  member_url_ = value;
has_url_ = true;
}

void PresentationSource::setUrl(String&& value) {
  member_url_ = std::move(value);
has_url_ = true;
}




void PresentationSource::Trace(Visitor* visitor) const {
  TraceIfNeeded<std::optional<V8AudioPlaybackDestination>>::Trace(visitor, member_audio_playback_);
TraceIfNeeded<std::optional<V8CaptureLatency>>::Trace(visitor, member_latency_hint_);
TraceIfNeeded<V8PresentationSourceType>::Trace(visitor, member_type_);
TraceIfNeeded<String>::Trace(visitor, member_url_);
bindings::InputDictionaryBase::Trace(visitor);
}

void PresentationSource::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PresentationSource";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("audioPlayback");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8AudioPlaybackDestination>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_audio_playback_, member_audio_playback_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("latencyHint");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8CaptureLatency>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_latency_hint_, member_latency_hint_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8PresentationSourceType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_type_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("url");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_url_, member_url_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PresentationSource::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
