// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_descriptor_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"id",
"transports",
"type",
};


}  // namespace 

PublicKeyCredentialDescriptorJSON* PublicKeyCredentialDescriptorJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PublicKeyCredentialDescriptorJSON* dictionary = MakeGarbageCollected<PublicKeyCredentialDescriptorJSON>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PublicKeyCredentialDescriptorJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PublicKeyCredentialDescriptorJSON::PublicKeyCredentialDescriptorJSON() {
  
}

 PublicKeyCredentialDescriptorJSON::PublicKeyCredentialDescriptorJSON(v8::Isolate* isolate) {
  
}



void PublicKeyCredentialDescriptorJSON::setId(const String& value) {
  member_id_ = value;
}

void PublicKeyCredentialDescriptorJSON::setId(String&& value) {
  member_id_ = std::move(value);
}




Vector<String> PublicKeyCredentialDescriptorJSON::getTransportsOr(const Vector<String>& fallback_value) const {
  if (!hasTransports()) {
  return fallback_value;
}
return member_transports_;
}

Vector<String> PublicKeyCredentialDescriptorJSON::getTransportsOr(Vector<String>&& fallback_value) const {
  if (!hasTransports()) {
  return std::move(fallback_value);
}
return member_transports_;
}

void PublicKeyCredentialDescriptorJSON::setTransports(const Vector<String>& value) {
  member_transports_ = value;
has_transports_ = true;
}

void PublicKeyCredentialDescriptorJSON::setTransports(Vector<String>&& value) {
  member_transports_ = std::move(value);
has_transports_ = true;
}




void PublicKeyCredentialDescriptorJSON::setType(const String& value) {
  member_type_ = value;
}

void PublicKeyCredentialDescriptorJSON::setType(String&& value) {
  member_type_ = std::move(value);
}




void PublicKeyCredentialDescriptorJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_id_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_transports_);
TraceIfNeeded<String>::Trace(visitor, member_type_);
bindings::InputDictionaryBase::Trace(visitor);
}

void PublicKeyCredentialDescriptorJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PublicKeyCredentialDescriptorJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transports");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_transports_, member_transports_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_type_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PublicKeyCredentialDescriptorJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
