// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_request_options_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_client_inputs_js_on.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_descriptor_js_on.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"allowCredentials",
"challenge",
"extensions",
"hints",
"rpId",
"timeout",
"userVerification",
};


}  // namespace 

PublicKeyCredentialRequestOptionsJSON* PublicKeyCredentialRequestOptionsJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PublicKeyCredentialRequestOptionsJSON* dictionary = MakeGarbageCollected<PublicKeyCredentialRequestOptionsJSON>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PublicKeyCredentialRequestOptionsJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PublicKeyCredentialRequestOptionsJSON::PublicKeyCredentialRequestOptionsJSON() {
  
}

 PublicKeyCredentialRequestOptionsJSON::PublicKeyCredentialRequestOptionsJSON(v8::Isolate* isolate) {
  
}



void PublicKeyCredentialRequestOptionsJSON::setAllowCredentials(const HeapVector<Member<PublicKeyCredentialDescriptorJSON>>& value) {
  member_allow_credentials_ = value;
}

void PublicKeyCredentialRequestOptionsJSON::setAllowCredentials(HeapVector<Member<PublicKeyCredentialDescriptorJSON>>&& value) {
  member_allow_credentials_ = std::move(value);
}




void PublicKeyCredentialRequestOptionsJSON::setChallenge(const String& value) {
  member_challenge_ = value;
}

void PublicKeyCredentialRequestOptionsJSON::setChallenge(String&& value) {
  member_challenge_ = std::move(value);
}











void PublicKeyCredentialRequestOptionsJSON::setHints(const Vector<String>& value) {
  member_hints_ = value;
}

void PublicKeyCredentialRequestOptionsJSON::setHints(Vector<String>&& value) {
  member_hints_ = std::move(value);
}




String PublicKeyCredentialRequestOptionsJSON::getRpIdOr(const String& fallback_value) const {
  if (!hasRpId()) {
  return fallback_value;
}
return member_rp_id_;
}

String PublicKeyCredentialRequestOptionsJSON::getRpIdOr(String&& fallback_value) const {
  if (!hasRpId()) {
  return std::move(fallback_value);
}
return member_rp_id_;
}

void PublicKeyCredentialRequestOptionsJSON::setRpId(const String& value) {
  member_rp_id_ = value;
has_rp_id_ = true;
}

void PublicKeyCredentialRequestOptionsJSON::setRpId(String&& value) {
  member_rp_id_ = std::move(value);
has_rp_id_ = true;
}











void PublicKeyCredentialRequestOptionsJSON::setUserVerification(const String& value) {
  member_user_verification_ = value;
}

void PublicKeyCredentialRequestOptionsJSON::setUserVerification(String&& value) {
  member_user_verification_ = std::move(value);
}




void PublicKeyCredentialRequestOptionsJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<PublicKeyCredentialDescriptorJSON>>>::Trace(visitor, member_allow_credentials_);
TraceIfNeeded<String>::Trace(visitor, member_challenge_);
TraceIfNeeded<Member<AuthenticationExtensionsClientInputsJSON>>::Trace(visitor, member_extensions_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_hints_);
TraceIfNeeded<String>::Trace(visitor, member_rp_id_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_timeout_);
TraceIfNeeded<String>::Trace(visitor, member_user_verification_);
bindings::InputDictionaryBase::Trace(visitor);
}

void PublicKeyCredentialRequestOptionsJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PublicKeyCredentialRequestOptionsJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("allowCredentials");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PublicKeyCredentialDescriptorJSON>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_allow_credentials_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("challenge");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_challenge_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("extensions");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsClientInputsJSON, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_extensions_, member_extensions_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("hints");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_hints_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rpId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_rp_id_, member_rp_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("timeout");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_timeout_, member_timeout_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userVerification");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_user_verification_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PublicKeyCredentialRequestOptionsJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
