// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_codec_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"channels",
"clockRate",
"mimeType",
"payloadType",
"sdpFmtpLine",
"transportId",
};


}  // namespace 

RTCCodecStats* RTCCodecStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCCodecStats* dictionary = MakeGarbageCollected<RTCCodecStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCCodecStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 RTCCodecStats::RTCCodecStats() {
  
}

 RTCCodecStats::RTCCodecStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}

















void RTCCodecStats::setMimeType(const String& value) {
  member_mime_type_ = value;
}

void RTCCodecStats::setMimeType(String&& value) {
  member_mime_type_ = std::move(value);
}









String RTCCodecStats::getSdpFmtpLineOr(const String& fallback_value) const {
  if (!hasSdpFmtpLine()) {
  return fallback_value;
}
return member_sdp_fmtp_line_;
}

String RTCCodecStats::getSdpFmtpLineOr(String&& fallback_value) const {
  if (!hasSdpFmtpLine()) {
  return std::move(fallback_value);
}
return member_sdp_fmtp_line_;
}

void RTCCodecStats::setSdpFmtpLine(const String& value) {
  member_sdp_fmtp_line_ = value;
has_sdp_fmtp_line_ = true;
}

void RTCCodecStats::setSdpFmtpLine(String&& value) {
  member_sdp_fmtp_line_ = std::move(value);
has_sdp_fmtp_line_ = true;
}




void RTCCodecStats::setTransportId(const String& value) {
  member_transport_id_ = value;
}

void RTCCodecStats::setTransportId(String&& value) {
  member_transport_id_ = std::move(value);
}




void RTCCodecStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_channels_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_clock_rate_);
TraceIfNeeded<String>::Trace(visitor, member_mime_type_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_payload_type_);
TraceIfNeeded<String>::Trace(visitor, member_sdp_fmtp_line_);
TraceIfNeeded<String>::Trace(visitor, member_transport_id_);
RTCStats::Trace(visitor);
}

void RTCCodecStats::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  RTCStats::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void RTCCodecStats::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  RTCStats::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (hasChannels()) {
  values[0] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_channels_);
DCHECK(!values[0].IsEmpty());
}
if (hasClockRate()) {
  values[1] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_clock_rate_);
DCHECK(!values[1].IsEmpty());
}
if (hasMimeType()) {
  values[2] = ToV8Traits<IDLString>::ToV8(script_state, member_mime_type_);
DCHECK(!values[2].IsEmpty());
}
if (hasPayloadType()) {
  values[3] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_payload_type_);
DCHECK(!values[3].IsEmpty());
}
if (hasSdpFmtpLine()) {
  values[4] = ToV8Traits<IDLString>::ToV8(script_state, member_sdp_fmtp_line_);
DCHECK(!values[4].IsEmpty());
}
if (hasTransportId()) {
  values[5] = ToV8Traits<IDLString>::ToV8(script_state, member_transport_id_);
DCHECK(!values[5].IsEmpty());
}
}

const void* RTCCodecStats::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> RTCCodecStats::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void RTCCodecStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "RTCCodecStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("channels");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_channels_, member_channels_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clockRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_clock_rate_, member_clock_rate_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mimeType");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mime_type_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("payloadType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_payload_type_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sdpFmtpLine");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_sdp_fmtp_line_, member_sdp_fmtp_line_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transportId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_transport_id_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCCodecStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
