// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_data_channel_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"id",
"maxPacketLifeTime",
"maxRetransmits",
"negotiated",
"ordered",
"priority",
"protocol",
};


}  // namespace 

RTCDataChannelInit* RTCDataChannelInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCDataChannelInit* dictionary = MakeGarbageCollected<RTCDataChannelInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCDataChannelInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 RTCDataChannelInit::RTCDataChannelInit() {
  
}

 RTCDataChannelInit::RTCDataChannelInit(v8::Isolate* isolate) {
  
}







































void RTCDataChannelInit::setProtocol(const String& value) {
  member_protocol_ = value;
}

void RTCDataChannelInit::setProtocol(String&& value) {
  member_protocol_ = std::move(value);
}




void RTCDataChannelInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint16_t>::Trace(visitor, member_id_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_max_packet_life_time_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_max_retransmits_);
TraceIfNeeded<bool>::Trace(visitor, member_negotiated_);
TraceIfNeeded<bool>::Trace(visitor, member_ordered_);
TraceIfNeeded<V8RTCPriorityType>::Trace(visitor, member_priority_);
TraceIfNeeded<String>::Trace(visitor, member_protocol_);
bindings::InputDictionaryBase::Trace(visitor);
}

void RTCDataChannelInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "RTCDataChannelInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShortEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_id_, member_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxPacketLifeTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_max_packet_life_time_, member_max_packet_life_time_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxRetransmits");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_max_retransmits_, member_max_retransmits_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("negotiated");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_negotiated_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ordered");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_ordered_, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::RTCDataChannelPriorityEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("priority");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCPriorityType, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_priority_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("protocol");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_protocol_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCDataChannelInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
