// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtcp_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"cname",
"reducedSize",
};


}  // namespace 

RTCRtcpParameters* RTCRtcpParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtcpParameters* dictionary = MakeGarbageCollected<RTCRtcpParameters>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtcpParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 RTCRtcpParameters::RTCRtcpParameters() {
  
}

 RTCRtcpParameters::RTCRtcpParameters(v8::Isolate* isolate) {
  
}



String RTCRtcpParameters::getCnameOr(const String& fallback_value) const {
  if (!hasCname()) {
  return fallback_value;
}
return member_cname_;
}

String RTCRtcpParameters::getCnameOr(String&& fallback_value) const {
  if (!hasCname()) {
  return std::move(fallback_value);
}
return member_cname_;
}

void RTCRtcpParameters::setCname(const String& value) {
  member_cname_ = value;
has_cname_ = true;
}

void RTCRtcpParameters::setCname(String&& value) {
  member_cname_ = std::move(value);
has_cname_ = true;
}











void RTCRtcpParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_cname_);
TraceIfNeeded<bool>::Trace(visitor, member_reduced_size_);
bindings::DictionaryBase::Trace(visitor);
}

void RTCRtcpParameters::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void RTCRtcpParameters::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCname()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_cname_);
DCHECK(!values[0].IsEmpty());
}
if (hasReducedSize()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_reduced_size_);
DCHECK(!values[1].IsEmpty());
}
}

const void* RTCRtcpParameters::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> RTCRtcpParameters::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void RTCRtcpParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "RTCRtcpParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("cname");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_cname_, member_cname_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("reducedSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_reduced_size_, member_reduced_size_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtcpParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
