// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_PACKET_INIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_PACKET_INIT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class RTCRtpHeaderExtensionInit;
class V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared;

class MODULES_EXPORT RTCRtpPacketInit : public bindings::InputDictionaryBase {
  
  public:
static RTCRtpPacketInit* Create() {
  return MakeGarbageCollected<RTCRtpPacketInit>();
}
static RTCRtpPacketInit* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<RTCRtpPacketInit>(isolate);
}
static RTCRtpPacketInit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  RTCRtpPacketInit();
explicit  RTCRtpPacketInit(v8::Isolate* isolate);

bool hasCsrcs() const {
  return true;
}
const Vector<uint32_t>& csrcs() const {
  return member_csrcs_;
}
void setCsrcs(const Vector<uint32_t>& value);
void setCsrcs(Vector<uint32_t>&& value);

bool hasHeaderExtensions() const {
  return true;
}
const HeapVector<Member<RTCRtpHeaderExtensionInit>>& headerExtensions() const {
  return member_header_extensions_;
}
void setHeaderExtensions(const HeapVector<Member<RTCRtpHeaderExtensionInit>>& value);
void setHeaderExtensions(HeapVector<Member<RTCRtpHeaderExtensionInit>>&& value);

bool hasMarker() const {
  return true;
}
bool marker() const {
  return member_marker_;
}
void setMarker(bool value) {
  member_marker_ = value;
}

bool hasPayload() const {
  return true;
}
V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared* payload() const {
  return member_payload_.Get();
}
void setPayload(V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared* value) {
  member_payload_ = value;
DCHECK(member_payload_);
}

bool hasPayloadType() const {
  return true;
}
uint8_t payloadType() const {
  return member_payload_type_;
}
void setPayloadType(uint8_t value) {
  member_payload_type_ = value;
}

bool hasTimestamp() const {
  return true;
}
uint32_t timestamp() const {
  return member_timestamp_;
}
void setTimestamp(uint32_t value) {
  member_timestamp_ = value;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 6;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Vector<uint32_t> member_csrcs_;
HeapVector<Member<RTCRtpHeaderExtensionInit>> member_header_extensions_;
bool member_marker_{false};
Member<V8UnionArrayBufferAllowSharedOrArrayBufferViewAllowShared> member_payload_;
uint8_t member_payload_type_;
uint32_t member_timestamp_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_PACKET_INIT_H_
