// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_SEND_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_SEND_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT RTCRtpSendOptions : public bindings::InputDictionaryBase {
  
  public:
static RTCRtpSendOptions* Create() {
  return MakeGarbageCollected<RTCRtpSendOptions>();
}
static RTCRtpSendOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<RTCRtpSendOptions>(isolate);
}
static RTCRtpSendOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  RTCRtpSendOptions();
explicit  RTCRtpSendOptions(v8::Isolate* isolate);

bool hasSendTime() const {
  return has_send_time_;
}
double sendTime() const {
  DCHECK(hasSendTime());
return member_send_time_;
}
double getSendTimeOr(double fallback_value) const {
  if (!hasSendTime()) {
  return fallback_value;
}
return member_send_time_;
}
void setSendTime(double value) {
  member_send_time_ = value;
has_send_time_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 1;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_send_time_ = false;

double member_send_time_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTP_SEND_OPTIONS_H_
