// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_video_source_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"frames",
"framesPerSecond",
"height",
"width",
};


}  // namespace 

RTCVideoSourceStats* RTCVideoSourceStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCVideoSourceStats* dictionary = MakeGarbageCollected<RTCVideoSourceStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCVideoSourceStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 RTCVideoSourceStats::RTCVideoSourceStats() {
  
}

 RTCVideoSourceStats::RTCVideoSourceStats(v8::Isolate* isolate) : RTCMediaSourceStats(isolate) {
  
}































void RTCVideoSourceStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_);
TraceIfNeeded<double>::Trace(visitor, member_frames_per_second_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_height_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_width_);
RTCMediaSourceStats::Trace(visitor);
}

void RTCVideoSourceStats::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  RTCMediaSourceStats::FillTemplateProperties(properties);
DCHECK_EQ(properties.size(), kBasePropertyCount);

static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void RTCVideoSourceStats::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  RTCMediaSourceStats::FillValuesImpl(script_state, values.first(kBasePropertyCount));
values = values.subspan(kBasePropertyCount);

CHECK_EQ(kOwnPropertyCount, values.size());
if (hasFrames()) {
  values[0] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_);
DCHECK(!values[0].IsEmpty());
}
if (hasFramesPerSecond()) {
  values[1] = ToV8Traits<IDLDouble>::ToV8(script_state, member_frames_per_second_);
DCHECK(!values[1].IsEmpty());
}
if (hasHeight()) {
  values[2] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_height_);
DCHECK(!values[2].IsEmpty());
}
if (hasWidth()) {
  values[3] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_width_);
DCHECK(!values[3].IsEmpty());
}
}

const void* RTCVideoSourceStats::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> RTCVideoSourceStats::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void RTCVideoSourceStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
RTCMediaSourceStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "RTCVideoSourceStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("frames");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_frames_, member_frames_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_frames_per_second_, member_frames_per_second_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("height");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_height_, member_height_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("width");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_width_, member_width_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCVideoSourceStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
