// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_run_function_for_shared_storage_run_operation.h"

#include <tuple>

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/callback_invoke_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"

namespace blink {





const char* V8RunFunctionForSharedStorageRunOperation::NameInHeapSnapshot() const {
  return "V8RunFunctionForSharedStorageRunOperation";
}

v8::Maybe<ScriptPromiseUntyped> V8RunFunctionForSharedStorageRunOperation::Invoke(bindings::V8ValueOrScriptWrappableAdapter arg0_receiver, const ScriptValue& arg1_data) {
  const char* const class_like_name = "RunFunctionForSharedStorageRunOperation";
const char* const property_name = "invoke";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<ScriptPromiseUntyped>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
ExceptionState exception_state(isolate, v8::ExceptionContext::kOperation,class_like_name, property_name);
exception_state.ThrowException(static_cast<ExceptionCode>(ESErrorType::kError), "The provided callback is no longer runnable.");
return v8::Nothing<ScriptPromiseUntyped>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kDefault, bindings::CallbackReturnTypeIsPromise::kYes> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(arg0_receiver)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<ScriptPromiseUntyped>();
}
return helper.Result<IDLPromise, ScriptPromiseUntyped>();
}
v8::Local<v8::Value> argv_arr[1];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_data;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_data = ToV8Traits<IDLOptional<IDLAny>>::ToV8(script_state, arg1_data);
argv[0] = v8_arg1_data;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<ScriptPromiseUntyped>();
}
return helper.Result<IDLPromise, ScriptPromiseUntyped>();
}

v8::Maybe<ScriptPromiseUntyped> V8RunFunctionForSharedStorageRunOperation::Construct(const ScriptValue& arg1_data) {
  const char* const class_like_name = "RunFunctionForSharedStorageRunOperation";
const char* const property_name = "construct";
ScriptState* callback_relevant_script_state =
    CallbackRelevantScriptStateOrThrowException(
        class_like_name, property_name);
if (!callback_relevant_script_state) {
  return v8::Nothing<ScriptPromiseUntyped>();
}

if (!IsCallbackFunctionRunnable(callback_relevant_script_state, IncumbentScriptState())) {
  v8::Isolate* isolate = GetIsolate();
v8::HandleScope handle_scope(isolate);
v8::Context::Scope context_scope(callback_relevant_script_state->GetContext());
ExceptionState exception_state(isolate, v8::ExceptionContext::kOperation,class_like_name, property_name);
exception_state.ThrowException(static_cast<ExceptionCode>(ESErrorType::kError), "The provided callback is no longer runnable.");
return v8::Nothing<ScriptPromiseUntyped>();
}

bindings::CallbackInvokeHelper<CallbackFunctionBase, bindings::CallbackInvokeHelperMode::kConstructorCall, bindings::CallbackReturnTypeIsPromise::kYes> helper(
    this, class_like_name, property_name);
if (!helper.PrepareForCall(nullptr)) [[unlikely]] {
  if (helper.V8Result().IsEmpty()) {
  return v8::Nothing<ScriptPromiseUntyped>();
}
return helper.Result<IDLPromise, ScriptPromiseUntyped>();
}
v8::Local<v8::Value> argv_arr[1];
base::span<v8::Local<v8::Value>> argv(argv_arr);
v8::Local<v8::Value> v8_arg1_data;
ScriptState* script_state = CallbackRelevantScriptState();
v8_arg1_data = ToV8Traits<IDLOptional<IDLAny>>::ToV8(script_state, arg1_data);
argv[0] = v8_arg1_data;
if (!helper.Call(static_cast<int>(argv.size()), argv.data())) {
  return v8::Nothing<ScriptPromiseUntyped>();
}
return helper.Result<IDLPromise, ScriptPromiseUntyped>();
}




}  // namespace blink
