// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_save_file_picker_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"suggestedName",
};


}  // namespace 

SaveFilePickerOptions* SaveFilePickerOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SaveFilePickerOptions* dictionary = MakeGarbageCollected<SaveFilePickerOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SaveFilePickerOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 SaveFilePickerOptions::SaveFilePickerOptions() {
  
}

 SaveFilePickerOptions::SaveFilePickerOptions(v8::Isolate* isolate) : FilePickerOptions(isolate) {
  
}



String SaveFilePickerOptions::getSuggestedNameOr(const String& fallback_value) const {
  if (!hasSuggestedName()) {
  return fallback_value;
}
return member_suggested_name_;
}

String SaveFilePickerOptions::getSuggestedNameOr(String&& fallback_value) const {
  if (!hasSuggestedName()) {
  return std::move(fallback_value);
}
return member_suggested_name_;
}

void SaveFilePickerOptions::setSuggestedName(const String& value) {
  member_suggested_name_ = value;
has_suggested_name_ = true;
}

void SaveFilePickerOptions::setSuggestedName(String&& value) {
  member_suggested_name_ = std::move(value);
has_suggested_name_ = true;
}




void SaveFilePickerOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_suggested_name_);
FilePickerOptions::Trace(visitor);
}

void SaveFilePickerOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
FilePickerOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "SaveFilePickerOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("suggestedName");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_suggested_name_, member_suggested_name_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SaveFilePickerOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
