// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_serial_input_signals.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"clearToSend",
"dataCarrierDetect",
"dataSetReady",
"ringIndicator",
};


}  // namespace 

SerialInputSignals* SerialInputSignals::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SerialInputSignals* dictionary = MakeGarbageCollected<SerialInputSignals>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SerialInputSignals";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 SerialInputSignals::SerialInputSignals() {
  
}

 SerialInputSignals::SerialInputSignals(v8::Isolate* isolate) {
  
}























void SerialInputSignals::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_clear_to_send_);
TraceIfNeeded<bool>::Trace(visitor, member_data_carrier_detect_);
TraceIfNeeded<bool>::Trace(visitor, member_data_set_ready_);
TraceIfNeeded<bool>::Trace(visitor, member_ring_indicator_);
bindings::DictionaryBase::Trace(visitor);
}

void SerialInputSignals::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void SerialInputSignals::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasClearToSend()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_clear_to_send_);
DCHECK(!values[0].IsEmpty());
}
if (hasDataCarrierDetect()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_data_carrier_detect_);
DCHECK(!values[1].IsEmpty());
}
if (hasDataSetReady()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_data_set_ready_);
DCHECK(!values[2].IsEmpty());
}
if (hasRingIndicator()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_ring_indicator_);
DCHECK(!values[3].IsEmpty());
}
}

const void* SerialInputSignals::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> SerialInputSignals::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void SerialInputSignals::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "SerialInputSignals";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clearToSend");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_clear_to_send_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dataCarrierDetect");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_data_carrier_detect_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dataSetReady");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_data_set_ready_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ringIndicator");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_ring_indicator_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SerialInputSignals::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
