// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_shared_storage_run_operation_method_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_shared_storage_private_aggregation_config.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"data",
"keepAlive",
"privateAggregationConfig",
"resolveToConfig",
};


}  // namespace 

SharedStorageRunOperationMethodOptions* SharedStorageRunOperationMethodOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SharedStorageRunOperationMethodOptions* dictionary = MakeGarbageCollected<SharedStorageRunOperationMethodOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SharedStorageRunOperationMethodOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 SharedStorageRunOperationMethodOptions::SharedStorageRunOperationMethodOptions() {
  
}

 SharedStorageRunOperationMethodOptions::SharedStorageRunOperationMethodOptions(v8::Isolate* isolate) {
  
}



























void SharedStorageRunOperationMethodOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<ScriptValue>::Trace(visitor, member_data_);
TraceIfNeeded<bool>::Trace(visitor, member_keep_alive_);
TraceIfNeeded<Member<SharedStoragePrivateAggregationConfig>>::Trace(visitor, member_private_aggregation_config_);
TraceIfNeeded<bool>::Trace(visitor, member_resolve_to_config_);
bindings::InputDictionaryBase::Trace(visitor);
}

void SharedStorageRunOperationMethodOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "SharedStorageRunOperationMethodOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("data");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLObject, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_data_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keepAlive");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_keep_alive_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("privateAggregationConfig");
if (!bindings::GetDictionaryMemberFromV8Object<SharedStoragePrivateAggregationConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_private_aggregation_config_, member_private_aggregation_config_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("resolveToConfig");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_resolve_to_config_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SharedStorageRunOperationMethodOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
