// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_smart_card_reader_state_flags.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"empty",
"exclusive",
"ignore",
"inuse",
"mute",
"present",
"unavailable",
"unpowered",
};


}  // namespace 

SmartCardReaderStateFlags* SmartCardReaderStateFlags::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SmartCardReaderStateFlags* dictionary = MakeGarbageCollected<SmartCardReaderStateFlags>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SmartCardReaderStateFlags";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 SmartCardReaderStateFlags::SmartCardReaderStateFlags() {
  
}

 SmartCardReaderStateFlags::SmartCardReaderStateFlags(v8::Isolate* isolate) {
  
}











































void SmartCardReaderStateFlags::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_empty_);
TraceIfNeeded<bool>::Trace(visitor, member_exclusive_);
TraceIfNeeded<bool>::Trace(visitor, member_ignore_);
TraceIfNeeded<bool>::Trace(visitor, member_inuse_);
TraceIfNeeded<bool>::Trace(visitor, member_mute_);
TraceIfNeeded<bool>::Trace(visitor, member_present_);
TraceIfNeeded<bool>::Trace(visitor, member_unavailable_);
TraceIfNeeded<bool>::Trace(visitor, member_unpowered_);
bindings::DictionaryBase::Trace(visitor);
}

void SmartCardReaderStateFlags::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void SmartCardReaderStateFlags::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasEmpty()) {
  values[0] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_empty_);
DCHECK(!values[0].IsEmpty());
}
if (hasExclusive()) {
  values[1] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_exclusive_);
DCHECK(!values[1].IsEmpty());
}
if (hasIgnore()) {
  values[2] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_ignore_);
DCHECK(!values[2].IsEmpty());
}
if (hasInuse()) {
  values[3] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_inuse_);
DCHECK(!values[3].IsEmpty());
}
if (hasMute()) {
  values[4] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_mute_);
DCHECK(!values[4].IsEmpty());
}
if (hasPresent()) {
  values[5] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_present_);
DCHECK(!values[5].IsEmpty());
}
if (hasUnavailable()) {
  values[6] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_unavailable_);
DCHECK(!values[6].IsEmpty());
}
if (hasUnpowered()) {
  values[7] = ToV8Traits<IDLBoolean>::ToV8(script_state, member_unpowered_);
DCHECK(!values[7].IsEmpty());
}
}

const void* SmartCardReaderStateFlags::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> SmartCardReaderStateFlags::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void SmartCardReaderStateFlags::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "SmartCardReaderStateFlags";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("empty");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_empty_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("exclusive");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_exclusive_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("ignore");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_ignore_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inuse");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_inuse_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mute");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_mute_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("present");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_present_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("unavailable");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_unavailable_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("unpowered");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), fallback_presence_var, member_unpowered_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SmartCardReaderStateFlags::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
