// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_socket_open_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/streams/readable_stream.h"
#include "third_party/blink/renderer/core/streams/writable_stream.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"localAddress",
"localPort",
"readable",
"remoteAddress",
"remotePort",
"writable",
};


}  // namespace 

SocketOpenInfo* SocketOpenInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  SocketOpenInfo* dictionary = MakeGarbageCollected<SocketOpenInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "SocketOpenInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 SocketOpenInfo::SocketOpenInfo() {
  
}

 SocketOpenInfo::SocketOpenInfo(v8::Isolate* isolate) {
  
}



String SocketOpenInfo::getLocalAddressOr(const String& fallback_value) const {
  if (!hasLocalAddress()) {
  return fallback_value;
}
return member_local_address_;
}

String SocketOpenInfo::getLocalAddressOr(String&& fallback_value) const {
  if (!hasLocalAddress()) {
  return std::move(fallback_value);
}
return member_local_address_;
}

void SocketOpenInfo::setLocalAddress(const String& value) {
  member_local_address_ = value;
has_local_address_ = true;
}

void SocketOpenInfo::setLocalAddress(String&& value) {
  member_local_address_ = std::move(value);
has_local_address_ = true;
}


















String SocketOpenInfo::getRemoteAddressOr(const String& fallback_value) const {
  if (!hasRemoteAddress()) {
  return fallback_value;
}
return member_remote_address_;
}

String SocketOpenInfo::getRemoteAddressOr(String&& fallback_value) const {
  if (!hasRemoteAddress()) {
  return std::move(fallback_value);
}
return member_remote_address_;
}

void SocketOpenInfo::setRemoteAddress(const String& value) {
  member_remote_address_ = value;
has_remote_address_ = true;
}

void SocketOpenInfo::setRemoteAddress(String&& value) {
  member_remote_address_ = std::move(value);
has_remote_address_ = true;
}


















void SocketOpenInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_local_address_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_local_port_);
TraceIfNeeded<Member<ReadableStream>>::Trace(visitor, member_readable_);
TraceIfNeeded<String>::Trace(visitor, member_remote_address_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_remote_port_);
TraceIfNeeded<Member<WritableStream>>::Trace(visitor, member_writable_);
bindings::DictionaryBase::Trace(visitor);
}

void SocketOpenInfo::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNames) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNames), std::cend(kOwnPropertyNames));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void SocketOpenInfo::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasLocalAddress()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_local_address_);
DCHECK(!values[0].IsEmpty());
}
if (hasLocalPort()) {
  values[1] = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_local_port_);
DCHECK(!values[1].IsEmpty());
}
if (hasReadable()) {
  values[2] = ToV8Traits<ReadableStream>::ToV8(script_state, member_readable_.Get());
DCHECK(!values[2].IsEmpty());
}
if (hasRemoteAddress()) {
  values[3] = ToV8Traits<IDLString>::ToV8(script_state, member_remote_address_);
DCHECK(!values[3].IsEmpty());
}
if (hasRemotePort()) {
  values[4] = ToV8Traits<IDLUnsignedShort>::ToV8(script_state, member_remote_port_);
DCHECK(!values[4].IsEmpty());
}
if (hasWritable()) {
  values[5] = ToV8Traits<WritableStream>::ToV8(script_state, member_writable_.Get());
DCHECK(!values[5].IsEmpty());
}
}

const void* SocketOpenInfo::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> SocketOpenInfo::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void SocketOpenInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "SocketOpenInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("localAddress");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_local_address_, member_local_address_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("localPort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_local_port_, member_local_port_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("readable");
if (!bindings::GetDictionaryMemberFromV8Object<ReadableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_readable_, member_readable_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteAddress");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_remote_address_, member_remote_address_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remotePort");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_remote_port_, member_remote_port_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("writable");
if (!bindings::GetDictionaryMemberFromV8Object<WritableStream, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_writable_, member_writable_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> SocketOpenInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
