// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SPEECH_RECOGNITION_ERROR_EVENT_INIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SPEECH_RECOGNITION_ERROR_EVENT_INIT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_event_init.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT SpeechRecognitionErrorEventInit : public EventInit {
  
  public:
static SpeechRecognitionErrorEventInit* Create() {
  return MakeGarbageCollected<SpeechRecognitionErrorEventInit>();
}
static SpeechRecognitionErrorEventInit* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<SpeechRecognitionErrorEventInit>(isolate);
}
static SpeechRecognitionErrorEventInit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  SpeechRecognitionErrorEventInit();
explicit  SpeechRecognitionErrorEventInit(v8::Isolate* isolate);

bool hasError() const {
  return has_error_;
}
const String& error() const {
  DCHECK(hasError());
return member_error_;
}
String getErrorOr(const String& fallback_value) const;
String getErrorOr(String&& fallback_value) const;
void setError(const String& value);
void setError(String&& value);

bool hasMessage() const {
  return has_message_;
}
const String& message() const {
  DCHECK(hasMessage());
return member_message_;
}
String getMessageOr(const String& fallback_value) const;
String getMessageOr(String&& fallback_value) const;
void setMessage(const String& value);
void setMessage(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = EventInit::kTotalPropertyCount;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_error_ = false;
bool has_message_ = false;

String member_error_;
String member_message_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SPEECH_RECOGNITION_ERROR_EVENT_INIT_H_
