// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_storage_event_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/storage/storage_area.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"key",
"newValue",
"oldValue",
"storageArea",
"url",
};


}  // namespace 

StorageEventInit* StorageEventInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  StorageEventInit* dictionary = MakeGarbageCollected<StorageEventInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "StorageEventInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 StorageEventInit::StorageEventInit() {
  
}

 StorageEventInit::StorageEventInit(v8::Isolate* isolate) : EventInit(isolate) {
  
}



void StorageEventInit::setKey(const String& value) {
  member_key_ = value;
}

void StorageEventInit::setKey(String&& value) {
  member_key_ = std::move(value);
}




void StorageEventInit::setNewValue(const String& value) {
  member_new_value_ = value;
}

void StorageEventInit::setNewValue(String&& value) {
  member_new_value_ = std::move(value);
}




void StorageEventInit::setOldValue(const String& value) {
  member_old_value_ = value;
}

void StorageEventInit::setOldValue(String&& value) {
  member_old_value_ = std::move(value);
}









void StorageEventInit::setUrl(const String& value) {
  member_url_ = value;
}

void StorageEventInit::setUrl(String&& value) {
  member_url_ = std::move(value);
}




void StorageEventInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_key_);
TraceIfNeeded<String>::Trace(visitor, member_new_value_);
TraceIfNeeded<String>::Trace(visitor, member_old_value_);
TraceIfNeeded<Member<StorageArea>>::Trace(visitor, member_storage_area_);
TraceIfNeeded<String>::Trace(visitor, member_url_);
EventInit::Trace(visitor);
}

void StorageEventInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
EventInit::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return;
}

const char* const class_like_name = "StorageEventInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("key");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_key_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("newValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_new_value_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("oldValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_old_value_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("storageArea");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<StorageArea>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_storage_area_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("url");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_url_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> StorageEventInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
