// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_TCP_SERVER_SOCKET_OPEN_INFO_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_TCP_SERVER_SOCKET_OPEN_INFO_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class ReadableStream;

class MODULES_EXPORT TCPServerSocketOpenInfo : public bindings::DictionaryBase {
  
  public:
static TCPServerSocketOpenInfo* Create() {
  return MakeGarbageCollected<TCPServerSocketOpenInfo>();
}
static TCPServerSocketOpenInfo* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<TCPServerSocketOpenInfo>(isolate);
}
static TCPServerSocketOpenInfo* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  TCPServerSocketOpenInfo();
explicit  TCPServerSocketOpenInfo(v8::Isolate* isolate);

bool hasLocalAddress() const {
  return has_local_address_;
}
const String& localAddress() const {
  DCHECK(hasLocalAddress());
return member_local_address_;
}
String getLocalAddressOr(const String& fallback_value) const;
String getLocalAddressOr(String&& fallback_value) const;
void setLocalAddress(const String& value);
void setLocalAddress(String&& value);

bool hasLocalPort() const {
  return has_local_port_;
}
uint16_t localPort() const {
  DCHECK(hasLocalPort());
return member_local_port_;
}
uint16_t getLocalPortOr(uint16_t fallback_value) const {
  if (!hasLocalPort()) {
  return fallback_value;
}
return member_local_port_;
}
void setLocalPort(uint16_t value) {
  member_local_port_ = value;
has_local_port_ = true;
}

bool hasReadable() const {
  return has_readable_;
}
ReadableStream* readable() const {
  DCHECK(hasReadable());
return member_readable_.Get();
}
ReadableStream* getReadableOr(ReadableStream* fallback_value) const {
  if (!hasReadable()) {
  return fallback_value;
}
return member_readable_.Get();
}
void setReadable(ReadableStream* value) {
  member_readable_ = value;
has_readable_ = true;
DCHECK(member_readable_);
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 3;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_local_address_ = false;
bool has_local_port_ = false;
bool has_readable_ = false;

String member_local_address_;
uint16_t member_local_port_;
Member<ReadableStream> member_readable_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_TCP_SERVER_SOCKET_OPEN_INFO_H_
