// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_usb_control_transfer_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"index",
"recipient",
"request",
"requestType",
"value",
};


}  // namespace 

USBControlTransferParameters* USBControlTransferParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  USBControlTransferParameters* dictionary = MakeGarbageCollected<USBControlTransferParameters>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "USBControlTransferParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 USBControlTransferParameters::USBControlTransferParameters() {
  
}

 USBControlTransferParameters::USBControlTransferParameters(v8::Isolate* isolate) {
  
}




























void USBControlTransferParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint16_t>::Trace(visitor, member_index_);
TraceIfNeeded<V8USBRecipient>::Trace(visitor, member_recipient_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_request_);
TraceIfNeeded<V8USBRequestType>::Trace(visitor, member_request_type_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_value_);
bindings::InputDictionaryBase::Trace(visitor);
}

void USBControlTransferParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "USBControlTransferParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("index");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_index_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recipient");
if (!bindings::GetDictionaryMemberFromV8Object<V8USBRecipient, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_recipient_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("request");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_request_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestType");
if (!bindings::GetDictionaryMemberFromV8Object<V8USBRequestType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_request_type_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("value");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShort, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_value_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> USBControlTransferParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
