// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_user_media_stream_constraints.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_track_constraints.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_boolean_mediatrackconstraints.h"
#include "third_party/blink/renderer/modules/mediastream/capture_controller.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"audio",
"controller",
"video",
};


}  // namespace 

UserMediaStreamConstraints* UserMediaStreamConstraints::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  UserMediaStreamConstraints* dictionary = MakeGarbageCollected<UserMediaStreamConstraints>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "UserMediaStreamConstraints";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 UserMediaStreamConstraints::UserMediaStreamConstraints() : member_audio_(MakeGarbageCollected<V8UnionBooleanOrMediaTrackConstraints>(false)), member_video_(MakeGarbageCollected<V8UnionBooleanOrMediaTrackConstraints>(false)) {
  
}

 UserMediaStreamConstraints::UserMediaStreamConstraints(v8::Isolate* isolate) : member_audio_(MakeGarbageCollected<V8UnionBooleanOrMediaTrackConstraints>(false)), member_video_(MakeGarbageCollected<V8UnionBooleanOrMediaTrackConstraints>(false)) {
  
}




















void UserMediaStreamConstraints::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionBooleanOrMediaTrackConstraints>>::Trace(visitor, member_audio_);
TraceIfNeeded<Member<CaptureController>>::Trace(visitor, member_controller_);
TraceIfNeeded<Member<V8UnionBooleanOrMediaTrackConstraints>>::Trace(visitor, member_video_);
bindings::InputDictionaryBase::Trace(visitor);
}

void UserMediaStreamConstraints::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "UserMediaStreamConstraints";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("audio");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionBooleanOrMediaTrackConstraints, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_audio_, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::CaptureControllerEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("controller");
if (!bindings::GetDictionaryMemberFromV8Object<CaptureController, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_controller_, member_controller_, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("video");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionBooleanOrMediaTrackConstraints, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_video_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> UserMediaStreamConstraints::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
