// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_hash.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_arraybuffer_arraybufferview.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNames[] = {
"algorithm",
"value",
};


}  // namespace 

WebTransportHash* WebTransportHash::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebTransportHash* dictionary = MakeGarbageCollected<WebTransportHash>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebTransportHash";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 WebTransportHash::WebTransportHash() {
  
}

 WebTransportHash::WebTransportHash(v8::Isolate* isolate) {
  
}



String WebTransportHash::getAlgorithmOr(const String& fallback_value) const {
  if (!hasAlgorithm()) {
  return fallback_value;
}
return member_algorithm_;
}

String WebTransportHash::getAlgorithmOr(String&& fallback_value) const {
  if (!hasAlgorithm()) {
  return std::move(fallback_value);
}
return member_algorithm_;
}

void WebTransportHash::setAlgorithm(const String& value) {
  member_algorithm_ = value;
has_algorithm_ = true;
}

void WebTransportHash::setAlgorithm(String&& value) {
  member_algorithm_ = std::move(value);
has_algorithm_ = true;
}











void WebTransportHash::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_algorithm_);
TraceIfNeeded<Member<V8UnionArrayBufferOrArrayBufferView>>::Trace(visitor, member_value_);
bindings::InputDictionaryBase::Trace(visitor);
}

void WebTransportHash::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "WebTransportHash";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("algorithm");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_algorithm_, member_algorithm_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("value");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionArrayBufferOrArrayBufferView, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_value_, member_value_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebTransportHash::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNames, kOwnPropertyNames);
}


}  // namespace blink
