// ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_SHARED_H_
#define UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "ui/gfx/mojom/color_space.mojom-shared.h"
#include "ui/gfx/mojom/gpu_fence_handle.mojom-shared.h"
#include "ui/gfx/mojom/overlay_transform.mojom-shared.h"
#include "ui/gfx/mojom/overlay_priority_hint.mojom-shared.h"
#include "ui/gfx/mojom/rrect_f.mojom-shared.h"
#include "ui/gfx/mojom/transform.mojom-shared.h"
#include "skia/public/mojom/skcolor4f.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace wl::mojom {
class WaylandOverlayConfigDataView;

class TransformUnionDataView;


}  // wl::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::wl::mojom::WaylandOverlayConfigDataView> {
  using Data = ::wl::mojom::internal::WaylandOverlayConfig_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::wl::mojom::TransformUnionDataView> {
  using Data = ::wl::mojom::internal::TransformUnion_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace wl::mojom {


class WaylandOverlayConfigDataView {
 public:
  WaylandOverlayConfigDataView() = default;

  WaylandOverlayConfigDataView(
      internal::WaylandOverlayConfig_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  int32_t z_order() const {
    return data_->z_order;
  }
  inline void GetColorSpaceDataView(
      ::gfx::mojom::ColorSpaceDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadColorSpace(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::gfx::mojom::ColorSpaceDataView, UserType>(),
    "Attempting to read the optional `color_space` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadColorSpace` instead "
    "of `ReadColorSpace if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->color_space.Get();
    return mojo::internal::Deserialize<::gfx::mojom::ColorSpaceDataView>(
        pointer, output, message_);
  }
  inline void GetTransformDataView(
      TransformUnionDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadTransform(UserType* output) {
    
    auto* pointer = !data_->transform.is_null() ? &data_->transform : nullptr;
    return mojo::internal::Deserialize<::wl::mojom::TransformUnionDataView>(
        pointer, output, message_);
  }
  uint32_t buffer_id() const {
    return data_->buffer_id;
  }
  float surface_scale_factor() const {
    return data_->surface_scale_factor;
  }
  inline void GetBoundsRectDataView(
      ::gfx::mojom::RectFDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadBoundsRect(UserType* output) {
    
    auto* pointer = data_->bounds_rect.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectFDataView>(
        pointer, output, message_);
  }
  inline void GetCropRectDataView(
      ::gfx::mojom::RectFDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadCropRect(UserType* output) {
    
    auto* pointer = data_->crop_rect.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectFDataView>(
        pointer, output, message_);
  }
  inline void GetDamageRegionDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDamageRegion(UserType* output) {
    
    auto* pointer = data_->damage_region.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
  bool enable_blend() const {
    return data_->enable_blend;
  }
  float opacity() const {
    return data_->opacity;
  }
  inline void GetAccessFenceHandleDataView(
      ::gfx::mojom::GpuFenceHandleDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadAccessFenceHandle(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::gfx::mojom::GpuFenceHandleDataView, UserType>(),
    "Attempting to read the optional `access_fence_handle` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAccessFenceHandle` instead "
    "of `ReadAccessFenceHandle if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->access_fence_handle.Get();
    return mojo::internal::Deserialize<::gfx::mojom::GpuFenceHandleDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadPriorityHint(UserType* output) const {
    auto data_value = data_->priority_hint;
    return mojo::internal::Deserialize<::gfx::mojom::OverlayPriorityHint>(
        data_value, output);
  }
  ::gfx::mojom::OverlayPriorityHint priority_hint() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::gfx::mojom::OverlayPriorityHint>(data_->priority_hint));
  }
  inline void GetRoundedClipBoundsDataView(
      ::gfx::mojom::RRectFDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadRoundedClipBounds(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::gfx::mojom::RRectFDataView, UserType>(),
    "Attempting to read the optional `rounded_clip_bounds` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadRoundedClipBounds` instead "
    "of `ReadRoundedClipBounds if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->rounded_clip_bounds.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RRectFDataView>(
        pointer, output, message_);
  }
  inline void GetBackgroundColorDataView(
      ::skia::mojom::SkColor4fDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadBackgroundColor(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::skia::mojom::SkColor4fDataView, UserType>(),
    "Attempting to read the optional `background_color` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadBackgroundColor` instead "
    "of `ReadBackgroundColor if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->background_color.Get();
    return mojo::internal::Deserialize<::skia::mojom::SkColor4fDataView>(
        pointer, output, message_);
  }
  inline void GetClipRectDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadClipRect(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::gfx::mojom::RectDataView, UserType>(),
    "Attempting to read the optional `clip_rect` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with std::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadClipRect` instead "
    "of `ReadClipRect if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->clip_rect.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
 private:
  internal::WaylandOverlayConfig_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class TransformUnionDataView {
 public:
  using Tag = internal::TransformUnion_Data::TransformUnion_Tag;

  TransformUnionDataView() = default;

  TransformUnionDataView(
      internal::TransformUnion_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_overlay_transform() const { return data_->tag == Tag::kOverlayTransform; }
  template <typename UserType>
  [[nodiscard]] bool ReadOverlayTransform(UserType* output) const {
    CHECK(is_overlay_transform());
    return mojo::internal::Deserialize<::gfx::mojom::OverlayTransform>(
        data_->data.f_overlay_transform, output);
  }
  ::gfx::mojom::OverlayTransform overlay_transform() const {
    CHECK(is_overlay_transform());
    // TODO(dcheng): This seems incorrect, as it bypasses enum traits.
    return ::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::gfx::mojom::OverlayTransform>(data_->data.f_overlay_transform));
  }
  bool is_matrix_transform() const { return data_->tag == Tag::kMatrixTransform; }
  inline void GetMatrixTransformDataView(
      ::gfx::mojom::TransformDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadMatrixTransform(UserType* output) const {
    
    CHECK(is_matrix_transform());
    return mojo::internal::Deserialize<::gfx::mojom::TransformDataView>(
        data_->data.f_matrix_transform.Get(), output, message_);
  }

 private:
  internal::TransformUnion_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // wl::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::wl::mojom::WaylandOverlayConfigDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::wl::mojom::WaylandOverlayConfigDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::wl::mojom::internal::WaylandOverlayConfig_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->z_order = Traits::z_order(input);
    decltype(Traits::color_space(input)) in_color_space = Traits::color_space(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->color_space)::BaseType> color_space_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::ColorSpaceDataView>(
        in_color_space, color_space_fragment);
    fragment->color_space.Set(
        color_space_fragment.is_null() ? nullptr : color_space_fragment.data());
    decltype(Traits::transform(input)) in_transform = Traits::transform(input);
    mojo::internal::MessageFragment<decltype(fragment->transform)>
        transform_fragment(fragment.message());
    transform_fragment.Claim(&fragment->transform);
    mojo::internal::Serialize<::wl::mojom::TransformUnionDataView>(
        in_transform, transform_fragment, true);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->transform.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null transform in WaylandOverlayConfig struct");
    fragment->buffer_id = Traits::buffer_id(input);
    fragment->surface_scale_factor = Traits::surface_scale_factor(input);
    decltype(Traits::bounds_rect(input)) in_bounds_rect = Traits::bounds_rect(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->bounds_rect)::BaseType> bounds_rect_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectFDataView>(
        in_bounds_rect, bounds_rect_fragment);
    fragment->bounds_rect.Set(
        bounds_rect_fragment.is_null() ? nullptr : bounds_rect_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->bounds_rect.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null bounds_rect in WaylandOverlayConfig struct");
    decltype(Traits::crop_rect(input)) in_crop_rect = Traits::crop_rect(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->crop_rect)::BaseType> crop_rect_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectFDataView>(
        in_crop_rect, crop_rect_fragment);
    fragment->crop_rect.Set(
        crop_rect_fragment.is_null() ? nullptr : crop_rect_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->crop_rect.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null crop_rect in WaylandOverlayConfig struct");
    decltype(Traits::damage_region(input)) in_damage_region = Traits::damage_region(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->damage_region)::BaseType> damage_region_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_damage_region, damage_region_fragment);
    fragment->damage_region.Set(
        damage_region_fragment.is_null() ? nullptr : damage_region_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->damage_region.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null damage_region in WaylandOverlayConfig struct");
    fragment->enable_blend = Traits::enable_blend(input);
    fragment->opacity = Traits::opacity(input);
    decltype(Traits::access_fence_handle(input)) in_access_fence_handle = Traits::access_fence_handle(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->access_fence_handle)::BaseType> access_fence_handle_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::GpuFenceHandleDataView>(
        in_access_fence_handle, access_fence_handle_fragment);
    fragment->access_fence_handle.Set(
        access_fence_handle_fragment.is_null() ? nullptr : access_fence_handle_fragment.data());
    mojo::internal::Serialize<::gfx::mojom::OverlayPriorityHint>(
        Traits::priority_hint(input), &fragment->priority_hint);
    decltype(Traits::rounded_clip_bounds(input)) in_rounded_clip_bounds = Traits::rounded_clip_bounds(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->rounded_clip_bounds)::BaseType> rounded_clip_bounds_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RRectFDataView>(
        in_rounded_clip_bounds, rounded_clip_bounds_fragment);
    fragment->rounded_clip_bounds.Set(
        rounded_clip_bounds_fragment.is_null() ? nullptr : rounded_clip_bounds_fragment.data());
    decltype(Traits::background_color(input)) in_background_color = Traits::background_color(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->background_color)::BaseType> background_color_fragment(
            fragment.message());
    mojo::internal::Serialize<::skia::mojom::SkColor4fDataView>(
        in_background_color, background_color_fragment);
    fragment->background_color.Set(
        background_color_fragment.is_null() ? nullptr : background_color_fragment.data());
    decltype(Traits::clip_rect(input)) in_clip_rect = Traits::clip_rect(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->clip_rect)::BaseType> clip_rect_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_clip_rect, clip_rect_fragment);
    fragment->clip_rect.Set(
        clip_rect_fragment.is_null() ? nullptr : clip_rect_fragment.data());
  }

  static bool Deserialize(::wl::mojom::internal::WaylandOverlayConfig_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::wl::mojom::WaylandOverlayConfigDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::wl::mojom::TransformUnionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::wl::mojom::TransformUnionDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::wl::mojom::internal::TransformUnion_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::wl::mojom::TransformUnionDataView::Tag::kOverlayTransform: {
        decltype(Traits::overlay_transform(input))
            in_overlay_transform = Traits::overlay_transform(input);
        mojo::internal::Serialize<::gfx::mojom::OverlayTransform>(
            in_overlay_transform, &fragment->data.f_overlay_transform);
        break;
      }
      case ::wl::mojom::TransformUnionDataView::Tag::kMatrixTransform: {
        decltype(Traits::matrix_transform(input))
            in_matrix_transform = Traits::matrix_transform(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_matrix_transform)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::gfx::mojom::TransformDataView>(
            in_matrix_transform, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null matrix_transform in TransformUnion union");
        fragment->data.f_matrix_transform.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::wl::mojom::internal::TransformUnion_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::wl::mojom::TransformUnionDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace wl::mojom {

inline void WaylandOverlayConfigDataView::GetColorSpaceDataView(
    ::gfx::mojom::ColorSpaceDataView* output) {
  auto pointer = data_->color_space.Get();
  *output = ::gfx::mojom::ColorSpaceDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetTransformDataView(
    TransformUnionDataView* output) {
  auto pointer = &data_->transform;
  *output = TransformUnionDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetBoundsRectDataView(
    ::gfx::mojom::RectFDataView* output) {
  auto pointer = data_->bounds_rect.Get();
  *output = ::gfx::mojom::RectFDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetCropRectDataView(
    ::gfx::mojom::RectFDataView* output) {
  auto pointer = data_->crop_rect.Get();
  *output = ::gfx::mojom::RectFDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetDamageRegionDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->damage_region.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetAccessFenceHandleDataView(
    ::gfx::mojom::GpuFenceHandleDataView* output) {
  auto pointer = data_->access_fence_handle.Get();
  *output = ::gfx::mojom::GpuFenceHandleDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetRoundedClipBoundsDataView(
    ::gfx::mojom::RRectFDataView* output) {
  auto pointer = data_->rounded_clip_bounds.Get();
  *output = ::gfx::mojom::RRectFDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetBackgroundColorDataView(
    ::skia::mojom::SkColor4fDataView* output) {
  auto pointer = data_->background_color.Get();
  *output = ::skia::mojom::SkColor4fDataView(pointer, message_);
}
inline void WaylandOverlayConfigDataView::GetClipRectDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->clip_rect.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}


inline void TransformUnionDataView::GetMatrixTransformDataView(
    ::gfx::mojom::TransformDataView* output) const {
  CHECK(is_matrix_transform());
  *output = ::gfx::mojom::TransformDataView(data_->data.f_matrix_transform.Get(), message_);
}


}  // wl::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_OVERLAY_CONFIG_MOJOM_SHARED_H_